#include <bits/stdc++.h>
using namespace std;
#define endl "\n"
typedef long long ll;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
const ll MAX_N = 1e5 + 10;
ll arr[MAX_N], pref[MAX_N];
ll n, q, a;
ll other[MAX_N];
ll solve(ll r) {
    for(ll i = 0; i < n; i ++) {
        other[i] = arr[i] * (a + i - r) + pref[i]; 
    }
    sort(other, other + n);
    ll ret = 0;
    for(ll i = 0; i < r; i ++) {
        ret += other[i];
    }
    return ret;
}
struct line {
    ll m, b, ind;
    
    ll eval(ll x) const {
        return m * x + b; 
    }
};
ll when(const line &a, const line &b) {
    assert(a.eval(0) <= b.eval(0));	
    if(a.m == b.m) {
        return MAX_N - 1;
    }
    return (b.b - a.b) / (a.m - b.m) + 1;	
}
line lines[MAX_N];
ll where[MAX_N];
vector<pair<int, int> > to_swap[MAX_N];
ll ans[MAX_N];
line lines_pref[MAX_N];

ostream &operator <<(ostream &out, const line &l) {
    return out << "{" << l.m << "*x+" << l.b << "; at " << l.ind << "}"; 
}

void hard_swap(int a, int b) {
	lines_pref[a].m -= lines[a].m - lines[b].m; 
	lines_pref[a].b -= lines[a].b - lines[b].b; 
	swap(where[lines[b].ind], where[lines[a].ind]);
	swap(lines[b], lines[a]);
}
signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    
    cin >> n >> q >> a;
       for(ll i = 0; i < n; i ++) {
        cin >> arr[i];
    }
    for(ll i = 0; i < n; i ++) {
        pref[i] = arr[i] + ((i != 0) ? pref[i - 1] : 0);
        lines[i] = {-arr[i], arr[i] * (i + a) + pref[i], i};
    }
    sort(lines, lines + n, [&](const auto &a, const auto &b) {
        return a.eval(0) < b.eval(0);
    });
    for(ll i = 0; i < n; i ++) {
        for(ll j = i + 1; j < n; j ++) {
            const auto x = when(lines[i], lines[j]);
            if(x < 0 || x > MAX_N - 1) continue; 
            to_swap[x].push_back({lines[i].ind, lines[j].ind});	
        }
    }
    for(ll i = 0; i < n; i ++) {
        where[lines[i].ind] = i;
        lines_pref[i] = lines[i];
        if(i != 0) {
            lines_pref[i].m += lines_pref[i - 1].m;
            lines_pref[i].b += lines_pref[i - 1].b;
        }
    }
    
    for(ll i = 1; i <= n; i ++) {
        for(const auto &it : to_swap[i]) {
			if(where[it.first] < where[it.second]) {
				hard_swap(where[it.first], where[it.second]); 
			}
		}
        ans[i] = lines_pref[i - 1].eval(i);
    }
    while(q --) {
        ll r;
        cin >> r;
        cout << ans[r] << endl;
    }
    return 0;
}
