// Sega produlzhavame s nai hitoviq kiuchek ot djodji bend specialno za vsichki romi
// Kuicheka konya vihyr 2012
// Novata modifikaciq
// Aide Chochko
// Aide Vihyre
// Vlez
// Vlez Vihyre

#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

llong ans;
llong q, r, c;
llong a[MAXN], n;

void cycleShift(int from, int to)
{
	int first = a[from];
	for (int i = from ; i < to ; ++i)
	{
		a[i] = a[i + 1];
	}

	a[to] = first;
}

void solve()
{
	for (int i = 1 ; i <= r ; ++i) ans += c * a[i];
	if (r == n)
	{
		std::cout << ans << '\n';
		return;
	}

	while (true)
	{
		llong sum = a[r];
		llong curr = 0;
		int idx = -1;

		for (int i = r + 1 ; i <= n ; ++i)
		{
			if (curr > (c + i - r) * a[i] + sum - c * a[r])
			{
				curr = (c + i - r) * a[i] + sum - c * a[r];	
				idx = i;
			}

			sum += a[i];
		}

		sum = a[r + 1];
		for (int i = r ; i >= 1 ; --i)
		{
			if (curr > (r - i + 1 - c) * a[i] + sum + c * a[r + 1])
			{
				curr = (r - i + 1 - c) * a[i] + sum + c * a[r + 1];	
				idx = i;
			}

			sum += a[i];
		}

		if (idx == -1) break;
		if (r < idx) cycleShift(r, idx);
		else cycleShift(idx, r + 1);
		ans += curr;
	}

	std::cout << ans << '\n';
}

void read()
{
	std::cin >> n >> q >> c;
	for (int i = 1 ; i <= n ; ++i)
	{
		std::cin >> a[i];
	}

	std::cin >> r;
}

void fastIOI()
{
	std::ios_base :: sync_with_stdio(0);
	std::cout.tie(nullptr);
	std::cin.tie(nullptr);
}

int main()
{
	fastIOI();
	read();
	solve();

	return 0;
}