// Sega produlzhavame s nai hitoviq kiuchek ot djodji bend specialno za vsichki romi
// Kuicheka konya vihyr 2012
// Novata modifikaciq
// Aide Chochko
// Aide Vihyre
// Vlez
// Vlez Vihyre

#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const llong INF  = 1e18;

llong ans;
llong q, r, c;
llong a[MAXN], n;

void cycleShift(int from, int to)
{
	int first = a[from];
	for (int i = from ; i < to ; ++i)
	{
		a[i] = a[i + 1];
	}

	a[to] = first;
}

void solve()
{
	for (int i = 1 ; i <= r ; ++i) ans += c * a[i];
	if (r == n)
	{
		std::cout << ans << '\n';
		return;
	}

	while (true)
	{
		llong sum = 0;
		llong currLeft = INF;
		llong currRight = INF;
		int idx1 = -1;
		int idx2 = -1;

		for (int i = r ; i >= 1 ; --i)
		{
			if (currLeft > (r - i + 1 - c) * a[i] + sum)
			{
				currLeft = (r - i + 1 - c) * a[i] + sum;	
				idx1 = i;
			}

			sum += a[i];
		}

		sum = 0;
		for (int i = r + 1 ; i <= n ; ++i)
		{
			if (currRight > (i - r + c) * a[i] + sum)
			{
				currRight = (i - r + c) * a[i] + sum;	
				idx2 = i;
			}

			sum += a[i];
		}

		if (currLeft + currRight >= 0) break;
		cycleShift(idx1, r);
		cycleShift(r, idx2);
		ans += currLeft + currRight;
	}

	std::cout << ans << '\n';
}

void read()
{
	std::cin >> n >> q >> c;
	for (int i = 1 ; i <= n ; ++i)
	{
		std::cin >> a[i];
	}

	std::cin >> r;
}

void fastIOI()
{
	std::ios_base :: sync_with_stdio(0);
	std::cout.tie(nullptr);
	std::cin.tie(nullptr);
}

int main()
{
	fastIOI();
	read();
	solve();

	return 0;
}