#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 5e4 + 10, block_size = 5000;
const ll inf = 1e18;

struct line
{
    ll k, m;

    line(ll _k = 0, ll _m = 0)
    {
        k = _k;
        m = _m;
    }

    inline ll calc(ll x)
    {
        return k * x + m;
    }
};


vector < line > g[maxn];
int n, q;
ll A, a[maxn], pref[maxn], to_get[maxn];

line pref_block[maxn / block_size][block_size + 10];

bool cmp(line l1, line l2)
{
    return (l1.m > l2.m);
}
void calc_pref(int idx)
{
    sort(g[idx].begin(), g[idx].end(), cmp);
    for (int i = (int)(g[idx].size()) - 1; i >= 0; i --)
    {
        pref_block[idx][i] = pref_block[idx][i + 1];
        pref_block[idx][i].k += g[idx][i].k;
        pref_block[idx][i].m += g[idx][i].m;
    }

}


int bl_cnt[maxn];
void sort_block(int idx, ll x)
{
    /**if (bl_cnt[idx] > g[idx].size() * g[idx].size())
    {
        cout << 1 / 0 << endl;
        exit(0);
    }*/
    /**cout << "-------" << endl;
    cout << "block " << idx << endl;
        for (int i = (int)(g[idx].size()) - 1; i >= 0; i --)
    {
        cout << pref_block[idx][i].k << " " << pref_block[idx][i].m << endl;
    }*/

    for (int i = (int)(g[idx].size()) - 1; i >= 0; i --)
    {
        int j = i;
        while(j + 1 < g[idx].size() && g[idx][j].calc(x) < g[idx][j + 1].calc(x))
        {
            //pref_block[idx][j + 1].k -= (g[idx][j + 1].k - g[idx][j].k);
            //pref_block[idx][j + 1].m -= (g[idx][j + 1].m - g[idx][j].m);
            //swap(g[idx][j], g[idx][j + 1]);
            j ++;
        }
    }
    /**for (int i = (int)(g[idx].size()) - 1; i >= 0; i --)
    {
        cout << pref_block[idx][i].k << " " << pref_block[idx][i].m << endl;
    }
    cout << "--------------" << endl;*/
}


ll get_cnt(int idx, ll x, ll to)
{
    int lf = 0, rf = (int)(g[idx].size()) - 1;
    while(lf <= rf)
    {
        int mf = (lf + rf) / 2;
        if (g[idx][mf].calc(x) > to)
            lf = mf + 1;
        else
            rf = mf - 1;
    }

    return (g[idx].size() - lf);
}


ll get_sum(int idx, ll x, ll to)
{
    int lf = 0, rf = (int)(g[idx].size()) - 1;
    while(lf <= rf)
    {
        int mf = (lf + rf) / 2;
        if (g[idx][mf].calc(x) > to)
            lf = mf + 1;
        else
            rf = mf - 1;
    }
   /** cout << g[idx].size() << " " << lf << endl;
    for (int i = 0; i < g[idx].size(); i ++)
        cout << g[idx][i].k << " " << g[idx][i].m << endl;
    cout << pref_block[idx][lf].k << " :: " << pref_block[idx][lf].m << endl;*/
    return pref_block[idx][lf].k * x + pref_block[idx][lf].m;
}
void solve()
{
    cin >> n >> q >> A;
   /// int a
    for (int i = 1; i <= n; i ++)
    {

     cin >> a[i];
      ///a[i] = rand() % (int)(1e9);
        pref[i] = pref[i - 1] + a[i];
    }

    int mbl = 0;
    for (int i = 1; i <= n; i ++)
    {
        g[i / block_size + 1].push_back(line(- a[i], + (A + i) * a[i] + pref[i - 1]));
        mbl = max(mbl, i / block_size + 1);
    }

    for (int i = 1; i <= mbl; i ++)
        calc_pref(i);
    vector < pair < ll, int > > ask;
    for (int t = 1; t <= q; t ++)
    {
        ll R;
        cin >> R;
        ask.push_back({R, t});
    }
    sort(ask.begin(), ask.end());

    /**for (int i = 1; i <= mbl; i ++)
    {
        //cout << "block " << i << endl;
        //for (int j = 0; j < g[i].size(); j ++)
           // cout << g[i][j].k << " " << g[i][j].m << endl;
    }*/
    for (int t = 0; t < q; t ++)
    {
        ll R = ask[t].first;
        for (int i = 1; i <= mbl; i ++)
            sort_block(i, R);

        ll lf = 0, rf = inf;
        while(lf <= rf)
        {
            ll mf = (lf + rf) / 2, s = 0;
            ///cout << lf << " " << rf << endl;
            for (int i = 1; i <= mbl; i ++)
                s = s + get_cnt(i, R, mf);
            if (s >= R)
                rf = mf - 1;
            else
                lf = mf + 1;
        }

        ll ans = 0, s = 0;
        ///cout << "here" << endl;
        for (int i = 1; i <= mbl; i ++)
        {
            ///cout << "get sum " << endl;
            ans = ans + get_sum(i, R, lf);
            ///cout << "get cnt" << endl;
            s = s + get_cnt(i, R, lf);
        }


        if (s > R)
            ans = ans - (s - R) * lf;
        to_get[ask[t].second] = ans;


    }

    for (int i = 1; i <= q; i ++)
        cout << to_get[i] << endl;


}

int main()
{
    solve();
    return 0;
}
/**
4 1 6
4 1 2 3
2
*/
