#include<iostream>
#include<algorithm>
#define endl "\n"
using namespace std;

int const MAXN=1001;
long long n, k, l[MAXN], r[MAXN], p[MAXN], last[MAXN], used[MAXN];
long long minn = 4*(1e18)+7;

void perm(int pos, long long ans)
{
    if(pos > n)
    {
        if(ans < minn) minn = ans;
        return;
    }
    else
    {
        for(int i=1; i<=k; i++)
        {
            if(used[i-1])
            {
                if(!used[i])
                {
                    p[pos] = i;
                    last[i] = r[pos];
                    used[i]++;
                    perm(pos+1, ans);
                    used[i]--;
                }
                else
                {
                    p[pos] = i;
                    long long past = last[i];
                    last[i] = r[pos];
                    used[i]++;
                    ans += abs(past - l[pos]);
                    if(ans < minn) perm(pos+1, ans);
                    ans -= abs(past - l[pos]);
                    last[i] = past;
                    used[i]--;
                }
            }
        }
    }
}

void read()
{
    cin>>n>>k;
    for(int i=1; i<=n; i++)
    {
        cin>>l[i]>>r[i];
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    used[0] = 1;
    perm(1, 0);
    cout<<minn<<endl;
    return 0;
}
/*
6 3
5 100
8 100
100 200
200 30
500 200
500 70

4 2
5 20
170 90
55 450
90 10
*/
