#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=1e4+6;
ll n,q,a;
ll v[MAXN];
vector<ll>best_order;
ll best_val=-1;
struct BIT
{
	ll tree[MAXN];
	void init()
	{
		memset(tree,0,sizeof(tree));
	}
	void update(ll idx,ll val)
	{
		for(;idx<MAXN;idx+=idx&(-idx))
		{
			tree[idx]+=val;
		}
	} 
	ll query(ll idx)
	{
		ll ret=0;
		for(;idx>0;idx-=idx&(-idx))
		{
			ret+=tree[idx];
		}
		return ret;
	}
}fen;
ll calc_perm(vector<ll>order,ll r)
{
	ll cur_val=0;
	for(ll i=0;i<r;i++)cur_val+=v[order[i]];
	cur_val*=a;
	fen.init();
	//for(ll i=0;i<order.size();i++)cout<<order[i]<<" ";
	//cout<<endl;
	for(ll i=0;i<n;i++)
	{
		ll cnt1=fen.query(n-order[i]+1);
		cur_val+=cnt1*v[order[i]];
		//cout<<order[i]<<" "<<cnt1<<endl;
		fen.update(n-order[i]+1,1); 
	}
	fen.init();
	for(ll i=n-1;i>=0;i--)
	{
		ll cnt1=fen.query(order[i]);
		cur_val+=cnt1*v[order[i]];
		//cout<<order[i]<<" "<<cnt1<<endl;
		fen.update(order[i],1); 
	}
	//cout<<cur_val<<endl;
	return cur_val;
	/*for(ll i=0;i<n;i++)
	{
		for(ll j=i-1;j>=0;j--)
		{
			if(order[j]>order[i])cur_val+=v[order[i]];
		}
		for(ll j=i+1;j<n;j++)
		{
			if(order[j]<order[i])cur_val+=v[order[i]];
		}
	}
	return cur_val;*/
}
void solve(ll r)
{
	vector<ll>order;
	for(ll i=1;i<=n;i++)best_val+=v[i];
	best_val*=a;
	for(ll i=1;i<=n;i++)order.push_back(i);
	best_order=order;
	do
	{
		ll cur_val=0;
		for(ll i=0;i<r;i++)cur_val+=v[order[i]];
		cur_val*=a;
		for(ll i=0;i<n;i++)
		{
			for(ll j=i-1;j>=0;j--)
			{
				if(order[j]>order[i])cur_val+=v[order[i]];
			}
			for(ll j=i+1;j<n;j++)
			{
				if(order[j]<order[i])cur_val+=v[order[i]];
			}
		}
		if(cur_val<best_val)
		{
			best_order=order;
			best_val=cur_val;
		}
	}while(next_permutation(order.begin(),order.end()));
	cout<<best_val<<endl;
	for(ll i=0;i<n;i++)
	{
		cout<<v[best_order[i]]<<" ";
	}
	cout<<endl;
}
struct chislo
{
	ll ind,val;
};
ll pref[MAXN];
bool cmp(chislo c1,chislo c2)
{
	if(c1.ind<c2.ind&&c1.val<c2.val)return 1;
	if(c1.ind>c2.ind&&c1.val>c2.val)return 0;
	if(c1.ind<c2.ind)
	{
		ll cost_swaps=pref[c2.ind-1]-pref[c1.ind]+c1.val+(c2.ind-c1.ind)*c2.val;
		ll delta=a*(c2.val-c1.val);
		if(cost_swaps+delta<0)return 0;
		else return 1;
	}
	else
	{
		ll cost_swaps=pref[c1.ind-1]-pref[c2.ind]+c2.val+(c1.ind-c2.ind)*c1.val;
		ll delta=a*(c1.val-c2.val);
		if(cost_swaps+delta<0)return 1;
		else return 0;
	}
}
vector<chislo>oh_outside,oh_inside;
bool inside[MAXN];
bool added[MAXN];
bool removed[MAXN];
ll cnt_swaps[MAXN];
int main()
{
	cin>>n>>q>>a;
	for(ll i=1;i<=n;i++)
	{
		cin>>v[i];
		pref[i]=pref[i-1]+v[i];
		
	}
	ll r;
	cin>>r;
	for(ll i=1;i<=r;i++)oh_inside.push_back({i,v[i]});
	for(ll i=r+1;i<=n;i++)oh_outside.push_back({i,v[i]});
	sort(oh_inside.rbegin(),oh_inside.rend(),cmp);
	sort(oh_outside.begin(),oh_outside.end(),cmp);
	ll prvval=-1;
	for(ll j=0;j<=min(oh_inside.size(),oh_outside.size());j++)
	{
		for(ll i=0;i<n;i++)inside[i]=0;
		for(ll i=j;i<oh_inside.size();i++)inside[oh_inside[i].ind]=1;
		for(ll i=0;i<j;i++)inside[oh_outside[i].ind]=1;
		vector<ll>order;
		for(ll i=1;i<=n;i++)
		{
			if(inside[i])order.push_back(i);
		}
		for(ll i=1;i<=n;i++)
		{
			if(!inside[i])order.push_back(i);
		}
		ll cur_val=calc_perm(order,r);
		/*cout<<cur_val<<" :\n";
		for(auto xd:order)cout<<xd<<" ";
		cout<<endl;*/
		if(cur_val<best_val||best_val==-1)
		{
			best_val=cur_val;
		}
		//if(prvval!=-1)cout<<cur_val-prvval<<" ";
		/*if(j!=0)
		{
			ll id_to_be_removed=oh_inside[j-1].ind;
			ll id_to_be_added=oh_outside[j-1].ind;
			cout<<v[id_to_be_removed]<<" "<<v[id_to_be_added]<<endl;
			ll delta=0,cnt1r=0,cnt2l=0;
			for(ll i=0;i<j-1;i++)
			{
				if(oh_inside[i].ind>id_to_be_removed)
				{
					delta+=oh_inside[i].val;
					delta-=oh_inside[j].val;
				}
			}
			
			for(ll i=0;i<j-1;i++)
			{
				if(oh_outside[i].ind<id_to_be_added)
				{
					delta+=oh_outside[i].val;
					delta-=oh_outside[j].val;
				}
			}
			delta+=v[id_to_be_removed]*(r-id_to_be_removed+j);
			delta+=v[id_to_be_added]*(id_to_be_added-r+j);
			//delta+=(v[id_to_be_added]+v[id_to_be_removed])*j;
			delta+=(v[id_to_be_added]-v[id_to_be_removed])*a;
			cout<<delta<<endl;
		}*/
		//prvval=cur_val;
	}
	cout<<best_val<<endl;
	/*cin>>r;
	vector<ll>order;
	for(ll i=1;i<=n;i++)best_val+=v[i];
	best_val*=a;
	for(ll i=1;i<=n;i++)order.push_back(i);
	best_order=order;
	do
	{
		ll cur_val=0;
		for(ll i=0;i<r;i++)cur_val+=v[order[i]];
		cur_val*=a;
		for(ll i=0;i<n;i++)
		{
			for(ll j=i-1;j>=0;j--)
			{
				if(order[j]>order[i])cur_val+=v[order[i]];
			}
			for(ll j=i+1;j<n;j++)
			{
				if(order[j]<order[i])cur_val+=v[order[i]];
			}
		}
		if(cur_val<best_val)
		{
			best_order=order;
			best_val=cur_val;
		}
	}while(next_permutation(order.begin(),order.end()));
	cout<<best_val<<endl;
	for(ll i=0;i<n;i++)
	{
		cout<<v[best_order[i]]<<" ";
	}
	cout<<endl;*/
return 0;
}
