#include<bits/stdc++.h>
#define pb push_back
#define fr first
#define sc second
#define ll long long
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl; 
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 5e3 + 3;

ll N, Q, A, v[MAXN], R, prefix[MAXN];
tuple<ll, ll, ll> dp[MAXN][MAXN];

void init(){
	for(int i = 0; i < MAXN; i ++) for(int j = 0; j < MAXN; j ++){
		dp[i][j] = {1e13, 1e13, 1e13};
	}
}


int main(){
	init();
	cin >> N >> Q >> A;
	for(int i = 1; i <= N; i ++){
		cin >> v[i];
	}
	v[N + 1] = 1e7;
	for(int i = 1; i <= N; i ++){
		prefix[i] = prefix[i - 1] + v[i];
	}
	cin >> R;
	for(int i = 1; i <= N + 1; i ++){ /// to be marked
		for(int used = 0; used <= R; used ++){ /// used till now, without i
			dp[i][used] = min(dp[i][used], {get<0>(dp[i - 1][used]), get<1>(dp[i - 1][used]) + v[i], get<2>(dp[i - 1][used]) + 1});
			if(used){
				ll cost = get<0>(dp[i - 1][used - 1]);
				ll sum  = get<1>(dp[i - 1][used - 1]);
				ll cnt  = get<2>(dp[i - 1][used - 1]);
				dp[i][used] = min(dp[i][used], {cost + A * v[i] + (sum ? sum + cnt * v[i] : 0), sum, cnt});
			}
			else{
				dp[i][used] = {A * v[i] + (prefix[i - 1] ? prefix[i - 1] + (i - 1) * v[i] : 0), prefix[i - 1], i - 1};
			}
		}
	}
	/**
	for(int i = 1; i <= N + 1; i ++){
		for(int j = 0; j <= R; j ++){
			cout << "(" << get<0>(dp[i][j]) << ", " << get<1>(dp[i][j]) << ", " << get<2>(dp[i][j]) << ") ";
		}
		cout << endl;
	}
	*/
	cout << get<0>(dp[N][R - 1]) << endl;
}