#include <iostream>
#include <iomanip>
#define endl '\n'
using namespace std;

int n, l, r;
long double p, ans;

void rec(string s, long double prob)
{
    if (s.size() > 15) return;
    ans += prob * p * (s.size() + 1);
    for (int i = 1; i < s.size(); ++ i)
    {
        if (s[i - 1] == 'b' and s[i] != 'a')
        {
            string s1 = s.substr(0, i) + "aA" + s.substr(i, s.size() - i);
            rec(s1, prob * p * p);
        }
        else if (s[i - 1] == 'a' and s[i] != 'b')
        {
            string s1 = s.substr(0, i) + "bB" + s.substr(i, s.size() - i);
            rec(s1, prob * (1 - p) * (1 - p));
        }
        else if (s[i - 1] == 'B' and s[i] != 'b')
        {
            string s1 = s.substr(0, i) + "bB" + s.substr(i, s.size() - i);
            rec(s1, prob * (1 - p) * (1 - p));
        }
        else if (s[i - 1] == 'A' and s[i] != 'a')
        {
            string s1 = s.substr(0, i) + "aA" + s.substr(i, s.size() - i);
            rec(s1, prob * p * p);
        }
    }
    if (s[s.size() - 1] == 'A')
    {
        string s1 = s + "aA";
        rec(s1, prob * p * p);
    }
    else
    {
        string s1 = s + "bB";
        rec(s1, prob * (1 - p) * (1 - p));
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> p >> n >> l >> r;

    ans = p;
    rec("bB", (1 - p) * (1 - p));

    long double EL = ans;

    p = 1 - p;
    ans = p;
    rec("bB", (1 - p) * (1 - p));

    long double ER = ans;

    cout << fixed << setprecision(12) << (n - l) * EL + (n - r) * ER << endl;

    return 0;
}
