#include <iostream>
#include <cstring>
#include <cmath>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 22;

int n, k;
int a[MAXN + 5], b[MAXN + 5];
map< pair<int, int>, int > mem;

long long rec(int i, int cnt, int mask)
{
    if (mem[{i, mask}]) return mem[{i, mask}];
    if (cnt > n - k) return (1e18);
    if (cnt + (n - i) < n - k) return (1e18);
    if (i == n)
    {
        if (cnt != n - k) return (1e18);
        return 0;
    }

    long long ret = rec(i + 1, cnt, mask);
    for (int j = i + 1; j <= n; ++ j)
    {
        if (!((1ll << (j - 1)) & mask))
        {
            ret = min(ret, (long long)(abs(b[i] - a[j])) + rec(i + 1, cnt + 1, (mask | (1ll << (j - 1)))));
        }
    }
    mem[{i, mask}] = ret;
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i] >> b[i];
    }

    cout << rec(1, 0, 0) << endl;

    return 0;
}
