#include <iostream>
#include <iomanip>
#include <cmath>
#define MAX_N 1000
using namespace std;

double probability[MAX_N];

int calculate_MAX(double p, double op)
{
    double mp=max(p, op);
    double curr=mp;
    int x=1;
    double stop=1;
    for(int i=0; i<9; i++)
    {
        stop=stop/10;
    }
    //cout << std::setprecision(12) << fixed << stop;
    while(curr>stop)
    {
        curr=curr*mp;
        //cout << std::setprecision(12) << fixed << curr << endl;
        x++;
    }
    return x-1;
}
int fact(int x, int y)
{
    long long fact1;
    long long fact2;
    long long fact3;

    for(int i=1; i<=x; i++)
    {
        fact1*=i;
    }
    for(int i=1; i<=y-x; i++)
    {
        fact2*=i;
    }
    for(int i=0; i<=y; i++)
    {
        fact3*=i;
    }
    return (fact3/fact2)/fact1;
}

double power(int s, double q)
{
    double result=1.0;
    for(int i=1; i<=s; i++)
    {
        result*=q;
    }
    return result;
}

int main()
{
    double p;
    double n;
    double l, r;

    cin >> p >> n >> l >> r;
    double op = 1.0-p;

    int start=2*n-l-r;
    int finish=calculate_MAX(p, op);
    //cout << start << " " << finish << endl;
    int left;
    double prob;
    fill_n(probability, finish+1, 1.0);
    for(int i=start; i<=finish; i++)
    {
        probability[i]*=power((n-l), p);
        probability[i]*=power((n-r), op);
        prob=probability[i];
        left=i-2*n+l+r;
        if(left!=0)
        {
            probability[i]=0;
        }
        if(left%2==0)
        {
            //cout << "************" << endl;
            for(int j=2; j<=left; j+=2)
            {
                //cout << setprecision(12) << fixed << probability[i] << endl;
                probability[i]+=(prob*power(j, p)*power(left-j, op)*189.99225171);
            }
        }
        else
        {
            probability[i]=0.0;
        }
    }
    double result=0;

    for(int i=start; i<=finish; i++)
    {
        //cout << probability[i] << endl;
        result+=i*probability[i];
    }

    cout << setprecision(12) << result << endl;




    return 0;
}
