#include <iostream>
#include <vector>
#include <climits>
#define MAX_K 30
using namespace std;

int lifts[MAX_K];
vector <pair<int, int>> order;
int n, k;
long long minans=LONG_MAX;
long long curr=0;
long long p;

void recursia(int index, long long curr)
{
    //cout << index << " " << curr << endl;
    if(index>=n)
    {
        //cout << "###" << minans << endl;
        if(minans>curr)
        {
            //cout << minans << endl;
            minans=curr;
        }
        return;
    }
    if(curr>minans)
    {
        return;
    }
    for(int i=0; i<k; i++)
    {
        if(lifts[i]==0)
        {

            lifts[i]=order[index].second;
            index++;
            recursia(index, curr);
            index--;
            lifts[i]=0;
        }
        else
        {
            int ceeplast=lifts[i];
            //cout << index << "^^^^^^" << order[index].first << " " << lifts[i] << endl;
            p=(max(order[index].first,lifts[i])-min(order[index].first,lifts[i]));
            lifts[i]=order[index].second;
            index++;
            recursia(index, curr+p);
            index--;
            lifts[i]=ceeplast;

        }
    }
    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    order.resize(n);
    int a, b;

    for(int i=0; i<n; i++)
    {
        cin >> a >> b;
        order[i]={a, b};
    }
    /*for(int i=0; i<n; i++)
    {
        cout << order[i].first << " " << order[i].second << endl;
    }*/
    recursia(0, 0);
    cout << minans;




    return 0;
}

