#include <bits/stdc++.h>
using namespace std;

#define all(x) x.begin(), x.end()
#define dbg(x) cout << #x << " " << x << endl;
#define sz(x) (int)x.size()

const long long inf = 1e18;
long long n, q, A; 

void print(vector<long long>& a) {
  cout << "[ ";
  for(auto i: a) {
    cout << i << " ";
  }
  cout << "]";
  cout << endl;
}

int main() {
  cin >> n >> q >> A;
  vector<long long> a(n), b(n);
  set<pair<long long, long long>> st;
  long long for_all = 0;
  for(int i = 0; i < n; i++) {
    cin >> a[i], b[i] = a[i];
    st.insert({i, a[i]});
    for_all += a[i];
  }
  sort(all(a));

  int query; cin >> query;

  if(query == n) {
    cout << for_all * A << endl;
    return 0;
  }

  long long current = n, sum = for_all;
  for(int i = 0; i < n; i++) {
    long long s = 0, costik = inf, cnt = 0, ind = -1, val = -1;
    for(auto j = st.rbegin(); j != st.rend(); j = next(j)) {
      long long cost = j->second * cnt + s + (sum - j->second) * A;
      if(cost < costik) {
        costik = cost;
        ind = j->first;
        val = j->second;
      }

      cnt++;
      s += j->second;
    }

    st.erase({ind, val});
    sum -= val;
    current--;
    if(current == query) {
      cout << costik << endl;
      return 0;
    }
  }

  assert(false);
  return 0;
}