#include <bits/stdc++.h>
using namespace std;

#define all(x) x.begin(), x.end()
#define dbg(x) cout << #x << " " << x << endl;
#define sz(x) (int)x.size()


void print(vector<long long>& a) {
  cout << "[ ";
  for(auto i: a) {
    cout << i << " ";
  }
  cout << "]";
  cout << endl;
}

const long long inf = 1e9;
// const int N = 1 << 22;
int n, k;
vector<pair<long long, long long>> queries;
map<pair<int, int>, long long> mp;

long long solve(long long mask, int k_s) {
  if(mp.find({mask, k_s}) != mp.end()) {
    return mp[{mask, k_s}];
  }

  vector<int> indices;
  for(int i = 0; i < n; i++) {
    if(!(mask & (1 << i))) {
      indices.push_back(i);
    }
  }

  if(indices.empty()) {
    return 0;
  }

  if(k_s == 0) {
    return inf;
  }

  int lim = sz(indices) - k_s + 1;
  vector<bool> curr(sz(indices), true);
  long long answ = inf;
  for(int i = 0; i <= lim; i++) {
    sort(all(curr));
    if(i) curr[i - 1] = false;  

    do {
      int new_mask = mask, last = -1;
      long long to_add = 0;

      for(int j = 0; j < sz(indices); j++) {
        if(curr[j]) {
          new_mask |= (1 << indices[j]);
          if(last != -1) {
            to_add += abs(queries[indices[j]].first - queries[last].second);
          }
          last = indices[j];
        }
      }

      answ = min(answ, to_add + solve(new_mask, k_s - 1));
    } while(next_permutation(all(curr)));
  }

  mp[{mask, k_s}] = answ;
  return answ;
}

int main() {
  cin >> n >> k;

  for(int i = 0; i < n; i++){
    long long l, r; cin >> l >> r;
    queries.push_back({l, r});
  }

  cout << solve(0, k) << endl;
  return 0;
}