#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <vector>
using namespace std;
#define ll long long
#define ld long double
#define pii pair<int, int>

const int N = 1502;

ld p;
int l, r, n;

ld cl[N], pl[N];
ld cr[N], pr[N];

ld powP[N];

void calcPref(ld p) {
    powP[0] = 1;
    for (int i = 1; i <= n + 1; i++) {
        powP[i] = powP[i - 1] * p;
    }
    cl[0] = (ld)2 / p;
    pl[0] = cl[0];
    for (int i = 1; i <= n; i++) {
        ld val = 0;
        for (int j = i - 1; j >= 0; j--) {
            val += (-p + 1) * powP[i - 1 - j] * (pl[i - 1] - pl[j] + i - j);
        }
        val += powP[i] * (pl[i - 1] + i + 1);
        val *= (-p + 1);
        val += 1;
        val /= p;
        cl[i] = val;
        pl[i] = pl[i - 1] + cl[i];
    }
}

void calcPref2(ld p) {
    powP[0] = 1;
    for (int i = 1; i <= n + 1; i++) {
        powP[i] = powP[i - 1] * p;
    }
    cr[0] = (ld)2 / p;
    pr[0] = cr[0];
    for (int i = 1; i <= n; i++) {
        ld val = 0;
        for (int j = i - 1; j >= 0; j--) {
            val += (-p + 1) * powP[i - 1 - j] * (pr[i - 1] - pr[j] + i - j);
        }
        val += powP[i] * (pr[i - 1] + i + 1);
        val *= (-p + 1);
        val += 1;
        val /= p;
        cr[i] = val;
        pr[i] = pr[i - 1] + cr[i];
    }
}

int main() {
    cout.precision(12);
    cin >> p >> n >> l >> r;
    if (l > r) {
        swap(l, r);
        p = 1 - p;
    }
    calcPref(p);
    calcPref2(1 - p);
    ld ans = 0;
    if (l > 0)
        ans += pl[r - 1] - pl[l - 1];
    else
        ans = pl[r - 1];
    l = r;
    cout << ans << endl;
    for (int i = r; i < n; i++) {
        ld val = 1;
        val += p * cr[i];
        val += (-p + 1) * cl[i];
        ans += val;
    }
    cout << ans << endl;
    return 0;
}