#include <bits/stdc++.h>

using namespace std;

vector<int> par, sizes;

int get_par(int u){
    if(par[u] == u) return u;
    return par[u] = get_par(par[u]);
}

void union_sets(int u, int v){
    int a = get_par(u), b = get_par(v);
    if(a == b) return;
    if(sizes[a] < sizes[b]) swap(a, b);
    par[b] = a;
    sizes[a] += sizes[b];
}

int main(){
    int n, k; cin >> n >> k;
    vector<pair<int, int>> vp(n);
    par = sizes =vector<int> (n);
    for(int i = 0; i < n;i++) par[i] = i, sizes[i] = 1;
    for(int i = 0; i < n; i++) cin >> vp[i].first >> vp[i].second;
    vector<tuple<long long, int, int>> vtp;
    for(int i =0 ; i < n; i++){
        for(int j = i + 1; j < n ;j++){
            vtp.push_back({abs(vp[j].first - vp[i].second), i, j});
        }
    }
    sort(vtp.rbegin(), vtp.rend());
    int cur = n;
    long long ans = 0;
    while(cur > k){
        int dist = get<0>(vtp.back()), u = get<1>(vtp.back()), v = get<2>(vtp.back());
        if(get_par(u) != get_par(v)){
            cur--;
            union_sets(u, v);
            ans += dist;
        }
        vtp.pop_back();
    }
    cout << ans << endl;
}
