#include<bits/stdc++.h>
#define ll long long
#define pii pair<int, int>
#define piii pair<pii, int>
#define size(v) v.size()
#define all(v) v.begin(), v.end()
#define INF 1e18
#define f first
#define s second

using namespace std;

/*const int up = 1e6 + 5;

ll st[up << 2], lazy[up << 2];

void build(int node, int l, int r, vector<int>&a){
    if(l == r){
        st[node] = a[l];
    }else{
        int mid = (l + r) >> 1;
        build(node << 1, l, mid, a);
        build((node << 1) | 1, mid + 1, r, a);
        st[node] = st[node << 1] + st[(node << 1) | 1];
    }
}

void relax(int node, int l, int r){
    if(l != r){
        lazy[node << 1] += 1ll * ((r - l) / 2) * lazy[node];
        lazy[(node << 1) | 1] += 1ll * ((r - l - 2) / 2) * lazy[node];
    }
    st[node] += (r - l + 1) * lazy[node];
    lazy[node] = 0;
}

void update(int node, int l, int r, int ul, int ur, int inc){
    if(r < ul || ur < l) return;
    if(lazy[node]){
        relax(node, l, r);
    }if(ul <= l && r <= ur){
        lazy[node] += (r - l + 1) * inc;
        relax(node, l, r);
    }else{
        int mid = (l + r) >> 1;
        update(node << 1, l, mid, ul, ur, inc);
        update((node << 1) | 1, mid + 1, r, ul, ur, inc);
        st[node] = st[node << 1] + st[(node << 1) | 1];
    }
}

ll sum(int node, int l, int r, int ql, int qr){
    if(r < ql || qr < l){
        return 0;
    }if(lazy[node]){
        relax(node, l, r);
    }if(ql <= l && r <= qr){
        return st[node];
    }else{
        int mid = (l + r) >> 1;
        return sum(node << 1, l, mid, ql, qr) + sum((node << 1) | 1, mid + 1, r, ql, qr);
    }
}

vector<ll>dist;

void bfs(int s, int n, int R, int A, vector<int>&a){
    queue<int>q;
    q.push(s);
    dist[s] = sum(1, 1, n, 1, R) * A;
    while(!q.empty()){
        s = q.front();
        q.pop();
        for(int to = R + 1; to <= n; to++){
            int mn = min(to, s);
            int mx = max(to, s);
            if(dist[to] > dist[s] + A * (a[to] - a[s]) + sum(1, 1, n, mn, mx) + (to - s) * a[s]){
                dist[to] = dist[s] + A * (a[to] - a[s]) + sum(1, 1, n, mn, mx) + (to - s) * a[s];
                swap(a[s], a[to]);
                update(1, 1, n, mn, mx, a[to] - a[s]);
                q.push(to);
            }
        }
    }
}*/

ll fact(ll n){
    if(n == 0 || n == 1) return 1;
    return n * fact(n - 1);
}

void solve(){
    ll n, q, A;
    cin >> n >> q >> A;
    vector<ll>a(n + 1), b(n + 1), c(n + 1);
    for(int i = 1; i <= n; i++){
        cin >> a[i];
    }
    ll R;
    cin >> R;
    c = a;
    sort(all(a));
    ll up = fact(n);
    ll Ans = INF;

    for(int i = 1; i <= up; i++){
        next_permutation(all(a));
        b = c;
        ll Res = 0;
        for(int j = 1; j <= n; j++){
            int to;
            if(a[j] != b[j]){
                for(int k = 1; k <= n; k++){
                    if(a[k] == b[j]){
                        to = k;
                        break;
                    }
                }
                if(to < j){
                    for(int k = j - 1; k >= to; k--){
                        Res += (b[k] + b[k + 1]);
                        swap(b[k], b[k + 1]);
                    }
                }else{
                    for(int k = j + 1; k <= to; k++){
                        Res += (b[k] + b[k - 1]);
                        swap(b[k], b[k - 1]);
                    }
                }
            }
        }
        for(int j = 1; j <= R; j++){
            Res += (b[j] * A);
        }
        if(Res < Ans){
            Ans = Res;
        }
    }
    cout << Ans;
}

int main()
{
    int t;
    t = 1;
    // cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
