#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <numeric>
using namespace std;

typedef long long ll;

const ll INF = 1e9;
const ll LLINF = 1e18;
const ll MOD = 1e9 + 7;

ll gcd(ll a, ll b) {
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

ll a, r;
ll res = LLINF;
vector<ll> cur;
void gen(int left, ll curRes) {
    ll endRes = curRes;
    for (int i = 0; i < r; ++i)
        endRes += cur[i] * a;
    res = min(res, endRes);
    if (left == 0)
        return;
    for (int i = 0; i < cur.size() - 1; ++i) {
        swap(cur[i], cur[i + 1]);
        gen(left - 1, curRes + cur[i] + cur[i + 1]);
        swap(cur[i], cur[i + 1]);
    }
}

void solve() {
    int n, q;
    cin >> n >> q >> a;
    cur.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> cur[i];
    while (q--) {
        cin >> r;
        res = LLINF;
        gen(n, 0);
        cout << res << "\n";
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);

    solve();
}
