#include <bits/stdc++.h>
#ifdef LOCAL
#else
#define debug(...)
#endif
#define int long long
using namespace std;

void solve(int n, vector<int>& v, int A, int r) {
    int res = 0;
    while (r != n) {
        vector<int> p(n);
        for (int i = 0; i < n; i++) {
            p[i] = v[i] + (i == 0 ? 0 : p[i - 1]);
        }

        auto sum = [&](int l, int r){
            return p[r] - (l == 0 ? 0 : p[l - 1]);
        };

        auto move21 = [&](int l, int r) {
            return v[l] * (r - l) + sum(l + 1, r);
        };

        auto shift1 = [&](int i, int j) {
            if (i > j) swap(i, j);
            int val = v[i];
            v.erase(v.begin() + i);
            v.insert(v.begin() + j, val);
        };
        int k = 0;
        int w = move21(k, r) + (v[r] - v[k]) * A;
        for (int j = 0; j < r; j++) {
            if (move21(j, r) + (v[r] - v[j]) * A < w) {
                w = move21(j, r) + (v[r] - v[j]) * A;
                k = j;
            }
        }

        auto move2 = [&](int l, int r) {
            return v[r] * (r - l) + sum(l, r - 1);
        };

        auto shift2 = [&](int l, int r) {
            int val = v[r];
            v.erase(v.begin() + r);
            v.insert(v.begin() + l, val);
        };

        vector<tuple<int, int, int>> a;
        for (int l = 0; l < r; l++) {
            for (int j = r; j < n; j++) {
                a.emplace_back(move2(l, j) + (v[j] - v[r - 1]) * A, l, j);
            }
        }
        sort(a.begin(), a.end());
        auto [x, l, j] = a[0];
        if (min(x, w) < 0) {
            if (x < w) {
                res += move2(l, j);
                shift2(l, j);
            } else {
                res += move21(k, r);
                shift1(k, r);
            }
        } else {
            break;
        }
    }
    for (int i = 0; i < r; i++) {
        res += v[i] * A;
    }
    cout << res << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, q, A;
    cin >> n >> q >> A;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    while (q--) {
        int r; cin >> r;
        solve(n, v, A, r);
    }
    return 0;
}
