#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int n, q, a;
vector<int> v;
vector<int> pref;
vector<int> v_sort;

ll get_sum(int l, int r) {
	return pref[r] - pref[l];
}

int k_th(int v) {
	auto it = lower_bound(v_sort.begin(), v_sort.end(), v);
	return it - v_sort.begin();
}

void solve(int r) {
	pref.resize(n + 1, 0);
	for (int i = 1; i <= n; ++i) {
		pref[i] = pref[i - 1] + v[i - 1];
	}
	v_sort = v;
	ll ans = get_sum(0, r) * a;
	ll tmp_ans = 0;
	ll cnt = 0;
	sort(v_sort.begin(), v_sort.end());
	for (int i = 0; i < n; ++i) {
		if (k_th(v[i]) < r) {
			tmp_ans += get_sum(0, i) - cnt + v[i];
			cnt += v[i];
		}
	}
	tmp_ans += cnt * a;
	cout << min(ans, tmp_ans) << "\n";
} 

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> q >> a;
	v.resize(n);
	for (int& i : v)
		cin >> i;
	for (int i = 0; i < q; ++i) {
		int r;
		cin >> r;
		solve(r);
	}
}