#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

typedef long long ll;

int n, q, a;
ll ans = INT64_MAX;
vector<int> v;
vector<ll> pref;
vector<int> v_sort;

ll get_sum(int l, int r) {
	return pref[r] - pref[l];
}

int k_th(int v) {
	auto it = lower_bound(v_sort.begin(), v_sort.end(), v);
	return it - v_sort.begin();
}

void solve(multiset<int> cur) {
	pref.resize(n + 1, 0);
	for (int i = 1; i <= n; ++i) {
		pref[i] = pref[i - 1] + v[i - 1];
	}
	//v_sort = v;
	//sort(v_sort.begin(), v_sort.end());
	ll tmp_ans = 0;
	ll cnt = 0;
	int num_cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (cur.find(v[i]) != cur.end()) {
			cur.erase(cur.find(v[i]));
			tmp_ans += get_sum(0, i) - cnt + (v[i] * (i - num_cnt));
			cnt += v[i];
			++num_cnt;
		}
	}
	tmp_ans += cnt * a;
	ans = min(ans, tmp_ans);
}

void gen(multiset<int>& cur, vector<bool>& used, int i, int r) {
	if (i == r) {
		solve(cur);
	}
	for (int j = 0; j < n; ++j) {
		if (!used[j]) {
			cur.insert(v[j]);
			used[j] = true;
			gen(cur, used, i + 1, r);
			used[j] = false;
			cur.erase(cur.find(v[j]));
		}
	}
}



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> q >> a;
	v.resize(n);
	for (int& i : v)
		cin >> i;
	for (int i = 0; i < q; ++i) {
		int r;
		cin >> r;
		multiset<int> st;
		vector<bool> used(n, false);
		gen(st, used, 0, r);
		cout << ans << "\n";
	}
}