#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
#define int long long
const int INF = 1e15;

inline void solve() {
    int n, q, x;
    cin >> n >> q >> x;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector <int> psum(n + 1);
    for (int i = 0; i < n; ++i) psum[i + 1] = psum[i] + a[i];
    while (q--) {
        int r;
        cin >> r;
        int cur = 0;
        for (int i = 0; i < r; ++i) cur += a[i];
        vector <int> taken(n);
        cur *= x;
        vector <pair <int, int>> imp1, imp2;
        for (int i = 0; i < r; ++i) {
            int l = r - i - 1;
            imp1.emplace_back(-a[i] * x + a[i] * l + psum[r] - psum[i + 1], a[i]);
        }
        for (int i = r; i < n; ++i) {
            int l = i - r;
            imp2.emplace_back(a[i] * x + a[i] * (l + 1) + psum[i] - psum[r], a[i]);
        }
        sort(imp1.begin(), imp1.end());
        sort(imp2.begin(), imp2.end());
        int it = 0;
        while (it < (int)imp1.size() && it < (int)imp2.size()) {
            int delta = imp1[it].first + imp2[it].first + imp1[it].second;
            if (delta < 0) {
                cur += delta;
                ++it;
            } else {
                break;
            }
        }
        cout << cur << "\n";
    }
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
}

/*
 4 1 5
 4 1 2 3
 2

4 1 6
4 1 2 3
2

 */