#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
#define ll long long
#define int long long
int x, n;
vector <int> a, psum;
vector <int> minr, maxr;

inline bool check_in(vector <int>& arr, int val) {
    auto it = lower_bound(arr.begin(), arr.end(), val);
    if (it != arr.end() && *it == val) return true;
    return false;
}

void calc(int l, int r, vector <int>& all1, vector <int>& all2) {
    if (l > r) return;
    int m = (l + r) / 2;
    vector <int> all11, all12, all21, all22;
    vector <pair <int, int>> imp1, imp2;
    for (int i : all1) {
        if (i >= m) {
            all12.push_back(i);
        } else {
            imp1.emplace_back(-a[i] * x + a[i] * (m - i) - psum[i + 1], i);
        }
    }
    for (int i : all2) {
        if (i < m) {
            all21.push_back(i);
        } else {
            imp2.emplace_back(a[i] * x + a[i] * (i - m + 1) + psum[i], i);
        }
    }
    int cnt1 = 0, cnt2 = 0;
    for (int i = 0; i < m; ++i) {
        if (maxr[i] > r) ++cnt1;
    }
    for (int i = m; i < n; ++i) {
        if (minr[i] < l) ++cnt2;
    }
    int hehe = min(cnt1, cnt2);
    cnt1 -= hehe;
    cnt2 -= hehe;
    sort(imp1.begin(), imp1.end());
    sort(imp2.begin(), imp2.end());
    int it1 = 0, it2 = 0;

    while (it1 < cnt2) {
        maxr[imp1[it1].second] = m;
        all12.push_back(imp1[it1].second);
        ++it1;
    }

    while (it2 < cnt1) {
        minr[imp2[it2].second] = m;
        all21.push_back(imp2[it2].second);
        ++it2;
    }

    while (it1 < (int)imp1.size() && it2 < (int)imp2.size()) {
        ll delta = imp1[it1].first + imp2[it2].first;
        if (delta <= 0) {
            all12.push_back(imp1[it1].second);
            all21.push_back(imp2[it2].second);
            maxr[imp1[it1].second] = m;
            minr[imp2[it2].second] = m;
            ++it1;
            ++it2;
        } else {
            break;
        }
    }
    if (l == r) return;
    for (int i = it1; i < (int)imp1.size(); ++i) all11.push_back(imp1[i].second);
    for (int i = it2; i < (int)imp2.size(); ++i) all22.push_back(imp2[i].second);
    calc(l, m - 1, all11, all21);
    calc(m + 1, r, all12, all22);
}

inline void solve() {
    int q;
    cin >> n >> q >> x;
    a.resize(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    psum.resize(n + 1);
    for (int i = 0; i < n; ++i) psum[i + 1] = psum[i] + a[i];
    minr.resize(n, n + 1);
    maxr.resize(n, -1);
    vector <int> all1, all2;
    for (int i = 0; i < n; ++i) {
        all1.push_back(i);
        all2.push_back(i);
    }
    calc(1, n, all1, all2);
    while (q--) {
        int r;
        cin >> r;
        int ans = psum[r] * x;
        for (int i = 0; i < n; ++i) {
            if (maxr[i] >= r && i < r) {
                ans += -a[i] * x + a[i] * (r - i) - psum[i + 1];
            }
            if (minr[i] <= r && i >= r) {
                ans += a[i] * x + a[i] * (i - r + 1) + psum[i];
            }
        }
        cout << min(ans, psum[r] * x) << "\n";
    }
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
}

/*
4 1 5
4 2 1 1
3

 */