#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <iomanip>

using namespace std;
const double INF = 1e9;
const int MAXN = 100 + 10;



inline void solve() {
    vector <vector <vector <double>>> dp(MAXN, vector <vector <double>> (MAXN, vector <double> (MAXN)));
    double pr;
    int n, l, r;
    cin >> pr >> n >> l >> r;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            for (int k = 0; k < 3; ++k) {
                dp[i][j][k] = INF;
            }
        }
    }
    dp[n][n][0] = 0;
    int it = 0;
    while (it < 1000) {
        vector <vector <vector <double>>> dp1(MAXN, vector <vector <double>> (MAXN, vector <double> (MAXN)));
        for (int i = n; i >= 0; --i) {
            for (int j = n; j >= 0; --j) {
                for (int k = 0; k < 3; ++k) {
                    if (k == 0) {
                        if (i == n && j == n) continue;
                        if (i == j) {
                            dp1[i][j][k] = pr * dp[i + 1][j][0] + (1 - pr) * dp[i][j + 1][0];
                        } else {
                            if (i == n) dp1[i][j][k] = pr * dp[i][j][1] + (1 - pr) * dp[i][j + 1][0];
                            else if (j == n) dp1[i][j][k] = pr * dp[i + 1][j][0] + (1 - pr) * dp[i][j][2];
                            else dp1[i][j][k] = min(dp[i + 1][j][0] * pr + (1 - pr) * dp[i][j][2], dp[i][j][1] * pr + (1 - pr) * dp[i][j + 1][0]);
                        }
                    } else if (k == 1) {
                        dp1[i][j][k] = pr * dp[i][j][0] + (1 - pr) * dp[i][max(0, j - 1)][1];
                    } else {
                        dp1[i][j][k] = pr * dp[max(0, i - 1)][j][2] + (1 - pr) * dp[i][j][0];
                    }
                }
            }
        }
        dp1.swap(dp);
        it++;
    }
    cout << fixed << setprecision(12) << dp[l][r][0];
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
}

/*

 */