#pragma GCC otpimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>



using namespace std;


#define ll long long
#define flt long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define prcs cout << fixed << setprecision(12)


flt p;
int n, l, r;


flt solve(){
    const flt inf = 1e5;
    vector<vector<flt>> dp(n + 1, vector<flt>(n + 1, inf));
    dp[n][n] = 0;
    const int iters = 1000;
    const int pws_itrs = 300;
    for(int itr = 0; itr < iters; itr += 1){
        for(int t = n - 1; t >= 0; t -= 1){
            for(int f = t; f <= n; f += 1){
                for(int cs = 0; cs < 2; cs += 1){
                    if(cs == 2 && t == f){
                        continue;
                    }
                    int i, j;
                    if(cs == 0){
                        i = t;
                        j = f;
                    } else{
                        i = f;
                        j = t;
                    }
                    if(i == j){
                        dp[i][j] = 1 + dp[i + 1][j] * p + dp[i][j + 1] * (1 - p);
                        continue;
                    }
                    flt prob;
                    flt sm1 = inf;
                    flt sm2 = inf;
                    if(i + 1 <= n){
                        sm1 = (1 + dp[i + 1][j]) * p;
                        prob = (1 - p);
                        for(int k = 0; k < pws_itrs; k += 1){
                            sm1 += (2 + k + dp[max(0, i - k)][j]) * prob * (1 - p);
                            prob *= p;
                        }
                    }
                    if(j + 1 <= n){
                        sm2 = (1 + dp[i][j + 1]) * (1 - p);
                        prob = p;
                        for(int k = 0; k < pws_itrs; k += 1){
                            sm2 += (2 + k + dp[i][max(0, j - k)]) * prob * (p);
                            prob *= (1 - p);
                        }
                    }
                    dp[i][j] = min(sm1, sm2);
                }
            }
        }
    }
    return dp[l][r];
}


int32_t main(){
    cin >> p >> n >> l >> r;
    prcs << solve() << "\n";
    return 0;
}