#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;
typedef long long ll;
#define int long long

int n, q, A;
int a[50010];
int r;
bool ch[50010];

int stans()
{
	int ans = 0;

	for (int musk = 0; musk < (1 << n); ++musk)
	{
		vector <int> le, ri;
		for (int j = 0; j < n; ++j)
		{
			if (!((musk >> j) & 1)) continue;
			if (j < r) le.push_back(j);
			else ri.push_back(j);
		}

		for (int j = 0; j < n; ++j) ch[j] = 0;

		if (le.size() != ri.size()) continue;
		int nans = 0;
		for (auto j : le) nans -= a[j] * A;
		for (auto j : ri) nans += a[j] * A;

		for (int j = 0; j < le.size(); ++j)
		{
			for (int k = le[j] + 1; k < r; ++k)
			{
				nans += a[le[j]] + a[k];
			}
			for (int k = r; k < ri[j]; ++k)
			{
				nans += a[ri[j]] + a[k];
			}

			nans += a[le[j]] * (j + 1);
			nans += a[ri[j]] * (ri.size() - j);
		}


		ans = min(ans, nans);
	}

	for (int i = 0; i < r; ++i) ans += a[i] * A;
	return ans;
}
//
//int smans()
//{
//	int ans = 0;
//	for (int j = 0; j < le.size(); ++j)
//	{
//		for (int k = le[j]; k < r; ++k)
//		{
//			if (!ch[k]) nans += a[le[j]] + a[k];
//		}
//		for (int k = r; k < ri[j]; ++k)
//		{
//			if (!ch[k]) nans += a[ri[j]] + a[k];
//		}
//		for (int k = 0; k < ri.size(); ++k)
//		{
//			nans += a[le[j]] + a[ri[k]];
//		}
//	}
//}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> q >> A;
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
	}

	cin >> r;

	auto got = stans();
	cout << got;

	return 0;
}