#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;
#define int long long 

int inf = 1e18;

int dppr[1 << 22];

int n, k;
int bitcnt(int n)
{
	int ans = 0;
	while (n)
	{
		ans += (n & 1);
		n >>= 1;
	}
	return ans;
}

int l[30];
int r[30];


signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> k;
	
	for (int i = 0; i < n; ++i)
	{
		cin >> l[i] >> r[i];
	}

	for (int j = 0; j < (1 << n); ++j) dppr[j] = inf;

	dppr[1] = 0;

	for (int i = 1; i < n; ++i)
	{
		for (int j = (1 << i) - 1; j >= 0; --j)
		{
			int musk = j + (1 << i);
			if (bitcnt(musk) > k) continue;
			dppr[musk] = dppr[j];
			for (int k = 0; k < i; ++k)
			{
				if ((j >> k) & 1) continue;
				dppr[musk] = min(dppr[musk], dppr[j + (1 << k)] + abs(r[k] - l[i]));
			}
		}
		for (int j = (1 << i) - 1; j >= 0; --j)
		{
			dppr[j] = inf;
		}
	}

	int ans = inf;
	for (int j = 0; j < (1 << n); ++j)
	{
		ans = min(ans, dppr[j]);
	}

	cout << ans;

	return 0;
}