#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;
vector<long long> a;
long long n, q, c;

long long getmnm(vector<bool> &mask) {
	long long notsum = 0;
	long long notnum = 0;
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		if (mask[i]) {
			ans += notnum * a[i] + notsum;
			ans += a[i]*c;
		}
		else {
			notsum += a[i];
			notnum++;

		}
	}
	return ans;
}
int main() {
	cin >> n >> q >> c;
	a.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<bool> within(n);
	vector<long long> anses(n+1,1e15);
	long long sum = 0;
	
	long long prevswaps=0;
	for (int i = 0; i <n; i++) {
		int pos = 0;
		for (int j = 0; j < n; j++) {
			if (!within[j]) {
				within[j] = 1;
				long long trial = getmnm(within);
				within[j] = 0;
				if (trial < anses[i]) {
					anses[i] = trial;
					pos = j;
				}
			}
		}
		within[pos] = 1;
	}
	for (int i = 0; i < q; i++) {
		int r;
		cin >> r;
		r--;
		cout << anses[r]<<'\n';

	}
}