#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;
vector<long long> a;
long long n, q, c;

long long getmnm(vector<bool> &mask) {
	long long notsum = 0;
	long long notnum = 0;
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		if (mask[i]) {
			ans += notnum * a[i] + notsum;
			ans += a[i]*c;
		}
		else {
			notsum += a[i];
			notnum++;

		}
	}
	return ans;
}
int main() {
	cin >> n >> q >> c;
	a.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<bool> within(n);
	vector<long long> anses(n+1,1e17);
	long long sum = 0;
	
	long long prevswaps=0;

	vector<long long> exswap(n);
	long long ps = 0;
	for (int i = 0; i < n; i++) {
		exswap[i]= a[i] * i + ps;
		ps += a[i];
	}
	
	
	long long swaprecord = 0;
	for (int i = 0; i <n; i++) {
		int pos = 0;
		long long best = 1e17;
		long long actswap = 0;
		for (int j = 0; j < n; j++) {
			if (!within[j]) {
				long long trial = (sum + a[j]) * c + exswap[j];
				if (trial < best) {
					best = trial;
					pos = j;
					actswap = exswap[j];
				}
			}
		}
		within[pos] = 1;
		sum += a[pos];
		for (int j = 0; j < n; j++) {
			if (!within[j]) {
				exswap[j] -= a[pos] + a[j];
			}
		}
		anses[i] = best + swaprecord;
		swaprecord += actswap;
	}
	for (int i = 0; i < q; i++) {
		int r;
		cin >> r;
		r--;
		cout << anses[r]<<'\n';

	}
}