#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define int long long

mt19937 rnd(51);

const int INF = 1e18;

int solve(int n, int A, int r, vector<int> a) {
    map<vector<int>, int> d;
    d[a] = 0;
    set<pair<int, vector<int>>> st;
    st.insert({0, a});
    int ans = INF;
    while (st.size() > 0) {
        auto v = st.begin()->second;
        st.erase(st.begin());
        int dist = d[v];
        for (int i = 0; i + 1 < n; i++) {
            int len = v[i] + v[i + 1];
            swap(v[i], v[i + 1]);
            if (!d.count(v) || d[v] > dist + len) {
                st.erase({d[v], v});
                d[v] = dist + len;
                st.insert({d[v], v});
            }
            swap(v[i], v[i + 1]);
        }
        int sum = dist;
        for (int i = 0; i < r; i++) {
            sum += v[i] * A;
        }
        ans = min(ans, sum);
    }
    return ans;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    if (1) {
        int n, q, A;
        cin >> n >> q >> A;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        assert(q == 1);
        int r;
        cin >> r;
        cout << solve(n, A, r, a) << endl;
        return 0;
    }
    while (0) {
        int n = rnd() % 5 + 1;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            a[i] = rnd() % 10 + 1;
        }
        int r = rnd() % n + 1, A = rnd() % 10 + 1;
        cout << solve(n, A, r, a) << endl;
    }
    return 0;
}
