#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define int long long

const int N = 20100, INF = 1e14, super_INF = 4e18;
int n, k, s, t;
int l[N], r[N];

int cost(int v, int u) {
    int mulp = 1;
    if (v > u) {
        mulp = -1;
        swap(v, u);
    }
    int pr;
    if (v >= k + 1) {
        v -= (k + 1);
        if (v % 2 == 0) {
            pr = -INF;
        } else if (u == t) {
            pr = 0;
        } else {
            u -= (k + 1);
            v /= 2, u /= 2;
            pr = abs(r[v] - l[u]);
        }
    } else {
        pr = 0;
    }
    return pr * mulp;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> k;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    s = 0, t = k + 1 + 2 * n;
    int m = t + 1;
    vector<int> pt(m, INF);
    pt[s] = 0;
    for (int v = 0; v < m; v++) {
        if (v >= k + 1 && v != t) {
            if ((v - (k + 1)) % 2 == 0) {
                int u = v + 1;
                int c = cost(v, u);
                pt[u] = min(pt[u], pt[v] + c);
            } else {
                for (int u = v + 1; u < t; u += 2) {
                    int c = cost(v, u);
                    pt[u] = min(pt[u], pt[v] + c);
                }
                int u = t;
                int c = cost(v, u);
                pt[u] = min(pt[u], pt[v] + c);
            }
        } else if (v == 0) {
            for (int u = 1; u <= k; u++) {
                int c = cost(v, u);
                pt[u] = min(pt[u], pt[v] + c);
            }
        } else if (v < k + 1){
            for (int u = k + 1; u < t; u += 2) {
                int c = 0;
                pt[u] = min(pt[u], pt[v] + c);
            }
        }
    }
    vector<map<int, int>> upd(m);
    int ans = 0;
    while (1) {
        vector<int> d(m, super_INF);
        vector<int> par(m, -1);
        vector<bool> used(m), block(m);
        d[s] = 0;
        for (int _ = 0; _ < m; _++) {
            int v = -1;
            for (int i = 0; i < m; i++) {
                if (used[i]) continue;
                if (v == -1 || d[i] < d[v]) {
                    v = i;
                }
            }
            used[v] = 1;
            if (d[v] == super_INF) break;
            for (auto to : upd[v]) {
                if (to.first > v) {
                    if (to.second != 0) {
                        block[to.first] = 1;
                    }
                } else {
                    if (to.second != 0) {
                        int u = to.first;
                        int c = cost(v, u);
                        if (d[u] > d[v] + pt[v] + c - pt[u]) {
                            d[u] = d[v] + pt[v] + c - pt[u];
                            par[u] = v;
                        }
                    }
                }
            }
            if (v >= k + 1 && v != t) {
                if ((v - (k + 1)) % 2 == 0) {
                    int u = v + 1;
                    int c = cost(v, u);
                    if (!block[u] && d[u] > d[v] + pt[v] + c - pt[u]) {
                        d[u] = d[v] + pt[v] + c - pt[u];
                        par[u] = v;
                    }
                } else {
                    for (int u = v + 1; u < t; u += 2) {
                        int c = cost(v, u);
                        if (!block[u] && d[u] > d[v] + pt[v] + c - pt[u]) {
                            d[u] = d[v] + pt[v] + c - pt[u];
                            par[u] = v;
                        }
                    }
                    int u = t;
                    int c = cost(v, u);
                    if (!block[u] && d[u] > d[v] + pt[v] + c - pt[u]) {
                        d[u] = d[v] + pt[v] + c - pt[u];
                        par[u] = v;
                    }
                }
            } else if (v == 0) {
                for (int u = 1; u <= k; u++) {
                    int c = cost(v, u);
                    if (!block[u] && d[u] > d[v] + pt[v] + c - pt[u]) {
                        d[u] = d[v] + pt[v] + c - pt[u];
                        par[u] = v;
                    }
                }
            } else if (v < k + 1){
                for (int u = k + 1; u < t; u += 2) {
                    int c = 0;
                    if (u > v && !block[u] && d[u] > d[v] + pt[v] + c - pt[u]) {
                        d[u] = d[v] + pt[v] + c - pt[u];
                        par[u] = v;
                    }
                }
            }
            for (auto to : upd[v]) {
                if (to.first > v) {
                    if (to.second != 0) {
                        block[to.first] = 0;
                    }
                }
            }
        }
        if (par[t] == -1) break;
        int cur = t;
        while (cur != s) {
            int p = par[cur];
            upd[p][cur]++, upd[cur][p]--;
            ans += cost(p, cur);
            cur = p;
        }
        for (int i = 0; i < m; i++) {
            pt[i] += d[i];
        }
    }
    cout << ans + INF * n << endl;
    return 0;
}
