#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;
#define int long long
const int MX = 2e18;

inline void solve() {
    int n;
    cin >> n;
    int q;
    cin >> q;
    int k;
    cin >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    while (q--) {
        int x;
        cin >> x;
        vector<vector<int> > dp(n + 1, vector<int>(x + 1, MX));
        dp[0][0] = 0;
        int pref_sum = 0;
        for (int i = 1; i <= n; ++i) {
            for (int j = 0; j <= min(i, x); ++j) {
                dp[i][j] = min(dp[i][j], dp[i - 1][j]);
                if(j == 0)
                    continue;
                dp[i][j] = min(dp[i][j], dp[i - 1][j - 1] + a[i - 1] * (k - x + i) + pref_sum);
            }
            pref_sum += a[i - 1];
        }
        cout << dp[n][x] << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
