#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;
#define int long long
const int MX = 2e18;

inline void solve() {
    int n;
    cin >> n;
    int q;
    cin >> q;
    int k;
    cin >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    while (q--) {
        int x;
        cin >> x;
        int pref_sum = 0;
        multiset<int> help;
        for (int i = 1; i <= n; ++i) {
            help.insert( a[i - 1] * (k + i - x) + pref_sum);
            pref_sum += a[i - 1];
        }
        int ans = 0;
        for(auto u : help)
        {
            ans += u;
            --x;
            if(x == 0)
                break;
        }
        cout << ans;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
