#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;
#define int long long
#define double long double
const int MX = 2e18;

inline void solve() {
    double p;
    cin >> p;
    int n, l, r;
    cin >> n >> l >> r;
    vector<vector<vector<vector<double> > > > dp(n + 2, vector<vector<vector<double>> >(n + 2, vector<vector<double> >(2, vector<double>(2, -1))));
    dp[l][r][0][0] = 0;
    for (int i = 0; i < 10000; ++i) {
        for(int x = 0;x<=n;++x)
            for(int y = 0;y<=n;++y)
                for(int z = 0;z<=1;++z)
                    for(int kk = 0;kk<=1;++kk)
                    if (dp[x][y][z][kk] == 0)
                        dp[x][y][z][kk] = -1;
        dp[l][r][0][0] = 0;
        vector<vector<vector<vector<double> > > > newdp(n + 2, vector<vector<vector<double>> >(n + 2, vector<vector<double> >(2, vector<double>(2, 0))));
        for (int x = 0; x <= n; ++x) {
            for (int y = 0; y <= n; ++y) {
                if (x == y) {
                    if(x < n) {
                        newdp[x + 1][y][0][0] += (dp[x][y][0][0] + 1) * p;
                        newdp[x][y + 1][0][0] += (dp[x][y][0][0] + 1) * (1 - p);
                    }
                } else if (x < y) {
                    newdp[x + 1][y][0][0] += (dp[x][y][0][0] + 1) * p;
                    newdp[x][y][1][1] += (dp[x][y][0][0] + 1) * (1 - p);
                } else {
                    newdp[x][y][1][0] += (dp[x][y][0][0] + 1) * p;
                    newdp[x][y + 1][0][0] += (dp[x][y][0][0] + 1) * (1 - p);
                }
                for (int q = 1; q <= 1; ++q) {
//                    newdp[x + 1][y][q][1] += (dp[x][y][q][1] + 1) * p;
//                    newdp[x][y][q + 1][1] += (dp[x][y][q][1] + 1) * (1 - p);
                    newdp[max(0LL, x - 1)][y][q][1] += (dp[x][y][q][1] + 1) * p;
                    newdp[x][y][q - 1][1 - ((q - 1) == 0)] += (dp[x][y][q][1] + 1) * (1 - p);


//                    newdp[x][y][q + 1][0] += (dp[x][y][q][0] + 1) * p;
//                    newdp[x][y + 1][q][0] += (dp[x][y][q][0] + 1) * (1 - p);
                    newdp[x][y][q - 1][0] += (dp[x][y][q][0] + 1) * p;
                    newdp[x][max(0LL, y - 1)][q][0] += (dp[x][y][q][0] + 1) * (1 - p);
                }
            }
        }
        dp = move(newdp);
        dp[l][r][0][0] = 0;
        cout << setprecision(12) << dp[n][n][0][0] << endl;
    }
    cout << setprecision(12) << dp[n][n][0][0];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
