#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;
constexpr ll infL = 3e18;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q, A;
    cin >> n >> q >> A;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> R(q);
    for (int i = 0; i < q; ++i) {
        cin >> R[i];
    }

    if (q == 1) {
        ll ans = accumulate(a.begin(), a.begin() + R[0], 0ll) * A;
        auto solve = [&](int k) {
            vector<ll> dp(k + 1, infL);
            dp[0] = 0;
            for (int i = R[0] - 1; i >= 0; --i) {
                auto dq = dp;
                dp.assign(k + 1, infL);
                { //choose
                    for (int c = 0; c < k; ++c) {
                        dp[c + 1] = dq[c] + (k + (R[0] - i - 1 - c)) * 1LL * a[i];
                    }
                }
                { //skip
                    for (int c = 0; c <= k; ++c) {
                        dp[c] = min(dp[c], dq[c] + (k - c + A) * 1LL * a[i]);
                    }
                }
            }
            ll now = dp[k];
            dp.assign(k + 1, infL);
            dp[0] = 0;
            for (int i = R[0]; i < n; ++i) {
                auto dq = dp;
                dp.assign(k + 1, infL);
                { //choose
                    for (int c = 0; c < k; ++c) {
                        dp[c + 1] = dq[c] + (k + (i - R[0] - c) + A) * 1LL * a[i];
                    }
                }
                { //skip
                    for (int c = 0; c <= k; ++c) {
                        dp[c] = min(dp[c], dq[c] + (k - c) * 1LL * a[i]);
                    }
                }
            }
            now += dp[k];
            if (now == 6) {
                cerr << k << endl;
            }
            ans = min(ans, now);
        };
        for (int k = 0; k <= min(R[0], n - R[0]); ++k) {
            solve(k);
        }
        cout << ans << '\n';
    } else {
        assert(false);
    }

    return 0;
}
