#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 22;

vector<pair<ll, int>> dp;

int S[N], T[N];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    for (int i = 0; i < n; ++i) {
        cin >> S[i] >> T[i];
    }

    dp.emplace_back(0, 1);
    for (int i = 1; i < n; ++i) {
        vector<pair<ll, int>> nxt;
        for (auto [val, mask]: dp) {
            int pc = __builtin_popcount(mask);
            if (pc + 1 <= k) {
                nxt.emplace_back(val, mask ^ 1 << i);
            }
            int fi = -1, se = -1;
            for (int j = 0; j < i; ++j) {
                if (mask >> j & 1) {
                    if (T[j] >= S[i]) {
                        if (se == -1 || T[se] > T[j]) {
                            se = j;
                        }
                    } else {
                        if (fi == -1 || T[fi] < T[j]) {
                            fi = j;
                        }
                    }
                }
            }
            for (int j : {fi, se}) {
                if (j != -1) {
                    nxt.emplace_back(val + abs(T[j] - S[i]), mask ^ 1 << j ^ 1 << i);
                }
            }
        }
        dp.clear();
        sort(nxt.begin(), nxt.end());
        for (auto &j : nxt) {
            if (dp.empty() || dp.back().second != j.second) {
                dp.push_back(j);
            }
        }
    }

    cout << dp.front().first << '\n';

    return 0;
}
