#include <bits/stdc++.h>

using namespace std;
using ll = long long;

template<typename T>
bool ckmin(T &a, T b) {
    return a > b ? a = b, 1 : 0;
}

constexpr int N = 22;

ll dp[1 << N];

int S[N], T[N];

constexpr ll infL = 3e18;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;

    for (int i = 0; i < n; ++i) {
        cin >> S[i] >> T[i];
    }

    fill(dp, dp + (1 << n), infL);
    dp[1] = 0;
    for (int i = 1; i < n; ++i) {
        for (int msk = 0; msk < (1 << (i - 1)); ++msk) {
            int mask = msk ^ 1 << (i - 1);
            ll val = dp[mask];
            if (val == infL) {
                continue;
            }
            int pc = __builtin_popcount(mask);
            assert(pc <= k);
            if (pc + 1 <= k) {
                ckmin(dp[mask ^ 1 << i], val);
            }
            int fi = -1, se = -1;
            for (int j = 0; j < i; ++j) {
                if (mask >> j & 1) {
                    if (T[j] >= S[i]) {
                        if (se == -1 || T[se] > T[j]) {
                            se = j;
                        }
                    } else {
                        if (fi == -1 || T[fi] < T[j]) {
                            fi = j;
                        }
                    }
                }
            }
            if (fi != -1 && se != -1) {
                if ((S[i] - T[fi]) * 2 < (T[se] - S[i])) {
                    se = -1;
                } else if ((S[i] - T[fi]) > 2 * (T[se] - S[i])) {
                    fi = -1;
                }
            }
            for (int j : {fi, se}) {
                if (j != -1) {
                    ckmin(dp[mask ^ 1 << i ^ 1 << j], val + abs(T[j] - S[i]));
                }
            }
        }
    }

    cout << *min_element(dp + (1 << (n - 1)), dp + (1 << n)) << '\n';

    return 0;
}
