#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast, unroll-loops")
#include <bits/stdc++.h>

using namespace std;

const long long inf = 1e18;

void solve() {
    int n, q, a;
    cin >> n >> q >> a;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    vector<long long> pr(n + 1);
    for (int i = 0; i < n; ++i) {
        pr[i + 1] = pr[i] + v[i];
    }
    vector<int> r(q);
    for (int i = 0; i < q; ++i) {
        cin >> r[i];
    }
    vector<pair<long long, int>> vals(n);
    for (int j = 0; j < n; ++j) {
        vals[j] = {v[j] * 1LL * j + v[j] * 1LL * a - (pr[n] - pr[j + 1]), j};
    }
    sort(vals.begin(), vals.end());
    vector<long long> ans_nw(n + 1);
    for (int i = 1; i <= n; ++i) {
        long long ans = pr[n] * 1LL * i;
        for (int j = 0; j < n; ++j) {
            vals[j].first -= v[vals[j].second];
        }
        nth_element(vals.begin(), vals.begin() + i - 1, vals.end());
        for (int j = 0; j < i; ++j) {
            ans += vals[j].first;
        }
        ans_nw[i] = ans;
    }
    for (int i = 0; i < q; ++i) {
        cout << ans_nw[r[i]] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}
