#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
#define all(a) a.begin(), a.end()

using namespace std;

template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;



signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q, x;
	cin >> n >> q >> x;
	vi a(n + 1);
	vi p(n + 1, 0);
	input(a, 1);
	for (int i = 1; i <= n; ++i)
		p[i] = p[i - 1] + a[i];
	while (q--) {
		int k;
		cin >> k;
		vi b, c;
		for (int i = 1; i <= n; ++i) {
			if (i <= k)
				b.push_back(a[i] * (k - i + 1) + p[k] - p[i] - a[i] * x);
			else
				c.push_back(a[i] * (i - k) + p[i - 1] - p[k] + a[i] * x);
		}
		sort(all(b));
		sort(all(c));
		int ans = 0;
		for (int i = 1; i <= k; ++i)
			ans += a[i] * x;
		for (int i = 0; i < min(b.size(), c.size()); ++i) {
			if (b[i] + c[i] < 0)
				ans += b[i] + c[i];
			else
				break;
		}
		cout << ans << '\n';
	}

	return 0;
}