#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std;

typedef long long ll;
//typedef __int128_t ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
//#define break_(x) {x; return;}
const ll MOD = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-9;
//const ll MOD2 = 998244353;
ld pi = asin(0.5) * (ld)6;

vector<ll> v, t;
int n;
ll A;

ll slv(int R) {
    ll ans = 0;
    for (int i = 0; i < R; ++i) {
        ans += v[i] * A;
    }
    while (true) {
        int mni = -1;
        ll mnf = inf;
        ll smnw = 0;
        for (int i = R - 1; i >= 0; --i) {
            ll cst = (ll)(R - i) * v[i] + smnw - v[i] * A;
            if (cst < mnf) {
                mnf = cst;
                mni = i;
            }
            smnw += v[i];
        }
        ll mns = inf;
        smnw = 0;
        int mnj = -1;
        for (int i = R; i < n; ++i) {
            ll cst = (ll)(i - R + 1) * v[i] + smnw + v[i] * A;
            if (cst < mns) {
                mns = cst;
                mnj = i;
            }
            smnw += v[i];
        }
        if (mnf + mns >= 0) {
            break;
        }
        t.clear();
        ans += mnf + mns;
        for (int i = 0; i < R; ++i) {
            if (i != mni) {
                t.push_back(v[i]);
            }
        }
        t.push_back(v[mnj]);
        t.push_back(v[mni]);
        for (int i = R; i < n; ++i) {
            if (i != mnj) {
                t.push_back(v[i]);
            }
        }
        v = t;
    }
    return ans;
}

inline void solve(void) {
    int q;
    cin >> n >> q >> A;
    v.resize(n);
    t.reserve(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    int R; cin >> R;
    cout << slv(R);
}

int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; srand(time(0)); //cin >> t;
    while (t--) solve();
    return 0;
}
