#include <bits/stdc++.h>

#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=5002;

ll arr[N],v[N];

void solve()
{
    ll n,q,k;
    cin>>n>>q>>k;
    map<ll,ve<ll>> pos;

    for(ll i=0;i<n;i++)
    {
        cin>>arr[i];
        pos[arr[i]].push_back(i);
    }

    ll r;
    cin>>r;

    for(ll i=0;i<n;i++)
        v[i]=arr[i];

    sort(v,v+n);
    ll ans=INF;

    do
    {
        ll cur=0;
        map<ll,ll> mp;

        for(ll i=0;i<n;i++)
        {
            ll x=v[i];
            if(!mp.count(x)) mp[x]=0;
            cur+=x*abs(i-pos[x][mp[x]]);
            mp[x]++;
        }

        for(ll i=0;i<r;i++)
            cur+=v[i]*k;

        ans=min(ans,cur);
    }
    while(next_permutation(v,v+n));

    ll tl=2.4*CLOCKS_PER_SEC;
    ve<ll> v1;

    for(ll i=0;i<n-1;i++)
    {
        for(ll j=0;j<n-1;j++)
            v1.push_back(i);
    }

    while(clock()<tl)
    {
        shuffle(all(v1),gen);
        ve<ll> y(n,0);

        for(ll i=0;i<n;i++)
            y[i]=arr[i];

        ll cur=0;

        for(ll i=0;i<r;i++)
            cur+=y[i]*k;

        for(ll i:v1)
        {
            cur+=y[i]+y[i+1];

            if(i==r-1)
            {
                cur-=y[r-1]*k;
                cur+=y[r]*k;
            }

            swap(y[i],y[i+1]);
            ans=min(ans,cur);
        }

        ans=min(ans,cur);
    }

    cout<<ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
