#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <iomanip>
#include <fstream>
#include <ctime>
#include <random>
#include <cassert>

#define ld long double
#define pii pair<int,int>
#define fi first
#define se second
#define p_b push_back
#define m_p make_pair
#define sz(x) (int)x.size()
#define pw(x) (1LL<<(x))
#define sqr(x) ((x)*(x))
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

using namespace std;

const ld e = 1e-12;
int n;
ld P, _P;
ld rem[20000005][2], add[20000005][2];

ld solve(int l, int r, ld p = 1)
{
    if(l == r)
    {
        if(l == n)
            return 0;
        return p + solve(l + 1, r + 1, p) + add[l][0] * p * _P + add[r][1] * p * P;
    }
    if(l < r)
        return add[l][0] * p + solve(l + 1, r, p);
    return add[r][1] * p + solve(l, r + 1, p);
}

main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int l, r;
    cin >> P >> n >> l >> r;
    _P = (ld)1 - P;

    rem[0][0] = (ld)1 / _P;
    rem[0][1] = (ld)1 / P;
    add[0][0] = (rem[0][0] + 1) * (rem[0][1] - 1) + 1;
    add[0][1] = (rem[0][1] + 1) * (rem[0][0] - 1) + 1;
    for(int i = 1; i < n; i++)
    {
        rem[i][0] = P * (rem[i - 1][0] + add[i - 1][0]) + 1;
        rem[i][1] = _P * (rem[i - 1][1] + add[i - 1][1]) + 1;
        add[i][0] = (rem[i][0] + 1) * (rem[0][1] - 1) + 1;
        add[i][1] = (rem[i][1] + 1) * (rem[0][0] - 1) + 1;
    }

    cout << fixed << setprecision(12) << solve(l, r);
    return 0;
}

