#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

int h(const vector<int>& a){
    int res = 0;
    int p = 1;
    for (int i = 0; i < a.size(); i++, p *= 10){
        res += (a[i] * p);
    }
    return res;
}

vector<int> uniq;

ll naive(vector<int> a, int R, int A){
    int n = a.size();
    ll res = 1e18;
    map<int, ll> dist;
    priority_queue<pair<ll, int>> q;
    dist[h(a)] = 0;
    q.push({0, h(a)});
    while (!q.empty()){
        pair<ll, int> t = q.top();
        q.pop();
        if (-t.first > dist[t.second]){
            continue;
        }
        int v = t.second;
        vector<int> b(n);
        for (int i = 0; i < n; i++){
            b[i] = t.second % 10;
            t.second /= 10;
        }
        ll curres = -t.first;
        for (int i = 0; i < R; i++){
            curres += uniq[b[i]] * 1ll * A;
        }
        res = min(res, curres);
        for (int i = 0; i + 1 < n; i++){
            swap(b[i], b[i + 1]);
            int cur = h(b);
            if (dist.find(cur) == dist.end() || dist[cur] > dist[v] + uniq[b[i]] + uniq[b[i + 1]]){
                dist[cur] = dist[v] + uniq[b[i]] + uniq[b[i + 1]];
                q.push({-dist[cur], cur});
            }
            swap(b[i], b[i + 1]);
        }
    }
    return res;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    // freopen("output.txt", "w", stdout);
    int T = 1;
    // cin >> T;
    while (T--){
        int n, m, A;
        cin >> n >> m >> A;
        vector<int> a(n);
        for (int i = 0; i < n; i++){
            cin >> a[i];
            uniq.push_back(a[i]);
        }
        int R = -1;
        cin >> R;
        sort(all(uniq));
        uniq.erase(unique(all(uniq)), uniq.end());
        for (int i = 0; i < n; i++){
            a[i] = lower_bound(all(uniq), a[i]) - uniq.begin();
        }
        ll res = naive(a, R, A);
        cout << res << "\n";
        #ifdef ON_PC
        {
        map<int, ll> ddist;
        priority_queue<pair<ll, int>> qq;
        ddist[h(a)] = 0;
        qq.push({0, h(a)});
        while (!qq.empty()){
            pair<ll, int> t = qq.top();
            qq.pop();
            if (-t.first > ddist[t.second]){
                continue;
            }
            int v = t.second;
            vector<int> b(n);
            for (int i = 0; i < n; i++){
                b[i] = t.second % 10;
                t.second /= 10;
            }
            ll curres = -t.first;
            for (int i = 0; i < R; i++){
                curres += uniq[b[i]] * 1ll * A;
            }
            if (curres == res){
                for (int i = 0; i < n; i++){
                    cout << uniq[b[i]] << " ";
                }
                return 0;
            }
            for (int i = 0; i + 1 < n; i++){
                swap(b[i], b[i + 1]);
                int cur = h(b);
                if (ddist.find(cur) == ddist.end() || ddist[cur] > ddist[v] + uniq[b[i]] + uniq[b[i + 1]]){
                    ddist[cur] = ddist[v] + uniq[b[i]] + uniq[b[i + 1]];
                    qq.push({-ddist[cur], cur});
                }
                swap(b[i], b[i + 1]);
            }
        }
        }
        #endif
    }
    return 0;
}