#include <bits/stdc++.h>

#pragma GCC optimize ("-O3")
#pragma GCC optimize ("unroll-loops")
#pragma GCC target ("avx2")
//#pragma comment (linker, "

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define mp make_pair
//#define int long long

using namespace std;

template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; };
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; };
typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 16;
const int MX = 400;
const int lg = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int n;
ld p1;
ld p2;
map<int, map<int, map<int, ld>>> dp[MAX][MAX];
map<int, map<int, map<int, ld>>> ready[MAX][MAX];
ld eps = 1e-15;
int all = 0;

ld calc(int cnt, int i, int j, int k, int p, ld x = 1) {
    all++;
    if(cnt < 0 || i < 0 || j < 0 || k < 0 || p < 0 || i > n || j > n) {
        return 0;
    }
    if(ready[cnt][i][j][k][p]) {
        return dp[cnt][i][j][k][p];
    }
    if(x < eps) {
        return 0;
    }
    if(!k && !p) {
        ld ans = 0;
        if(i == j) {
            ans = p1 * calc(cnt - 1, i + 1, j, k, p, x * p1) + p2 * calc(cnt - 1, i, j + 1, k, p, x * p2);
            ready[cnt][i][j][k][p] = 1;
            return dp[cnt][i][j][k][p] = ans;
        }
        umax(ans, p1 * calc(cnt - 1, i + 1, j, k, p, x * p1) + p2 * calc(cnt - 1, i, j, k, p + 1, x * p2));
        umax(ans, p1 * calc(cnt - 1, i, j, k + 1, p, x * p1) + p2 * calc(cnt - 1, i, j + 1, k, p, x * p2));
        ready[cnt][i][j][k][p] = 1;
        return dp[cnt][i][j][k][p] = ans;
    }
    if(!k) {
        ld ans = 0;
        umax(ans, p1 * calc(cnt - 1, i + 1, j, k, p, x * p1) + p2 * calc(cnt - 1, i, j, k, p + 1, x * p2));
        umax(ans, p1 * calc(cnt - 1, max(i - 1, 0), j, k, p, x * p1) + p2 * calc(cnt - 1, i, j, k, p - 1, x * p2));
        ready[cnt][i][j][k][p] = 1;
        return dp[cnt][i][j][k][p] = ans;
    }
    if(!p) {
        ld ans = 0;
        umax(ans, p1 * calc(cnt - 1, i, j, k + 1, p, x * p1) + p2 * calc(cnt - 1, i, j + 1, k, p, x * p2));
        umax(ans, p1 * calc(cnt - 1, i, j, k - 1, p, x * p1) + p2 * calc(cnt - 1, i, max(j - 1, 0), k, p, x * p2));
        //cout << cnt << " " << i << ' ' << j << ' ' << k << " " << p << " " << x << " " << all << endl;
        ready[cnt][i][j][k][p] = 1;
        return dp[cnt][i][j][k][p] = ans;
    }
    ld ans = 0;
    umax(ans, p1 * calc(cnt - 1, i, j, k - 1, p, x * p1) + p2 * calc(cnt - 1, i, j, k, p - 1, x * p2));
    ready[cnt][i][j][k][p] = 1;
    return dp[cnt][i][j][k][p] = ans;
}

void solve() {
    int l, r;
    cin >> p1 >> n >> l >> r;
    p2 = 1 - p1;
    if(l == n && r == n) {
        cout << "0\n";
        return;
    }
    dp[0][n][n][0][0] = 1;
    ready[0][n][n][0][0] = 1;
    ld ans = 0;
    for(int i = 0; i < 1000; i++) {
        ld curr = calc(i, l, r, 0, 0);
        ans += curr * i;
        //cout << i << " " << curr << endl;
    }
    cout << fixed << setprecision(15) << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    int ttt0 = ttt;
    while(ttt--) {
        solve();
    }
}
