#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<pii> vp;

const ll inf = 1e18 + 9;
vi orginal;
map<int,int> locateg;

inline ll range(int s, int e, vi &arr) {
	ll ans = 0;
	for (int i = s; i <= e; i++) {
		ans += arr[i];
	}
	return ans;
}


ll cost(vi &order, int r) {
	ll ans = 0;
	vi arr = orginal;
	map<int, int> locate = locateg;

	for (int i = 0; i < order.size(); i++) {
		int n = abs(locate[order[i]] - i);
		ll curr = range(i, locate[order[i]] - 1, arr) + n * order[i];
		ans += curr;

		for (int j = locate[order[i]] - 1; j >= 0; j--) {
			locate[arr[j]]++;
			arr[j + 1] = arr[j];
			
		}
		arr[i] = order[i];
		locate[order[i]] = i;
	}
	return ans;
}

ll calc(vi &order, int r, int a) {
	ll ans = 0;
	for (int i = 0; i <= r; i++) {
		ans += order[i];
	}
	ans *= a;
	ans += cost(order,r);
	return ans;
}


ll solve(int r, int a) {
	vi order = orginal;
	ll ans = 0;
	for (int i = 0; i <= r; i++) {
		ans += orginal[i];
	}
	ans *= a;
	sort(order.begin(), order.end());
	do
	{
		ll curr = calc(order, r, a);
		ans = min(ans, curr);
	} while (next_permutation(order.begin(), order.end()));
	return ans;
}



int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, q, a;
	cin >> n >> q >> a;
	orginal.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> orginal[i];
		locateg[orginal[i]] = i;
	}
	int r;
	for (int i = 0; i < q; i++) {
		cin >> r;
		r--;
		ll ans = solve(r, a);
		cout << ans << endl;
	}

	return 0;
}