#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<pii> vp;

const ll inf = 1e18 + 9;


vp queries;
vector<vvi> dp;
vector<vector<vvi>> keep;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, k;
	cin >> n >> k;
	queries.resize(n+1);
	dp.resize(n+1, vvi(k,vi(n+1,inf)));
	keep.resize(n+1, vector<vvi>(k, vvi(n+1,(vi(k,-1)))));
	for (int i = 0; i < k; i++) {
		dp[0][i][0] = 0;
	}

	for (int i = 0; i < n; i++) {
		cin >> queries[i+1].first >> queries[i+1].second;
	}

	for (int i = 1; i <= n; i++) {
		for (int j = 0; j < k; j++) {
			for (int h = 1; h <= i; h++) {
				if (h == 1) {
					ll mincost = inf;
					pii minindex = {-1,-1};
					for (int a = 0; a < k; a++) {
						if (a == j)continue;
						for (int b = 0; b < i; b++) {
							ll dist = abs(keep[i-1][a][b][j] - queries[i].first);
							if (keep[i-1][a][b][j]==-1)dist = 0;

							ll curr = dp[i - 1][a][b] + dist;
							if (curr < mincost) {
								mincost = curr;
								minindex = {a,b};
							}
						}
					}

					dp[i][j][h] = mincost;
					keep[i][j][h] = keep[i - 1][minindex.first][minindex.second];
					keep[i][j][h][j] = queries[i].second;
				}
				else {
					int dist = abs(keep[i-1][j][h-1][j] - queries[i].first);
					if (keep[i-1][j][h - 1][j]==-1)dist = 0;
					dp[i][j][h] = dp[i][j][h - 1] + dist;
				}
			}


		}
	}

	ll ans = inf;
	for (int j = 0; j < k; j++) {
		for (int h = 1; h <= n; h++) {
			ans = min(ans, dp[n][j][h]);
		}
	}
	cout << ans;

	return 0;
}