#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
using namespace std;
int N;
vector <vector <int>> pways;
void ways(int left, vector <int> now)
{
	if (left == 0)
	{
		pways.push_back(now);
		return;
	}
	for (int a = 0; a < N; a++)
		if (now[a] == -1)
		{
			now[a] = left - 1;
			ways(left - 1, now);
			now[a] = -1;
		}
}
int main()
{
	int Q, A;
	cin >> N >> Q >> A;
	vector <long long> values;
	int i;
	for (int a = 0; a < N; a++)
	{
		cin >> i;
		values.push_back(i);
	}
	vector <int> queries;
	for (int a = 0; a < Q; a++)
	{
		cin >> i;
		queries.push_back(i);
	}
	int R = queries[0];
	vector <int> start(N, -1);
	ways(N, start);
	vector <pair <int,int>> temp;
	vector <long long> waynow;
	for (int a = 0; a < values.size(); a++)
		temp.push_back({ values[a] , a });
	sort(temp.begin(), temp.end());
	long long mincost = 1000000000000000000;
	for (int a = 0; a < pways.size(); a++)
	{
		waynow = values;
		long long cost = 0;
		//for (int b : pways[a])
		//	cout << b << " ";
		//cout << "cost: ";
		for (int b = 0; b < N; b++)
		{
			int ind = 0;
			for (int c = 0; c < N; c++)
				if (temp[b].first == waynow[c])
					ind = c;
			while (ind > pways[a][b])
			{
				//cout << "swap " << ind << ", " << ind - 1 << " ";
				cost += waynow[ind] + waynow[ind - 1];
				swap(waynow[ind], waynow[ind - 1]);
				ind--;
			}
		}
		for (int b = 0; b < R; b++)
		{
			cost += A * waynow[b];
			//cout << "A, waynow: " << A << ", " << waynow[b] << " ";
		}
		//cout << "total: " << cost << '\n';
		mincost = min(mincost, cost);
	}
	cout << mincost;
}