#include "bits/stdc++.h"
using namespace std;

int step(vector<int>& arr, int& i, int a, int q) {
    int s;
    for (int p = i - 1; p >= 0; p--) {
        if (p >= q) continue;
        s = 0;
        for (int o = p+1; o <= i; o++) {
            s += arr[p] + arr[o];
        }
        int diff = (arr[p] - arr[i]) * a;
        if (diff < 0) continue;
        if (diff - s < 0) continue;
        i = p;
        return s; 
    }

    return -1;
}

int query(vector<int>& arr, int q, int a) {
    vector<int> new_order(arr);
    int s = 0, t;
    for (int i = q; i < arr.size(); i++) {
        int new_i = i;
        t = step(new_order, new_i, a, q);
        if (t == -1) continue;
        s += t;
        new_order.insert(new_order.begin() + i + 1, new_order[new_i]);
        new_order.erase(new_order.begin() + new_i);
    }

    for (int i = 0; i < q; i++) {
        s += new_order[i] * a;
    }

    return s;
} 

void solve() {
    int n, q, a;
    cin >> n >> q >> a;

    vector<int> arr(n, 0);
    for (int i = 0; i < n; i++)
        cin >> arr[i];
    
    vector<int> queries(q, 0);
    for (int i = 0; i < q; i++) 
        cin >> queries[i];

    for (int q : queries) {
        cout << query(arr, q, a) << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    solve();
}