#include <bits/stdc++.h>
#define ff first
#define ss second

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;

const ll N = 1e4 + 20;

ll n,k,l[N],r[N],p[N];
ll le[N],ri[N];
vector<pair<ll,pll>> ed;

ll find_set(ll v){
	if(p[v] == v) return v;
	return p[v] = find_set(p[v]);
}

void union_set(ll u,ll v){
	u = find_set(u), v = find_set(v);
	p[u] = v;
}

int main(){
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> n >> k;
	for(ll i = 1; i <= n; ++i) cin >> l[i] >> r[i];
	for(ll i = 1; i <= n; ++i){
		for(ll j = i+1; j <= n; ++j){
			ed.push_back({abs(l[j]-r[i]),{i,j}});
		}
	}
	for(ll i = 1; i <= n; ++i){
		le[i] = ri[i] = -1;
		p[i] = i;
	}
	sort(ed.begin(),ed.end());
	ll ans = 0,cc = n;
	for(auto it : ed){
		if(cc <= k) break;
		ll u = it.ss.ff, v = it.ss.ss;
		if(ri[u] == -1 && le[v] == -1 && find_set(u) != find_set(v)){
			union_set(u,v);
			ans += it.ff;
			ri[u] = v, le[v] = u;
			cc--;
		}
	}
	cout << ans << endl;
	return 0;
}