#include <iostream>
#include <fstream>
#include <vector>
#include <queue>

using namespace std;

ifstream fin("test.in");
ofstream fout("test.out");

const int maxN = 10005;
int n, p, lift[maxN], last[maxN];
long long ans = (1LL << 60);
pair <int, int> v[maxN];

int modul(int x)
{
    if(x < 0)
        x = -x;
    return x;
}

void check()
{
    long long aux = 0;
    for(int i = 1; i <= p; i++)
        last[i] = 0;
    for(int i = 1; i <= n; i++)
    {
        int curr_lift = lift[i];
        if(last[curr_lift] != 0)
            aux += modul(v[last[curr_lift]].second - v[i].first);
        last[curr_lift] = i;
    }
    if(aux < ans)
        ans = aux;
}

void bkt(int k, int used)
{
    if(k == n + 1)
    {
        check();
        return;
    }
    for(int i = 1; i <= min(p, used + 1); i++)
    {
        lift[k] = i;
        bkt(k + 1, max(used, i));
    }
}

int main()
{
    cin >> n >> p;
    for(int i = 1; i <= n; i++)
        cin >> v[i].first >> v[i].second;
    bkt(1, 0);
    cout << ans;
    return 0;
}
