#include <iostream>
#include <fstream>
#include <bitset>
#include <vector>
#include <queue>

using namespace std;

ifstream fin("test.in");
ofstream fout("test.out");

const long long inf = (1LL << 60);
const int maxN = 10005;
int n, p;
long long sp[maxN], ans = inf;
pair <int, int> v[maxN];
long long dp[(1 << 22)];

int modul(int x)
{
    if(x < 0)
        x = -x;
    return x;
}

int calc(int x, int y)
{
    return sp[y] - sp[x];
}

int cautbin(int x)
{
    int aux = 0;
    for(int i = 16; i; i >>= 1)
    {
        int val = (1 << (aux + i));
        if(val <= x)
            aux += i;
    }
    return aux;
}

int main()
{
    cin >> n >> p;
    for(int i = 0; i < n; i++)
    {
        cin >> v[i].first >> v[i].second;
        if(i > 0)
            sp[i] = sp[i - 1] + modul(v[i - 1].second - v[i].first);
    }
    for(int mask = 1; mask < (1 << n); mask++)
    {
        if(__builtin_popcount(mask) > p)
            continue;
        int last = cautbin(mask);
        bitset <3> x(mask);
        int mask2 = mask - (1 << last);
        if(mask2 == 0)
            dp[mask] = calc(0, last);
        else
        {
            int last2 = cautbin(mask2);
            dp[mask] = dp[mask2] + calc(last2 + 1, last);
        }
        for(int i = 0; i < last; i++)
        {
            if((1 << i) & mask)
                continue;
            int mask2 = mask - (1 << last) + (1 << i);
            int last2 = cautbin(mask2);
            long long cost = dp[mask2] + modul(v[i].second - v[last2 + 1].first) + calc(last2 + 1, last);
            dp[mask] = min(dp[mask], cost);
        }
        //cout << x << ' ' << last << ' ' << dp[mask] << '\n';
        if(last == n - 1)
            ans = min(ans, dp[mask]);
    }
    cout << ans;
    return 0;
}
