#include <bits/stdc++.h>

using namespace std;
unsigned seed = chrono :: system_clock :: now().time_since_epoch().count();
mt19937 rng(seed);
using ll = long long;
const ll INF = 1e18;
const int N = 10;
ll v[N], A;
struct state {
    ll d;
    vector <int> p;
    friend bool operator <(const state& a, const state& b) {
        return a.d > b.d;
    }
};

int main()
{
    ios_base :: sync_with_stdio(false); cin.tie(0);
    int n, q;
    cin >> n >> q >> A;
    for(int i = 0; i < n; i++)
        cin >> v[i];
    int r;
    cin >> r;
    vector <int> p(n); iota(p.begin(), p.end(), 0);
    ll res = INF;
    map <vector <int>, ll> d;
    d[p] = 0;
    priority_queue <state> pq;
    pq.push({0, p});
    while(!pq.empty()) {
        auto [dd, p] = pq.top();
        pq.pop();
        if(dd > d[p]) continue;
        ll val = 0;
        for(int i = 0; i < r; i++)
            val += v[p[i]] * A;
        res = min(res, val + dd);
        for(int i = 0; i < n - 1; i++) {
            vector <int> pp = p;
            swap(pp[i], pp[i + 1]);
            if(!d.count(pp) || d[pp] > dd + v[p[i]] + v[p[i + 1]]) {
                d[pp] = dd + v[p[i]] + v[p[i + 1]];
                pq.push({d[pp], pp});
            }
        }
    }
    cout << res << "\n";
    return 0;
}
