#include <bits/stdc++.h>

using namespace std;
#pragma GCC optimize("Ofast, avx2")
const int N = 40, magic = 25000, rmagic = 100000;
double x[3][N][N], xp[3][N][N];
int l, r, n;
double p;
void transform()
{
    for(int w : {0, 1, 2}) for(int i = 0; i <= n; i++)
        for(int j = 0; j <= n; j++)
            xp[w][i][j] = 0;
    for(int w : {0, 1, 2}) for(int i = 0; i <= n; i++)
        for(int j = 0; j <= n; j++){
            if(i == n && j == n) continue;
            if(!w) {
                if(i > j) {
                    xp[0][i][j + 1] += (1 - p) * x[w][i][j];
                    xp[1][i][j] += p * x[w][i][j];
                } else if(i < j) {
                    xp[0][i + 1][j] += p * x[w][i][j];
                    xp[2][i][j] += (1 - p) * x[w][i][j];
                } else {
                    xp[0][i + 1][j] += p * x[w][i][j];
                    xp[0][i][j + 1] += (1 - p) * x[w][i][j];
                }
            } else {
                if(w == 1) {
                    if(j) xp[w][i][j - 1] += (1 - p) * x[w][i][j];
                    else xp[w][i][0] += (1 - p) * x[w][i][j];
                    xp[0][i][j] += p * x[w][i][j];
                } else {
                    if(i) xp[w][i - 1][j] += p * x[w][i][j];
                    else  xp[w][0][j] += p * x[w][i][j];
                    xp[0][i][j] += (1 - p) * x[w][i][j];
                }
            }
        }
    for(int w : {0, 1, 2})
        for(int i = 0; i <= n; i++)
            for(int j = 0; j <= n; j++)
                x[w][i][j] = xp[w][i][j];
}
const double eps = 1.0e-10;

int main()
{
    cin >> p >> n >> l >> r;
    x[0][l][r] = 1;
    double res = 0;
    for(int i = 1; i <= magic; i++) {
        transform();
        res += i * x[0][n][n];
        if(i >= 3 * n && i * x[0][n][n] < eps) break;
    }
    res += 20000 * x[0][n][n];
    cout << fixed << setprecision(13) << res << "\n";
    return 0;
}
