#include <bits/stdc++.h>

using namespace std;

const int VALMAX = 1e6;

int main() {
    int n, Q, a, r;
    cin >> n >> Q >> a;
    vector <int> v(n);
    vector <int> pos(1 + VALMAX);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        pos[v[i]] = i;
    }
    cin >> r;

    long long bestSum = 0;
    for (int i = 0; i < r; i++) 
        bestSum += 1LL * v[i] * a;

    vector <int> perm(n); iota(perm.begin(), perm.end(), 1);
    do {
        long long sum = 0;
        for (int i = 0; i < n; i++)
            sum += 1LL * abs(perm[i] - i - 1) * v[perm[i] - 1];
        for (int i = 0; i < r; i++)
            sum += 1LL * v[perm[i] - 1] * a;

        if (sum < bestSum)
            bestSum = sum;
    } while (next_permutation(perm.begin(), perm.end()));

    cout << bestSum << '\n';
    return 0;
}
