#include <bits/stdc++.h>

using namespace std;

int main() {
    int n, Q, a, r;
    cin >> n >> Q >> a;
    vector <int> v(n);
    set <vector <int>> vis;
    for (int i = 0; i < n; i++) cin >> v[i];
    cin >> r;

    long long bestSum = 0;
    for (int i = 0; i < r; i++) 
        bestSum += 1LL * v[i] * a;
    
    queue <pair <vector <int>, long long>> q;
    q.push(make_pair(v, bestSum));
    vis.insert(v);

    while (q.size()) {
        auto [vv, sum] = q.front();
        q.pop();

        if (sum <= bestSum)
            bestSum = sum;
        if (vis.find(vv) != vis.end())
            continue;
        
        vis.insert(vv);
        for (int i = 0; i < n - 1; i++) {
            swap(vv[i], vv[i + 1]);
            sum += vv[i] + vv[i + 1];

            if (i == r - 1) {
                sum += vv[i] * a;
                sum -= vv[i + 1] * a;
            }

            if (vis.find(vv) == vis.end())
                q.push(make_pair(vv, sum));
            
            if (i == r - 1) {
                sum -= vv[i] * a;
                sum += vv[i + 1] * a;
            }

            sum -= vv[i] + vv[i + 1];
            swap(vv[i], vv[i + 1]);
        }
    }

    cout << bestSum << '\n';
    return 0;
}

