#include <iostream>
#include <vector>
#include <map>

#define int long long

using namespace std;

const int INF = 1e18;

int n, q, a, r;
int v[9];

map <vector <int>, bool> mp;

int ans = INF;
int swap_cost = 0;

void bkt(int pas){
    vector <int> mask;
    for(int i = 1; i <= n; i++)
        mask.push_back(v[i]);

    if(mp[mask] == true){
        return;
    }

    mp[mask] = true;

    int prefix_sum = 0;
    for(int i = 1; i <= r; i++)
        prefix_sum += v[i];
    ans = min(ans, prefix_sum * a + swap_cost);

    for(int i = 1; i <= n - 1; i++){
        swap(v[i], v[i + 1]);
        swap_cost += (v[i] + v[i + 1]);
        bkt(pas + 1);
        swap(v[i], v[i + 1]);
        swap_cost -= (v[i] + v[i + 1]);
    }
}

signed main(){
    cin >> n >> q >> a;

    for(int i = 1; i <= n; i++)
        cin >> v[i];

    cin >> r;

    bkt(1);

    cout << ans << '\n';

    return 0;
}
