#include <iostream>
#include <vector>
#include <map>

#define int long long

using namespace std;

const int INF = 1e18;
const int NMAX = 8;

int n, q, a, r;
int v[NMAX + 1];
int prefix[NMAX + 1];

signed main(){
    cin >> n >> q >> a;

    for(int i = 1; i <= n; i++){
        cin >> v[i];
        prefix[i] = prefix[i - 1] + v[i];
    }

    cin >> r;

    int ans = INF;

    for(int mask = 0; mask < (1 << n); mask++){
        if(__builtin_popcount(mask) == r){
            int tmp = 0;
            int prev = 0;
            int cnt = 0;
            for(int i = 1; i <= n; i++){
                if(mask & (1 << (i - 1))){
                    tmp += (i - 1 - cnt) * v[i] + prefix[i - 1] - prev;
                    prev += v[i];
                    cnt++;
                }
            }
            tmp += prev * a;
            ans = min(ans, tmp);
        }
    }

    cout << ans << '\n';

    return 0;
}

/*
8 1 5
8 7 6 5 4 3 2 1
1
*/
