#include <iostream>

#define int long long

#define pii pair <int, int>
#define all first
#define sum second

using namespace std;

const int NMAX = 5010;
const int INF = 1e18;

int n, q, a, r;
int v[NMAX + 1];
int prefix[NMAX + 1];

pii dp[NMAX + 1][NMAX + 1];
pii e[NMAX + 1][NMAX + 1];

signed main(){

    cin >> n >> q >> a;

    for(int i = 1; i <= n; i++){
        cin >> v[i];
        prefix[i] = prefix[i - 1] + v[i];
    }

    cin >> r;

    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= i; j++){
            if(i == j){
                dp[i][j] = {prefix[i] * a, prefix[i]};
                e[i][j] = {prefix[i] * a, prefix[i]};
            }else{
                e[i][j] = e[i - 1][j];
                if(e[i - 1][j - 1].all + v[i] * a + prefix[i - 1] - e[i - 1][j - 1].sum + v[i] * (i - 1 - (j - 1)) - e[i - 1][j - 1].sum < e[i][j].all - e[i][j].sum){
                    e[i][j].all = e[i - 1][j - 1].all + v[i] * a + prefix[i - 1] - e[i - 1][j - 1].sum + v[i] * (i - 1 - (j - 1));
                    e[i][j].sum = e[i - 1][j - 1].sum + v[i];
                }

                dp[i][j] = dp[i - 1][j];
                if(e[i - 1][j - 1].all + v[i] * a + prefix[i - 1] - e[i - 1][j - 1].sum + v[i] * (i - 1 - (j - 1)) < dp[i][j].all){
                    dp[i][j].all = e[i - 1][j - 1].all + v[i] * a + prefix[i - 1] - e[i - 1][j - 1].sum + v[i] * (i - 1 - (j - 1));
                    dp[i][j].sum = e[i - 1][j - 1].sum + v[i];
                }
            }
        }
    }

    cout << dp[n][r].all << '\n';

    return 0;
}
