#include <iostream>
#include <vector>
#include <stack>

using namespace std;

const int NMAX = 22;
const int INF = 1e9;

struct request{
    int level1;
    int level2;
}req[NMAX + 1];

vector <int> pos[NMAX + 1];

int n, k;
int v[NMAX + 1];

int ans = INF;

stack <int> S[NMAX + 1];

int tmp = 0;

void bkt(int pas){
    if(tmp > ans)
        return;

    if(pas == n + 1){
        ans = min(ans, tmp);
        return;
    }

    for(int i = 1; i <= k; i++){
        v[pas] = i;
        int sub = 0;
        if(!S[i].empty()){
            sub = abs(S[i].top() - req[pas].level1);
            tmp += sub;
        }
        S[i].push(req[pas].level2);
        bkt(pas + 1);
        tmp -= sub;
        S[i].pop();
    }
}

int main(){

    cin >> n >> k;

    for(int i = 1; i <= n; i++)
        cin >> req[i].level1 >> req[i].level2;

    bkt(1);

    cout << ans << '\n';

    return 0;
}
