#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <numeric>

using ll = long long;

int const nmax = 8;
int v[1 + nmax];


int main() {
  int n, q, coef;
  std::cin >> n >> q >> coef;
  for(int i = 1;i <= n; i++)
    std::cin >> v[i];
  int lim;
  std::cin >> lim;

  std::vector<int> id(n);
  std::iota(id.begin(), id.end(), 1);
  bool first = true;
  ll answer = 0;
  do {
    ll result = 0;
    for(int i = 0; i < lim; i++)
      result += v[id[i]] * coef;
    for(int i = 0; i < n; i++)
      for(int j = i + 1; j < n; j++)
        if(id[j] < id[i])
          result += v[id[i]] + v[id[j]];
    if(first == true || result < answer) {
      answer = result;
    }
    first = false;
  } while(std::next_permutation(id.begin(), id.end()));
  std::cout << answer<< '\n';
  return 0;
}
