#include <bits/stdc++.h>

using namespace std;

#define int long long
const int NMAX = 1e6 + 78;
int64_t sp[NMAX], v[NMAX];
int N, A;

int64_t prefix_right, suffix_left;
struct Prefix {
    struct PrefixElem {
        int64_t sum_right, last_right, position, value;

        void update(int64_t cnt_right) {
            sum_right += sp[cnt_right] - sp[last_right];
            last_right = cnt_right;
        }

        int64_t get_value() const {
            // update(prefix_right);
            return sum_right + sp[prefix_right] - sp[last_right] + (prefix_right - position) * value - A * value;
        }

        bool operator<(const PrefixElem& oth) const {
            if(get_value() == oth.get_value()) return position < oth.position;
            // update(prefix_right); oth.update(prefix_right);
            return get_value() < oth.get_value();
        }

        void prt() {
            // update(prefix_right);
            cerr << sum_right << " " << last_right << " " << position << " " << value << endl;
            cerr << "GV: " << get_value() << endl;
        }
    };

    set<PrefixElem> s;
    int64_t sum_v = 0;
    int64_t sum_v_2 = 0;

    void insert_elem(int value, int position) {
        s.insert({0, position, position, value});
        sum_v += value; sum_v_2 += value * value;
    }
};
Prefix pr;

struct Suffix {
    struct SuffixElem {
        int64_t sum_left, last_left, position, value;

        int64_t get_value() const {
            return sum_left - (sp[suffix_left - 1] - sp[last_left - 1]) + A * value + (position - suffix_left) * A;
        }

        bool operator<(const SuffixElem& oth) const {
            if(get_value() == oth.get_value()) return position < oth.position;
            return get_value() < oth.get_value();
        }

        void prt() {
            cerr << sum_left << " " << last_left << " " << position << " " << value << endl;
            cerr << "GV: " << get_value() << endl;
        }
    };

    set<SuffixElem> s;
    int64_t sum_v = 0;
    int64_t sum_v_2 = 0;
    void insert_elem(int value, int position) {
        s.insert({0, position, position, value});
        sum_v += value; sum_v_2 += value * value;
    
        // for(auto e : s) e.prt();
    }

    void erase_elem(int value, int position) {
        s.erase({0, position, position, value});
        sum_v -= value; sum_v_2 -= value * value;
    }   
}; Suffix sf;

int64_t comb() {
    auto it_sf = sf.s.begin();
    auto it_pr = pr.s.begin();

    int64_t init_sum = 0;
    for(auto e : pr.s) init_sum += e.value * A;
    int64_t best_sum = init_sum;
    int64_t part_sum = init_sum;

    int64_t sf_v = 0, sf_v2 = 0;
    int64_t pr_v = 0, pr_v2 = 0;
    int64_t transfer = 0;

    while(it_sf != sf.s.end() && it_pr != pr.s.end()) {
        transfer += 1;
        sf_v += it_sf->value; sf_v2 += it_sf->value * it_sf->value;
        pr_v += it_pr->value; pr_v2 += it_pr->value * it_pr->value;

        part_sum += it_sf->get_value() + it_pr->get_value();
        best_sum = min(best_sum, part_sum + transfer * (sf_v + pr_v) - (sf_v * sf_v - sf_v2) / 2 - (pr_v * pr_v - pr_v2) / 2); 
        it_sf++; it_pr++;
    }

    return best_sum;
}

int64_t pre_rec[NMAX];
int32_t main()
{
    #ifdef LOCAL
        cerr << "Compiled!" << endl;
    #endif // LOCAL;

    prefix_right = 0;
    int q; cin >> N >> q >> A;
    for(int i = 1; i <= N; i++) {
        cin >> v[i]; sp[i] = sp[i - 1] + v[i];
    }
    for(int i = 1; i <= N; i++) {
        sf.insert_elem(v[i], i);
    }

    for(int i = 1; i <= N; i++) {
        prefix_right = i; suffix_left = i + 1;
        sf.erase_elem(v[i], i);
        pr.insert_elem(v[i], i);
        // cerr << "Inserted!" << endl;

        #ifdef LOCAL
        cerr << "Solve: " << i << " " << comb() << endl;
        #endif // LOCAL
        pre_rec[i] = comb();
    }

    while(q--) {
        int R; cin >> R;
        cout << pre_rec[R] << '\n';
    }

    return 0;
}
