#include <bits/stdc++.h>
using namespace std;
int n, l, r;
using ld = long double; // TODO
const int NR_PROPAGARI = 1000;
const int PRECIZIE = 500;
const int MN = 171;
const double INF = 1e9;
double p;
double E[MN][MN], EN[MN][MN];
int main() {
    cin >> p >> n >> l >> r;
    for(int i = 0; i <= n + 1; ++i)
        for(int j = 0; j <= n + 1; ++j)
            E[i][j] = INF;
    E[n][n] = 0;
    double difp = 1. - p;
    for(int t = 1; t <= NR_PROPAGARI; ++t) {
        for(int i = 0; i <= n; ++i)
            for(int j = 0; j <= n; ++j)
                EN[i][j] = 0.;
        for(int i = 0; i <= n; ++i) {
            for(int j = 0; j <= n; ++j) {
                double v1 = 0.;
                double v2 = 0.;
                double prob;

                v1 += (E[i][j + 1] + 1) * difp;
                prob = p * p;
                for(int nr_fail = 0; nr_fail < PRECIZIE; ++nr_fail) {
                    v1 += (E[max(i - nr_fail, 0)][j] + nr_fail + 2) * prob; 
                    prob *= difp;
                }

                v2 += (E[i + 1][j] + 1) * p;
                prob = difp * difp;
                for(int nr_fail = 0; nr_fail < PRECIZIE; ++nr_fail) {
                    v2 += (E[i][max(0, j - nr_fail)] + 2 + nr_fail) * prob;
                    prob *= p;
                }
             //   if(t == NR_PROPAGARI) {
             //       printf("pt i=%d j=%d avem v1=%lf  v2=%lf\n", i, j, v1, v2);
             //   }

                EN[i][j] = min(v1, v2);
            }
            //i = j
            EN[i][i] = 1 + p * E[i + 1][i] + difp * E[i][i + 1];
        }
        EN[n][n] = 0;
        for(int i = 0; i <= n; ++i)
            for(int j = 0; j <= n; ++j)
                E[i][j] = min(EN[i][j], INF);
 //       //i == n;
 //       for(int j = 0; j < n; ++j) {
 //           EN[n][j] += (E[n][j + 1] + 1) * difp;
 //           double prob = p * p;
 //           for(int nr_fail = 0; nr_fail < PRECIZIE; ++nr_fail) {
 //               EN[n][j] += (E[max(n - nr_fail, 0)][j] + nr_fail + 2) * prob; 
 //               prob *= difp;
 //           }
 //       }
 //       //j == n;
 //       for(int i = 0; i < n; ++i) {
 //           EN[i][j] += (E[i + 1][j] + 1) * p;
 //           double prob = difp * difp;
 //           for(int nr_fail = 0; nr_fail < PRECIZIE; ++nr_fail) {
 //               EN[i][j] += (E[i][max(0, j - nr_fail)] + 2 + nr_fail) * prob;
 //               prob *= p;
 //           }
 //       }
    }
    cout << fixed << setprecision(12) << E[l][r] << "\n";


    return 0;
}
