#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = 50000 + 7;
const ll INF = (ll) 1e18 + 7;
int n;
int q;
ll coef;
ll sol[N];

struct T
{
    int i;
    ll a;
    ll s;
    ll eval(int k)
    {
        return a * (coef + i - k) + s;
    }
};

T ord[N];

void algosort(int k)
{
    while (1)
    {
        bool change = 0;
        for (int i = 1; i < n; i++)
        {
            if (ord[i + 1].eval(k) < ord[i].eval(k))
            {
                swap(ord[i], ord[i + 1]);
                change = 1;
            }
        }
        if (!change)
        {
            break;
        }
    }
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

   // freopen ("input.txt", "r", stdin);


    cin >> n >> q >> coef;
    ll cs = 0;
    ll as = 0;
    for (int i = 1; i <= n; i++)
    {
        cin >> as;
        ord[i] = {i, as, cs};
        cs += as;
    }
    for (int k = 1; k <= n; k++)
    {
        algosort(k);
        sol[k] = 0;
        for (int i = 1; i <= k; i++)
        {
            sol[k] += ord[i].eval(k);
        }
    }
    for (int iq = 1; iq <= q; iq++)
    {
        int k;
        cin >> k;
        cout << sol[k] << "\n";
    }


    return 0;
}
