#include <bits/stdc++.h>

using namespace std;

typedef long double ld;

const int N = 35 + 7;
ld dp[N][N][3];
ld p1;
ld p2;
int n;
int init1;
int init2;

void minup(ld &a, ld b)
{
    a = min(a, b);
}

void relax(int i, int j, int type)
{
    assert(0 <= type && type <= 2);
    /// backspace
    if (type == 1)
    {
        minup(dp[i][j][1], 1 + p1 * dp[i][j][0] + p2 * dp[i][max(0, j - 1)][1]);
    }
    if (type == 2)
    {
        minup(dp[i][j][2], 1 + p1 * dp[max(0, i - 1)][j][2] + p2 * dp[i][j][0]);
    }
    /// place same char
    if (i == j)
    {
        if (i + 1 <= n)
        {
            minup(dp[i][j][0], 1 + p1 * dp[i + 1][j][0] + p2 * dp[i][j + 1][0]);
        }
    }
    else  /// place different char
    {
        /// place char i
        if (i + 1 <= n)
        {
            minup(dp[i][j][0], 1 + p1 * dp[i + 1][j][0] + p2 * dp[i][j][2]);
        }
        /// place char j
        if (j + 1 <= n)
        {
            minup(dp[i][j][0], 1 + p1 * dp[i][j][1] + p2 * dp[i][j + 1][0]);
        }
    }

}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    ///freopen ("input.txt", "r", stdin);
    cin >> p1;
    p2 = 1 - p1;
    cin >> n >> init1 >> init2;
    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j < N; j++)
        {
            for (int k = 0; k <= 2; k++)
            {
                dp[i][j][k] = (ld) 1e40;
            }
        }
    }
    dp[n][n][0] = 0;
    for (int step = 1; step <= (int) 1e6; step++)
    {
        for (int i = 0; i <= n; i++)
        {
            for (int j = 0; j <= n; j++)
            {
                for (int k = 0; k <= 2; k++)
                {
                    relax(i, j, k);
                }
            }
        }
        if (step != (int) 1e4)
        {
            continue;
        }

    }
    cout << fixed << setprecision(20) << dp[init1][init2][0] << "\n";

    return 0;
}
