#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

mt19937 rng(7777);

const int N = 22;
int n;
int k;
bool is[N];
int in[N];
int out[N];
int ord[N];

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    //freopen ("input.txt", "r", stdin);
    cin >> n >> k;
    for (int i = 0; i < n; i++)
    {
        cin >> in[i] >> out[i];
        ord[i] = i;
    }
    ll best = (ll) 1e18 + 7;
    for (int step = 1; step <= (int) 1e5; step++)
    {
        shuffle(ord, ord + n, rng);
        for (int i = 0; i < n; i++)
        {
            is[ord[i]] = (i < k);
        }
        ll cost = 0;
        for (int i = 0; i < n; i++)
        {
            if (is[i])
            {
                continue;
            }
            int apr = -1;
            for (int j = 0; j < n; j++)
            {
                if (is[j])
                {
                    if (apr == -1 || abs(out[apr] - in[i]) > abs(out[j] - in[i]))
                    {
                        apr = j;
                    }
                }
            }
            assert(apr != -1);
            cost += abs(out[apr] - in[i]);
            is[i] = 1;
            is[apr] = 0;
        }
        best = min(best, cost);
    }
    cout << best << "\n";
    return 0;
}
