#include <bits/stdc++.h>

using namespace std;

typedef long long LL;

constexpr int NMAX = 5e3 + 2;
constexpr LL INF = 1LL * 1e17;

int N, Q, A;

int V[NMAX];

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> Q >> A;

    for (int i = 1; i <= N; ++ i )
        cin >> V[i];
}

LL Init = 0;
LL cost[NMAX];
LL sp[NMAX];

bool ComputeCost (int R) {
    for (int i = 1; i <= N; ++ i )
        sp[i] = sp[i-1] + V[i];

    for (int i = 1; i <= R; ++ i )
        cost[i] = 1LL * V[i] * (R - i + 1) + (sp[R] - sp[i]) - A * V[i];

    for (int i = R+1; i <= N; ++ i )
        cost[i] = 1LL * V[i] * (i - R) + (sp[i-1] - sp[R]) + A * V[i];

    LL Min_st = INF, Min_dr = INF;
    int poz_st = 0, poz_dr = N+1;
    for (int i = 1; i <= R; ++ i ) {
        Min_st = min(Min_st, cost[i]);
        if (cost[i] == Min_st) {
            poz_st = i;
        }
    }
    for (int i = R+1; i <= N; ++ i ) {
        Min_dr = min(Min_dr, cost[i]);
        if (Min_dr == cost[i]) {
            poz_dr = i;
        }
    }

    if (Min_st + Min_dr >= 0) return false;

    Init += (Min_st + Min_dr);

    for (int i = poz_st; i < R; ++ i )
        swap(V[i], V[i+1]);
    for (int i = poz_dr-1; i >= R; -- i )
        swap(V[i], V[i+1]);

    return true;
}

void Solve () {
    assert(Q == 1);
    int R;
    cin >> R;

    for (int i = 1; i <= R; ++ i )
        Init += 1LL * V[i] * A;

    while (ComputeCost(R));

    cout << Init << '\n';
}

int main () {
    Read();
    Solve();

    return 0;
}
