#include <bits/stdc++.h>

using namespace std;

typedef long long LL;

constexpr int NMAX = 1e6 + 5;
constexpr LL INF = 1LL * 1e17;

int N, Q;
LL A;
LL V[NMAX];

LL cop_V[NMAX];

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> Q >> A;

    for (int i = 1; i <= N; ++ i ) {
        cin >> V[i];
        cop_V[i] = V[i];
    }
}

LL Init = 0;
LL cost[NMAX];
LL sp[NMAX];
int R;

LL ans = 0;
LL sol = 0;

void ComputeCost () {
    for (int i = 1; i <= N; ++ i )
        V[i] = cop_V[i];

    ans = 0;
    for (int i = 1; i <= R; ++ i )
        ans += 1LL * V[i] * A;

    for (int mask_l = 0; mask_l < (1<<R); ++ mask_l ) {
        int k_l = __builtin_popcount(mask_l);
        for (int mask_r = 0; mask_r < (1<<(N-R)); ++ mask_r ) {
            int k_r = __builtin_popcount(mask_r);

            if (k_l != k_r) continue;

            sol = 0;
            LL s_L = 0, s_R = 0;

            for (int i = 1; i <= N; ++ i )
                V[i] = cop_V[i];

            int contor = 0;
            for (int j = R-1; j >= 0; -- j ) {
                if ((mask_l&(1<<j)) == 0) continue;

                s_L += V[j+1];

                for (int i = j+2; i <= R - contor; ++ i ) {
                    swap(V[i], V[i-1]);
                    sol += (V[i] + V[i-1]);
                }

                ++ contor;
            }

            contor = 0;
            for (int j = 0; j < N-R; ++ j ) {
                if ((mask_r&(1<<j)) == 0) continue;

                s_R += V[R+1+j];
                for (int i = R+1+j; i > R+1; -- i ) {
                    swap(V[i], V[i-1]);
                    sol += (V[i] + V[i-1]);
                }

                ++ contor;
            }

            sol += 1LL * k_l * (s_L + s_R);

            for (int i = 1; i <= R-k_l; ++ i )
                sol += 1LL * A * V[i];
            sol += 1LL * A * s_R;

            ans = min(ans, sol);
        }
    }

    cout << ans << '\n';
}

void Solve () {
    assert(Q == 1);
    cin >> R;

    ComputeCost();
}

int main () {
    Read();
    Solve();

    return 0;
}
