#include <bits/stdc++.h>

using namespace std;
typedef long double ld;

const int N_MAX = 15;
const int M_MAX = (N_MAX + 1) * (N_MAX + 1) * 3;
const int K_MAX = M_MAX;
const ld INF = INT_MAX;

const ld EPS = 0.000000001;

int L, R, N;
ld P;

int ok (int i, int j) {
    return i * (N + 1) + j;
}
int brL (int i, int j) {
    return (N + 1) * (N + 1) + i * (N + 1) + j;
}
int brR (int i, int j) {
    return 2 * (N + 1) * (N + 1) + i * (N + 1) + j;
}
int K, M;

ld coef[K_MAX][M_MAX + 1];
int pos[K_MAX];

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(12);

    cin >> P >> N >> L >> R;
    swap(L, R);
    M = (N + 1) * (N + 1) * 3 + 1;
    for (int l = 0; l <= N; l++) {
        for (int r = 0; r < l; r++) {
            coef[K][ok(l, r)] += -1;
            coef[K][ok(l, r + 1)] += P;
            coef[K][brL(l, r)] += 1 - P;
            coef[K][M] += 1;
            K++;
        }
        for (int r = l + 1; r <= N; r++) {
            coef[K][ok(l, r)] += -1;
            coef[K][ok(l + 1, r)] += 1 - P;
            coef[K][brR(l, r)] += P;
            coef[K][M] += 1;
            K++;
        }
    }
    for (int i = 0; i < N; i++) {
        coef[K][ok(i, i)] += -1;
        coef[K][ok(i, i + 1)] += P;
        coef[K][ok(i + 1, i)] += 1 - P;
        coef[K][M] += 1;
        K++;
    }
    coef[K][ok(N, N)] += -1;
    K++;
    for (int l = 0; l <= N; l++) {
        for (int r = 0; r <= N; r++) {
            coef[K][brL(l, r)] += -1;
            coef[K][brL(l, max(0, r - 1))] += P;
            coef[K][ok(l, r)] += 1 - P;
            coef[K][M] += 1;
            K++;
            coef[K][brR(l, r)] += -1;
            coef[K][brR(max(0, l - 1), r)] += 1 - P;
            coef[K][ok(l, r)] += P;
            coef[K][M] += 1;
            K++;
        }
    }

    for (int k = 0; k < K; k++) {
        pos[k] = 0;
        while (pos[k] <= M && abs(coef[k][pos[k]]) < EPS) {
            pos[k]++;
        }
        if (pos[k] <= M) {
            for (int k1 = 0; k1 < K; k1++) {
                if (k != k1 && coef[k1][pos[k]] != 0) {
                    ld c = -coef[k1][pos[k]] / coef[k][pos[k]];
                    for (int i = 0; i <= M; i++) {
                        coef[k1][i] += coef[k][i] * c;
                    }
                }
            }
        }
    }
    for (int k = 0; k < K; k++) {
        if (pos[k] == ok(L, R)) {
            cout << -coef[k][M] / coef[k][ok(L, R)] << "\n";
            break;
        }
    }

    return 0;
}
