#include "bits/stdc++.h"
#define ll long long
using namespace std;
const ll mod = 1000000007;

int dsu[10001], rnk[10001];

int find(int x) {
    if(dsu[x] == x)
        return x;
    return dsu[x] = find(dsu[x]);
}

void unite(int x, int y) {
    if(rnk[x] < rnk[y])
        swap(x, y);
    rnk[x]++;
    dsu[y] = x;
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n, k;
    cin >> n >> k;
    for(int i = 0; i < n; i++)
        dsu[i] = i;
    int a[n], b[n];
    for(int i = 0; i < n; i++)
        cin >> a[i] >> b[i];
    vector<pair<pair<int, int>, ll>> v;
    for(int i = 0; i < n; i++) {
        for(int j = i + 1; j < n; j++)
            v.push_back({{i, j}, abs(b[i] - a[j])});
    }
    sort(v.begin(), v.end());
    int sz = v.size();
    ll ans = 0;
    bool bb[n] = {};
    for(int i = 0; i < sz && n > k; i++) {
        int x = v[i].first.first, y = v[i].first.second;
        if(bb[x] || find(x) == find(y))
            continue;
        bb[x] = 1;
        unite(x, y);
        n--;
        ans += v[i].second;
    }
    cout << ans;

    return 0;
}
