#include <bits/stdc++.h>
#define ll long long
#define pb push_back
#define all(v) v.begin(), v.end()
#define sp ' '
#define en '\n'
#define pv(v) for (auto x : v) cout << x << sp; cout << en;

using namespace std;

const ll LINF = 4e18;
const int mxN = 1e6+10;
ll n, m, l[mxN], r[mxN];

ll BackTrack(int i, vector<ll> v){

    if (i == n) return 0;
    ll ans = LINF;
    if (v.size() < m){
        v.pb(r[i]);
        ans = BackTrack(i+1, v);
        v.pop_back();
    }
    for (int j = 0; j < v.size(); j++){
        ll cur = abs(v[j] - l[i]);
        ll t = v[j];
        v[j] = r[i];
        cur += BackTrack(i+1, v);
        v[j] = t;
        ans = min(ans, cur);
    }
    return ans;
}

int main(){

    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i];
    cout << BackTrack(0, {}) << en;

    return 0;
}

