#include <bits/stdc++.h>

#define ll long long

using namespace std;

bool isSorted(ll arr[], int n) {

    for(int i = 0; i < n - 1; i++)
        if(arr[i] > arr[i + 1])
            return false;
    return true;
}

ll calc(ll dest[], ll src[], int n, ll a, int r) {

    ll ans = 0;
    for(int i = 0; i < n; i++) {
        int j;
        for(j = 0; j < n; j++)
            if(src[j] == dest[i])
                break;
        for(int l = j; l > i; l--) {
            swap(src[l], src[l - 1]);
            ans += src[l] + src[l - 1];
        }
    }

/*
cout << "----" << endl;
for(int i = 0; i < n; i++) { if(src[i] != dest[i]) cout << "L"; cout << dest[i] << " "; } cout << endl;
cout << ans << endl;
*/

    for(int i = 0; i < r; i++)
        ans += dest[i] * a;
// cout << ans << endl;
    return ans;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, q, r;
    ll a;
    cin >> n >> q >> a;

    ll arr[n], org[n];
    for(int i = 0; i < n; i++) {
        cin >> arr[i];
        org[i] = arr[i];
    }
    sort(arr, arr + n);
    cin >> r;

    ll ans = LLONG_MAX;
    do {
        ll copy[n];
        for(int i = 0; i < n; i++)
            copy[i] = org[i];
        ans = min(ans, calc(arr, copy, n, a, r));
        next_permutation(arr, arr + n);
    } while(!isSorted(arr, n));
    cout << ans << endl;
    return 0;
}
