#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef ld __f128;

const ll mod=1e9+7;


ll bpow(ll a,ll b){
    ll res=1;
    while(b){
        if(b&1) res*=a;
        a*=a;a%=mod;
        res%=mod;
        b>>=1;
    }
    return res;
}   
vector<ll> fact,inv;


void solve(){
    cout<<fixed<<setprecision(12)<<endl;
    ld p;cin>>p;   
    int n,l,r;cin>>n>>l>>r;
    fact.resize(max(n+100,(int)1e5+100),1),
    inv.resize(max(n+100,(int)1e5+100));

    for(ll i =1;i<fact.size();i++){
        fact[i] = fact[i-1]*i;
        fact[i]%=mod;
        inv[i] = bpow(fact[i],mod-2);
    }

    ld ans=(n-l)*powf128(p,n-l) + (n-r)*powf128(p,n-r);
    
    for(int i=2;i<=1e5;i+=2){
        ans+=(n-l+i)*powf128(p,n-l) * powf128(1-p,i)*
        (((fact[n-l+i]*inv[n-l])%mod* inv[i])%mod);
    }
    for(int i=2;i<=1e5;i+=2){
        ans+=(n-r+i)*powf128(p,n-r) * powf128(1-p,i)*
        (((fact[n-r+i]*inv[n-r])%mod* inv[i])%mod);
    }
    cout<<ans<<endl;
}


int main(){
    ios_base::sync_with_stdio(0),cin.tie(0); 
    int t=1;//cin>>t;
    while(t--) solve();
}

/*
torej kaksna je moznost da mu uspe v n-l,
n-l+2 etc korakih, saj mora usako napako popravt


*/