#include <iostream>
#include <vector>

using namespace std;

int calculate(int n, int a, int r, vector<int> &v, int i, int c) {
	// If i == n-1 => Calculate costs
	if (i == n-1) {
		int cc = 0;
		for (int j=0; j<r; j++) cc += v[j];
		cc *= a;
		return c + cc;
	}
	
	// Don't swap it => i++, c same
	int c1 = calculate(n, a, r, v, i+1, c);
	
	// Swap i-th with (i+1)-th => i++, cost += v_i+v_(i+1)
	swap(v[i], v[i+1]);
	int c2 = calculate(n, a, r, v, i+1, c + v[i] + v[i+1]);
	swap(v[i], v[i+1]);
	
	return min(c1, c2);
}

int main() {
	int n, q, a;
	cin >> n >> q >> a;
	
	vector<int> v(n);
	for (int i=0; i<n; i++) cin >> v[i];
	
	for (int i=0; i<q; i++) {
		int r; cin >> r;
		vector<int> v2(v);
		cout << calculate(n, a, r, v2, 0, 0) << "\n";
	}
}

