#include <iostream>
#include <utility>
#include <vector>
#include <cstdlib>
#include <cstring>


std::vector<std::pair<int, int>> connections;


int n, k;
int bruteforce(int depth, int movement, int* ks) {
    if(depth == n) {
        //std::cout << movement << std::endl;
        return movement;
    }
    int smallest = 1'999'999;
    bool minus = false;

    for(int x = 0; x < k; x++) {
        int m;
        if(ks[x] == -1) {
            if(minus) {
                continue;
            }
            minus = true;
            m = 0;
        } else {
            m = std::abs(ks[x] - connections[depth].first);
        }
        int tmp = ks[x];
        ks[x] = connections[depth].second;
        smallest = std::min(smallest, bruteforce(depth+1, movement+m, ks));
        ks[x] = tmp;
        //std::cout <<"-" <<smallest << std::endl;
    }
    return smallest;
}

int main(void) {
    std::cin >> n >> k;
    for(int x = 0; x < n; x++) {
        std::pair<int,int> tmp;
        std::cin >> tmp.first >> tmp.second;
        connections.push_back(tmp);
    }
    int* ks = (int*)malloc(sizeof(int) * k);
    for(int x = 0; x < k; x++) {
        ks[x] = -1;
    }
    std::cout << bruteforce(0, 0, ks) << std::endl;
}