#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#define int long long
using namespace std;

struct rebro{
    int z,v,w=1e18;
};

vector<rebro> G(500);
vector<bool> canz, canv;
int n,k, siz=0, done=0, res=1e18, res2=0;

bool comp (rebro a, rebro b){
    return a.w<b.w;
}

bool rec(int i){
    if (done==n-k){
        res=min(res, res2);
        return true;
    }
    if (res2+(n-k-done)*G[i].w>=res){
        return false;
    }
    for (; i<siz; ++i){
        if (res2+(n-k-done)*G[i].w>=res){
            return false;
        }
        if (canz[G[i].z] and canv[G[i].v]){
            canz[G[i].z]=false;
            canv[G[i].v]=false;
            ++done;
            res2+=G[i].w;
            res2-=G[i].w;
            canz[G[i].z]=true;
            canv[G[i].v]=true;
            --done;
        }
    }
    return true;
}

signed main(){
    cin>>n>>k;
//    G.resize(n);
    int z[n], v[n];
    for (int i=0; i<n; ++i){
//        G[i].resize(n,-1);
        cin>>z[i]>>v[i];
    }
    if (n==k){
        cout<<0;
        return 0;
    }
    for (int i=0; i<n; ++i){
        for (int j=i+1; j<n; ++j){
            G[siz]={i, j, abs(v[i]-z[j])};
            ++siz;
        }
    }
    sort(G.begin(), G.end(), comp);
    canz.resize(n,true);
    canv.resize(n,true);
    rec(0);
    cout<<res;
    return 0;
}
