#include <bits/stdc++.h>

#define ll long long int

using namespace std;

int main() {
    int n, nq, a; cin >> n >> nq >> a;
    int v[n];
    for(int i=0; i<n; ++i) {
        cin >> v[i];
    }
    int qs[nq];
    for(int i=0; i<nq; ++i) {
        cin >> qs[i];
    }

    for(int q : qs) {
        int total_cost = 0;
        while(true){
            int gains[n];
            for(int i=0; i<q; ++i) {
                gains[i] = a*(v[i]-v[q]);
            }
            for(int i=q; i<n; ++i) {
                gains[i] = a*(v[q-1]-v[i]);
            }
            int pref_sums[n];
            pref_sums[q-1] = v[q];
            for(int i=q-2; i>=0; --i) {
                pref_sums[i] = pref_sums[i+1] + v[i+1];
            }
            pref_sums[q] = v[q-1];
            for(int i=q+1; i<n; ++i) {
                pref_sums[i] = pref_sums[i-1] + v[i-1];
            }
            int costs[n];
            for(int i=0; i<n; ++i) {
                int dist = (i<q) ? q-i : i-q+1;
                costs[i] = dist*v[i] + pref_sums[i];
                //cout << gains[i] << " ";
            }
            //cout << "\n";

            int best_profit = -1;
            int b_ind = -1;
            for(int i=0; i<n; ++i) {
                int profit = gains[i] - costs[i];
                if(profit > best_profit) {
                    best_profit = profit;
                    b_ind = i;
                }
            }
            if(best_profit <= 0 || b_ind == -1) break;

            total_cost += costs[b_ind];
            if(b_ind < q) {
                int temp = v[b_ind];
                for(int i=b_ind; i<q; ++i) v[i] = v[i+1];
                v[q] = temp;

            } else {
                int temp = v[b_ind];
                for(int i=b_ind; i>=q; --i) v[i] = v[i-1];
                v[q-1] = temp;
            }
        }

        for(int i=0; i<q; ++i) total_cost += a*v[i];
        cout << total_cost << "\n";
    }
}
