#include <bits/stdc++.h>

using namespace std;

const long long INF = 1e18;

int main() {
    int n, Q, A; cin >> n >> Q >> A;
    vector<int> v(n), R(Q);
    vector<long long> vPsum(1+n);
    for (int i = 0; i < n; ++i) cin >> v[i], vPsum[i+1] = v[i]+vPsum[i];
    for (int &x : R) cin >> x;

    for (int q = 0; q < Q; ++q) {
        int r = R[q];
        int mx = max(r, n-r);
        vector<long long> best[2]{};
        best[0] = best[1] = vector<long long>(1+mx, INF);
        best[0][0] = best[1][0] = 0;

        // from left
        for (int i = 0; i < r; ++i) {
            int dist = r-1-i;
            for (int already = mx-1; already >= 0; --already) {
                long long cost = v[i] * (dist - A + already+1 - already) + (vPsum[r] - vPsum[i+1]);
                best[0][already+1] = min(best[0][already+1], best[0][already] + cost);
                //cout << " left WITH  " << i << " already " << already << " cost " << cost << endl;
                //cout << " left AFTER " << i << " already " << already+1 << " is " << best[0][already+1] << endl;
            }
        }
        // from right
        for (int i = n-1; i >= r; --i) {
            int dist = i-r;
            for (int already = mx-1; already >= 0; --already) {
                long long cost = v[i] * (dist + A + already+1 - already) + (vPsum[i] - vPsum[r]);
                best[1][already+1] = min(best[1][already+1], best[1][already] + cost);
                //cout << " right WITH  " << i << " already " << already << " cost " << cost << endl;
                //cout << " right AFTER " << i << " already " << already+1 << " is " << best[1][already+1] << endl;
            }
        }

        long long minChange = 0;
        for (int cnt = 0; cnt <= mx; ++cnt) minChange = min(minChange, best[0][cnt] + best[1][cnt]);
        long long originalCost = vPsum[r]*A;
        cout << originalCost + minChange << '\n';
    }
    return 0;
}
