#include <bits/stdc++.h>

using namespace std;

int main() {
    int n, Q, A; cin >> n >> Q >> A;
    vector<long long> v(n), vPsum(1+n);
    for (int i = 0; i < n; ++i) cin >> v[i], vPsum[i+1] = v[i]+vPsum[i];
    vector<int> R(Q);
    for (int &x : R) cin >> x;

    for (int q = 0; q < Q; ++q) {
        int r = R[q];
        int mx = max(r, n-r);
        vector<long long> best[2]{};

        // from left
        for (int i = 0; i < r; ++i) {
            int dist = r-1-i;
            long long cost = v[i] * (dist - A + 1) + (vPsum[r] - vPsum[i+1]);
            best[0].push_back(cost);
        }
        sort(best[0].begin(), best[0].end());
        // from right
        for (int i = n-1; i >= r; --i) {
            int dist = i-r;
            long long cost = v[i] * (dist + A + 1) + (vPsum[i] - vPsum[r]);
            best[1].push_back(cost);
        }
        sort(best[1].begin(), best[1].end());

        long long minChange = 0;
        for (int i = 0; i < mx && best[0][i] + best[1][i] < 0; ++i) minChange += best[0][i] + best[1][i];
        long long originalCost = vPsum[r]*A;
        cout << originalCost + minChange << '\n';
    }
    return 0;
}
