#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define sz(c) (int)c.size()
#define all(c) c.begin(),c.end()
#define f first
#define s second

// O(n^2) is possible
// either move a lift or spawn a new one there
// I think this is also some dp thing
// could just do greedy matching but I think it would fail
// constraint on the number of lifts must be useful
// maybe something bitwise?
// a O(2^n) is possible for the first bit
// actually idk if this approach will run out of memory
// the 64mb limit seems a bit tight
// always best to greedily use the nearest lift?
const ll mxN = 22, mxK = min(30ll,mxN);
vector<pair<ll,ll> > a;
ll n, k, out = LONG_LONG_MAX;

// This is a multiset as there can be multiple lifts on the same
// floor together
multiset<ll> s;
void dfs(ll pos, ll cost, ll spare) {
	//cout << "pos: " << pos << " cost: " << cost << " spare: " << spare << "\n";
	if (pos == n) {
		out = min(out,cost);
		return;
	}
	if (spare) {
		s.insert(a[pos].s);
		dfs(pos+1, cost, spare-1);
		s.erase(s.find(a[pos].s));
	}

	if (sz(s)) {
		// This will find the first one that is later
		ll val = 0, dist = LONG_LONG_MAX;
		for (auto i = s.begin(); i != s.end(); i++) {
			if (abs(*i-a[pos].f) < dist) {
				dist = abs(*i-a[pos].f);
				val = *i;
			}
		}

		s.erase(s.find(val));
		s.insert(a[pos].s);
		dfs(pos+1, cost+dist, spare);
		s.erase(s.find(a[pos].s));
		s.insert(val);
	}
}

void solve() {
	cin >> n >> k;
	for (ll i = 0; i < n; i++) {
		ll l, r; cin >> l >> r;
		a.push_back({l,r});
	}

	dfs(0,0,k);

	cout << out << "\n";
}

int main() {
	//ios::sync_with_stdio(0);
	//cin.tie(0);

	solve();
}
