// Sega produlzhavame s nai hitoviq kiuchek ot djodji bend specialno za vsichki romi
// Kuicheka konya vihyr 2012
// Novata modifikaciq
// Aide Chochko
// Aide Vihyre
// Vlez
// Vlez Vihyre

#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <queue>
#include <map>

typedef long long llong;
const llong MAXN = 100000 + 10;
const llong INF  = 1e9;

llong n, q, c, r;
llong perm[MAXN];
std::pair <llong,llong> a[MAXN];
llong currAns;

inline void moveInside(llong pos)
{
    for (llong i = pos ; i > r ; --i)
    {
        currAns += a[i].second + a[i - 1].second;
        std::swap(a[i], a[i-1]);
    }
}

inline void moveOutside(llong pos)
{
    for (llong i = pos ; i <= r ; ++i)
    {
        currAns += a[i].second + a[i + 1].second;
        std::swap(a[i], a[i+1]);
    }
}

void solve()
{
    if (r == n)
    {
        llong ans = 0;
        for (llong i = 1 ; i <= n ; ++i)
        {
            ans += a[i].second * c;
        }

        std::cout << ans << '\n';
        return;
    }

    llong ans = 0;
    for (llong i = 1 ; i <= r ; ++i) ans += c * a[i].second;
    std::iota(perm + 1, perm + 1 + n, 1);
    do
    {
        std::sort(a + 1, a + 1 + n);
        currAns = 0;

        for (llong idx = 1 ; idx <= n ; ++idx)
        {
            llong currPos = perm[idx];
            for (llong i = 1 ; i <= n ; ++i)
            {
                if (a[i].first == currPos)
                {
                    if (i <= r) moveOutside(i);
                    else moveInside(i);
                    break;
                }
            }

            llong addToAns = 0;
            for (llong i = 1 ; i <= r ; ++i)
            {
                addToAns += c * a[i].second;
            }

            ans = std::min(ans, addToAns + currAns);
         }
    } while(std::next_permutation(perm + 1, perm + 1 + n));
    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n >> q >> c;
    for (llong i = 1 ; i <= n ; ++i)
    {
        a[i].first = i;
        std::cin >> a[i].second;
    }

    std::cin >> r;
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    read();
    solve();

    return 0;
}