// Sega produlzhavame s nai hitoviq kiuchek ot djodji bend specialno za vsichki romi
// Kuicheka konya vihyr 2012
// Novata modifikaciq
// Aide Chochko
// Aide Vihyre
// Vlez
// Vlez Vihyre

#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <queue>
#include <map>

typedef long long llong;
const int MAXN = 10000 + 10;
const int MAXK = 30 + 5;
const int INF  = 1e9;

int n, k;
int l[MAXN];
int r[MAXN];
int last[MAXK];
void solve()
{
    llong ans = 1LL * n * INF;
    for (int mask = 1 ; mask < (1 << n) ; mask += 2)
    {
        if (__builtin_popcount(mask) != k) continue;

        int cnt = 0;
        llong currAns = 0;
        for (int i = 1 ; i <= n ; ++i)
        {
            if (mask & (1 << i-1))
            {
                last[++cnt] = i;
            } else
            {
                int minIdx = -1;
                int currMin = INF;
                for (int j = 1 ; j <= cnt ; ++j)
                {
                    if (abs(r[last[j]] - l[i]) < currMin)
                    {
                        currMin = abs(r[last[j]] - l[i]);
                        minIdx = j;
                    }
                }

                currAns += currMin;
                last[minIdx] = i;
            }
        }

        ans = std::min(ans, currAns);
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n >> k;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> l[i] >> r[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    read();
    solve();

    return 0;
}