#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 10000 + 4;
const int MAXQ = 1e6+6;
const int MAXK = 0;
int dp[MAXN][MAXK];
int n, k;
pair <int, int> queries[MAXN];

long long rec(int p, vector <int> lifts)
{
    if (p == n+1)
    {
        return 0;
    }

    long long ret = 1e18;

    for (int i = 1; i <= k; i++)
    {
        if (lifts[i] != 0) ret += 0;

        vector <int> lifts_update = lifts;
        lifts_update[i] = queries[p].second;

        long long add = abs(lifts[i] - queries[p].first);
        if (lifts[i] == 0) add = 0;

        ret = min(ret, add + rec(p+1, lifts_update));
    }

    return ret;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;

    for (int i = 1; i <= n; i++)
        cin >> queries[i].first >> queries[i].second;

    long long ans = rec(1, vector <int> (k+1));

    cout << ans << endl;

    return 0;
}
/**

3 2
5 20
8 100
2 80

*/

