#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 10000 + 4;
const int MAXQ = 1e6+6;
const int MAXK = 0;
int dp[MAXN][MAXK];
int n, k;
pair <int, int> queries[MAXN];

vector <int> lifts;

long long rec(int p)
{
    if (p == n+1)
    {
        return 0;
    }

    long long ret = 1e18;

    for (int i = 1; i <= k; i++)
    {
        long long add = abs(lifts[i] - queries[p].first);
        if (lifts[i] == 0) add = 0;

        int prev = lifts[i];
        lifts[i] = queries[p].second;

        ret = min(ret, add + rec(p+1));

        lifts[i] = prev;

        if (lifts[i] == 0) break;
    }

    return ret;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;

    for (int i = 1; i <= n; i++)
        cin >> queries[i].first >> queries[i].second;

    lifts.resize(k+1);

    long long ans = rec(1);

    cout << ans << endl;

    return 0;
}
/**

3 2
5 20
8 100
2 80

19 3
1 2
3 4
5 6
7 8
9 10
11 12
13 14
15 16
17 18
19 20
21 22
23 24
25 26
27 28
29 30
23 24
25 26
27 28
29 30

*/

