#include <bits/stdc++.h>
#define MAXN 1000007
#define endl '\n'
using namespace std;
unsigned long long tree[MAXN*4], a[MAXN], n, q, A, p, mixi = 0, tek = 0;

void build(unsigned long long node, unsigned long long L, unsigned long long R)
{
    if(L == R)
    {
        tree[node] = a[L];
        return;
    }

    unsigned long long mid = (L+R)/2;

    build(node*2, L, mid);
    build(node*2+1, mid+1, R);

    tree[node] = tree[node*2] + tree[node*2+1];
}

void update(unsigned long long node, unsigned long long L, unsigned long long R, unsigned long long ind, unsigned long long st)
{
    if(L == R && R == ind)
    {
        a[node] = st;
        tree[node] = st;
        return;
    }

    unsigned long long mid = (L+R)/2;
    if(mid <= ind) return update(node*2, L, mid, ind, st);
    else return update(node*2+1, mid+1, R, ind, st);

    tree[node] = tree[node*2] + tree[node*2+1];
}

unsigned long long query(unsigned long long node, unsigned long long L, unsigned long long R, unsigned long long l, unsigned long long r)
{
    if(L > r || R < l) return 0;
    if(L >= l && R <= r) return tree[node];

    unsigned long long mid = (L+R)/2;
    unsigned long long s1 = query(node*2, L, mid, l, r);
    unsigned long long s2 = query(node*2+1, mid+1, R, l, r);

    return (s1+s2);
}
int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> q >> A;

    for(int i = 1; i <= n; i ++) cin >> a[i]; /// !!!! ot 1 do n, NE 0 do n-1
    build(1, 1, n);

    mixi = 0;
    for(int i = 0; i < q; i ++)
    {
        cin >> p;
        mixi = A*query(1,1,n,1,p);
        for(int j = 2; j <= n; j++)
        {
            tek = A*query(1, 1, n, j-p+1, j);

            if(tek < mixi)
            {
                tek += (p)*(query(1,1,n,1,j-p))+(j-p)*(query(1,1,n,j-p+1,j));
               // cout << (p) << "  1" << ", " << j-p << endl;
               // cout << (j-p+1) << "  " << j << ", " << j+p-1 << endl << endl;
                if(tek < mixi) mixi = tek;
            }
        }
        cout << mixi << endl;
    }
    return 0;
}
/*
4 1 6
4 1 2 3
2
*/
