#include <iostream>
#include <cstring>
#define endl '\n'
using namespace std;

const int MAXN = 5000;
const long long INF = 1e18;

int a[MAXN + 5];
pair<long long, long long> dp[MAXN + 5][MAXN + 5][2];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, q, x;
    cin >> n >> q >> x;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    int r;
    cin >> r;

    for (int i = 0; i <= n; ++ i)
    {
        for (int j = 0; j <= n; ++ j)
        {
            dp[i][j][0] = dp[i][j][1] = {INF, INF};
        }
    }

    dp[0][0][0] = {0, 0};
    long long ans = INF;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 0; j <= min(i, r); ++ j)
        {
            if (dp[i - 1][j][0].first < dp[i - 1][j][1].first) dp[i][j][0] = dp[i - 1][j][0];
            else if (dp[i - 1][j][0].first > dp[i - 1][j][1].first) dp[i][j][0] = dp[i - 1][j][1];
            else if (dp[i - 1][j][0].second < dp[i - 1][j][1].second) dp[i][j][0] = dp[i - 1][j][0];
            else dp[i][j][0] = dp[i - 1][j][1];
            dp[i][j][0].second += a[i];

            if (j > 0)
            {
                long long c1 = dp[i - 1][j - 1][0].first + (x + i - j) * a[i] + dp[i - 1][j - 1][0].second;
                long long c2 = dp[i - 1][j - 1][1].first + (x + i - j) * a[i] + dp[i - 1][j - 1][1].second;
                if (c1 < c2) dp[i][j][1] = {c1, dp[i - 1][j - 1][0].second};
                else if (c1 > c2) dp[i][j][1] = {c2, dp[i - 1][j - 1][1].second};
                else dp[i][j][1] = {c1, min(dp[i - 1][j - 1][0].second, dp[i - 1][j - 1][1].second)};
            }

            ///cout << i << " " << j << " " << dp[i][j][0].first << " " << dp[i][j][1].first << endl;

            if (j == r) ans = min(ans, min(dp[i][j][0].first, dp[i][j][1].first));
        }
    }

    cout << ans << endl;

    return 0;
}
