#include <iostream>
#include <cstring>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXN = 22;

int n, k;
int a[MAXN + 5], b[MAXN + 5];
long long dp[2][(1ll << (MAXN - 1)) + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> k;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i] >> b[i];
    }

    memset(dp, (long long)(1e18), sizeof(dp));

    dp[0][0] = 0;
    for (int i = 2; i <= n; ++ i)
    {
        dp[0][(1ll << (i - 2))] = abs(b[1] - a[i]);
    }

    int curr = 0;
    for (int i = 2; i <= n; ++ i)
    {
        curr ^= 1;

        for (int mask = 0; mask < (1ll << (n - 1)); ++ mask)
        {
            dp[curr][mask] = dp[curr ^ 1][mask];
        }

        for (int mask = 0; mask < (1ll << (n - 1)); ++ mask)
        {
            for (int j = i + 1; j <= n; ++ j)
            {
                if (mask & (1ll << (j - 2)))
                {
                    dp[curr][mask] = min(dp[curr][mask], (long long)(abs(b[i] - a[j])) + dp[curr ^ 1][mask ^ (1ll << (j - 2))]);
                }
            }
        }
    }

    long long ans = 1e18;
    for (int mask = 0; mask < (1ll << (n - 1)); ++ mask)
    {
        int cnt = 0;
        for (int i = 0; i < n - 1; ++ i)
        {
            if (mask & (1ll << i)) cnt++;
        }
        if (cnt == n - k) ans = min(ans, dp[curr][mask]);
    }

    cout << ans << endl;

    return 0;
}
