#include<bits/stdc++.h>
#define llong long long
#define endl "\n"
#define mkstate(a, b, c, d) {{a, b}, {c, d}}
#define state pair< pair<int, int>, pair<int, int> >
#define cl first.first
#define cr first.second
#define wl second.first
#define wr second.second

#define node pair<int, bool>
#define left 0
#define right 1
#define to first
#define prob second
using namespace std;
using ldouble = long double;

map<state, llong> nodes;
unordered_map<llong, state> rev;
llong node_count = 1;
vector<vector<node>> graph;
unordered_map<llong, bool> visited;

ldouble p, lp, rp;
llong n, l, r;

bool correct(const state& s)
{
    return s.cl == n && s.cr == n;
}

llong id(const state& given)
{
    if(nodes[given] != 0) return nodes[given];
    graph.emplace_back(0);
    rev[(nodes[given] = node_count++)] = given;
    return nodes[given];
}

void make_graph(const state& curr)
{
    if(correct(curr)) return;

    llong idx = id(curr);
    if(visited[idx]) return;

    visited[idx] = true;
    state next;

    if(curr.wl == 0 && curr.wr == 0)
    {
        if(curr.cl == curr.cr)
        {
            next = mkstate(curr.cl+1, curr.cr, 0, 0);
            graph[idx].emplace_back(id(next), left);
            make_graph(next);

            next = mkstate(curr.cl, curr.cr+1, 0, 0);
            graph[idx].emplace_back(id(next), right);
            make_graph(next);
        }
        else
        {
            if(curr.cl < n)
            {
                next = mkstate(curr.cl+1, curr.cr, 0, 0);
                graph[idx].emplace_back(id(next), left);
                make_graph(next);

                next = mkstate(curr.cl, curr.cr, 1, 0);
                graph[idx].emplace_back(id(next), left);
                make_graph(next);
            }
            if(curr.cr < n)
            {
                next = mkstate(curr.cl+1, curr.cr, 0, 0);
                graph[idx].emplace_back(id(next), right);
                make_graph(next);

                next = mkstate(curr.cl, curr.cr, 0, 1);
                graph[idx].emplace_back(id(next), right);
                make_graph(next);
            }
        }
    }
    else
    {
        if(curr.wl == 1)
        {
            next = mkstate(curr.cl, curr.cr, 0, 0);
            graph[idx].emplace_back(id(next), left);
            make_graph(next);

            next = mkstate(curr.cl, max(curr.cr-1, 0), 1, 0);
            graph[idx].emplace_back(id(next), right);
            make_graph(next);
        }
        else if(curr.wr == 1)
        {
            next = mkstate(curr.cl, curr.cr, 0, 0);
            graph[idx].emplace_back(id(next), right);
            make_graph(next);

            next = mkstate(max(curr.cl-1, 0), curr.cr, 0, 1);
            graph[idx].emplace_back(id(next), left);
            make_graph(next);
        }
    }
}

void solve()
{
    // 0.5 1 0 0
    cin >> p >> n >> l >> r;
    lp = p; rp = 1-p;

    graph.emplace_back(0);
    state init = mkstate(l, r, 0, 0);
    llong init_id = id(init);
    make_graph(init);
}

void test_graph()
{

}

int main()
{
    solve();
    test_graph();
    return 0;
}
