#include <iostream>
#include <vector>
#include <climits>
#define MAX_K 30
using namespace std;

int lifts[MAX_K];
vector <pair<int, int>> order;
int n, k;
long long minans=LONG_MAX;


void recursia(int index, long long curr, int ind)
{
    //cout << index << " " << curr << endl;
    if(curr>minans)
    {
        return;
    }
    if(index>0)
    {
        lifts[ind]=order[index-1].second;
    }
    if(index>=n)
    {
        //cout << "###" << minans << endl;
        if(minans>curr)
        {
            //cout << minans << endl;
            minans=curr;
        }
        return;
    }
    for(int i=0; i<k; i++)
    {
        if(lifts[i]==0)
        {

            recursia(++index, curr, i);
        }
        else
        {
            recursia(++index, (curr+(max(order[index].first,lifts[i])-min(order[index].first,lifts[i]))), i);
        }
    }
    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k;
    order.resize(n);
    int a, b;

    for(int i=0; i<n; i++)
    {
        cin >> a >> b;
        order[i]={a, b};
    }
    /*for(int i=0; i<n; i++)
    {
        cout << order[i].first << " " << order[i].second << endl;
    }*/
    recursia(0, 0, 0);
    cout << minans;




    return 0;
}

