#include <bits/stdc++.h>
using namespace std;

#define all(x) x.begin(), x.end()
#define dbg(x) cout << #x << " " << x << endl;
#define sz(x) (int)x.size()

const long long inf = 1e18;
long long n, q, A; 

void print(vector<long long>& a) {
  cout << "[ ";
  for(auto i: a) {
    cout << i << " ";
  }
  cout << "]";
  cout << endl;
}

int main() {
  cin >> n >> q >> A;
  vector<long long> a(n), b(n);
  for(int i = 0; i < n; i++) {
    cin >> a[i], b[i] = a[i];
  }
  sort(all(a));

  int query; cin >> query;

  long long pat = inf;
  do {
    long long answ = 0, si = 0;
    vector<long long> new_b = b;
    for(int i = 0; i < query; i++) {
      si += a[i];
      long long curr = a[i];
      int ind = -1;
      for(int j = i; j < n; j++) {
        if(new_b[j] == curr) {
          ind = j;
          break;
        } else {
          answ += new_b[j];
          answ += curr;
        }
      }

      for(int j = ind - 1; j >= i; j--) {
        swap(new_b[j], new_b[j + 1]);
      }
    }

    answ += si * A;
    pat = min(pat, answ);
  } while(next_permutation(all(a)));

  cout << pat << "\n";
  return 0;
}