#include <bits/stdc++.h>
using namespace std;

#define all(x) x.begin(), x.end()
#define dbg(x) cout << #x << " " << x << endl;
#define sz(x) (int)x.size()


void print(vector<long long>& a) {
  cout << "[ ";
  for(auto i: a) {
    cout << i << " ";
  }
  cout << "]";
  cout << endl;
}

void print(vector<bool>& a) {
  cout << "[ ";
  for(auto i: a) {
    cout << i << " ";
  }
  cout << "]";
  cout << endl;
}

const int N = 1e6 + 10;
const long long inf = 1e18;
long long n, q, A;
deque<int> t[N];

int main() {
  cin >> n >> q >> A;
  vector<long long> arr(n);

  set<pair<int, int>> deleted, curr;

  for(int i = 0; i < n; i++) {
    cin >> arr[i];
    t[arr[i]].push_back(i);
  }

  int query; cin >> query;
  long long already = 0, prefix = 0;
  for(int i = 0; i < query; i++) {
    long long s = 0, cnt = 0, min_cost = inf, min_add = 0, ind = -1;

    for(int j = i; j < n; j++) {
      long long curr_cost = cnt * arr[j] + s + already;
      long long cur_add = cnt * arr[j] + s;
      curr_cost += A * (prefix + arr[j]);
      for(auto k: deleted) {
        if(k.first > t[arr[j]].front()) {
          curr_cost -= k.second;
          curr_cost -= arr[j];

          //
          cur_add -= k.second;
          cur_add -= arr[j];
        }
      }

      if(curr_cost < min_cost) {
        min_cost = curr_cost;
        ind = j;
        min_add = cur_add;
      }

      cnt++;
      s += arr[j];
    }

    swap(arr[i], arr[ind]);
    deleted.insert({ind, arr[i]});
    t[arr[i]].pop_front();
    print(arr);
    if(i == query - 1) {
      cout << min_cost << endl;
      return 0;
    }
    already += min_add;
    prefix += arr[i];
  }

  return 0;
}