#include <iostream>
#include <algorithm>
#include <cmath>
#include <map>
#include <set>
#include <string>
#include <vector>
using namespace std;
#define ll long long
#define ld long double
#define pii pair<ll, ll>

const int N = 1e6 + 2;

ll n, q;
ll c;
ll a[N], r;
ll s[N];
ll prefA[N], prefB[N];

int main() {
	cin >> n >> q >> c;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	cin >> r;

	ll sum = 0;
	for (int i = 1; i <= r; i++) {
		sum += a[i];
	}
	if(r == n){
		cout << sum * c << endl;
		return 0;
	}

	s[r] = 0;
	for (int i = r - 1; i >= 1; i--) {
		s[i] = s[i + 1] + a[i + 1];
	}
	s[r + 1] = 0;
	for (int i = r + 2; i <= n; i++) {
		s[i] = s[i - 1] + a[i - 1];
	}
	//chisht a
	vector<ll> wa, wb;
	for (int i = 1; i <= r; i++) {
		ll val = s[i] + a[i] * (r - i + 1 - c);
		wa.push_back(val);
	}
	for (int i = r + 1; i <= n; i++) {
		ll val = s[i] + a[i] * (-r + i + c);
		wb.push_back(val);
	}

	sort(wa.begin(), wa.end());
	sort(wb.begin(), wb.end());
	prefA[1] = wa[0];
	prefB[1] = wb[0];
	for (int i = 2; i <= r; i++) {
		prefA[i] = prefA[i - 1] + wa[i - 1];
	}
	for (int i = 2; i <= n - r; i++) {
		prefB[i] = prefB[i - 1] + wb[i - 1];
	}
	ll ans = sum * c;
	for (int k = 1; k <= min(r, n - r); k++) {
		ll ansi = sum * c + prefA[k] + prefB[k];
		
		ans = min(ans, ansi);
	}
	cout << ans << endl;
	return 0;
}