#include <algorithm>
#include <cmath>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <vector>

using namespace std;

const int N = 5003;

int t, n, A;
long long a[N], p[N];
long long dp[N][N], mn[N][N];

void solve()
{
    int r;
    cin >> r;
    for (int i = 0; i < n; i++)
    {
        for (int k = 0; k < min(r, i + 1); k++)
        {
            dp[i][k] = a[i] * (A + (i - k) - (r - k - 1)) + p[i] + mn[i - 1][k - 1];
            mn[i][k] = i > k ? min(mn[i - 1][k], dp[i][k]) : dp[i][k];
            //cout << dp[i][k] << ' ';
        }
        //cout << endl;
    }
    cout << mn[n - 1][r - 1] << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> t >> A;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        if (i != 0)
            p[i] = p[i - 1] + a[i - 1];
    }
    while (t--)
        solve();
    return 0;
}