#include <algorithm>
#include <cmath>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <vector>

using namespace std;

const int N = 1000003;

int t, n, A;
long long a[N], p[N], c[N];
long long dp[N], mn[N];



void solve()
{
    int r;
    cin >> r;
    for (int i = 0; i < n; i++)
    {
        c[i] = a[i] * (A + i - r + 1) + p[i];
    }
    sort(c, c + n);
    long long ans = 0;
    for (int i = 0; i < r; i++)
    {
        ans += c[i];
    }
    cout << ans << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> t >> A;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        if (i != 0)
            p[i] = p[i - 1] + a[i - 1];
    }
    while (t--)
        solve();
    return 0;
}