#include <bits/stdc++.h>

using namespace std;

long long ans = 1e18;

int n, k;

void rec(vector<int> &lifts, int i, int j, vector<pair<int, int>> &v, long long cur_val){
    // cout << i << ' ' << j << ' ' << cur_val << endl;
    if(i == n) {
        ans = min(ans, cur_val);
        return;
    }
    for(int ii = 0; ii < j; ii++){
        int cur_lift = lifts[ii];
        lifts[ii] = v[i].second;
        rec(lifts, i + 1, j, v, cur_val + abs(cur_lift - v[i].first));
        lifts[ii] = cur_lift;
    }
    if(j != k){
        lifts[j] = v[i].second;
        rec(lifts, i + 1, j + 1, v, cur_val);
        lifts[j] = 0;
    }
}

long long solve(vector<pair<int, int>> &vp){

    vector<vector<long long>> dp(n + 1, vector<long long> (k + 1, 1e18));
//     vector<pair<int, int>> vp(n + 1);
    // for(int i = 1; i <= n; i++){
       // cin >> vp[i].first >> vp[i].second;
    // }
    vector<vector<multiset<long long>>> lifts(n + 1, vector<multiset<long long>> (k + 1));
    for(int i = 0; i <= k; i++) dp[0][i] = 0;
    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= k; j++){
            int lift = -1;
            int cur = -1;
            for(int tmp = j; tmp > 0; tmp--){
                long long d = dp[i][j];
                for(auto l : lifts[i - 1][tmp]){
                    if(dp[i][j] >= dp[i - 1][tmp] + abs(l - vp[i].first)){
                        dp[i][j] = dp[i - 1][tmp] + abs(l - vp[i].first);
                        lift = l;
                    }
                }
                if(dp[i][j] != d) cur = tmp;
            }
            if(dp[i][j] > dp[i - 1][j - 1]){
                dp[i][j] = dp[i -1][j - 1];
                lifts[i][j] = lifts[i - 1][j - 1];
                lifts[i][j].insert(vp[i].second);
            }
            else{
                if(cur == -1){
                    cout << 1 / 0 << endl;
                   return 0;
                }
                lifts[i][j] = lifts[i - 1][cur];
                if(lifts[i][j].find(lift) != lifts[i][j].end()){
                    lifts[i][j].erase(lifts[i][j].find(lift));
                }
                lifts[i][j].insert(vp[i].second);
            }
        }
    }
    for(int i = 0; i <= n; i++) {
        for(int j = 0; j <= k; j++){
            cout << dp[i][j] << ' ';
        }
        cout << endl;
    }
    return dp[n][k];
    // cout << dp[n][k] << endl;
}

int main(){
    cin >> n >> k;
    vector<pair<int, int>> v(n), vp(n + 1);
    for(int i = 0; i < n; i++){
        cin >> v[i].first >> v[i].second;
        vp[i + 1] = v[i];
    }
    vector<int> lift(k);
    rec(lift, 0, 0, v, 0);
    if(ans != solve(vp)) {
        cout << solve(vp) << " " << ans << endl;
        // cout << "HAZIV" << endl;

    }
}
