#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long double ld;

int dp[31][1001][1001];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector<pair<int, int>> s(n);
    vector<int> x;
    for (auto &[l, r] : s) {
        cin >> l >> r;
        x.push_back(l);
        x.push_back(r);
    }
    sort(x.begin(), x.end());
    x.erase(unique(x.begin(), x.end()), x.end());
    int m = (int)x.size();
    unordered_map<int, int> d;
    for (int i = 0; i < m; i++) {
        d[x[i]] = i;
    }
    for (auto &[l, r] : s) {
        l = d[l];
        r = d[r];
    }
    for (int j = 0; j <= k; j++) {
        for (int i = 0; i <= n; i++) {
            for (int t = 0; t < m; t++) {
                dp[j][i][t] = INT32_MAX;
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        dp[1][i][s[i - 1].second] = (i == 1 ? 0 : dp[1][i - 1][s[i - 2].second] + abs(x[s[i - 1].first] - x[s[i - 2].second]));
    }
    for (int j = 2; j <= k; j++) {
        for (int i = 2; i <= n; i++) {
            for (int t = 0; t < m; t++) {
                {
                    dp[j][i][t] = min(dp[j][i][t], dp[j - 1][i - 1][t]);
                    dp[j][i][s[i - 1].second] = min(dp[j][i][s[i - 1].second], dp[j - 1][i - 1][t] + abs(x[s[i - 1].first] - x[t]));
                }
                {
                    dp[j][i][s[i - 1].second] = min(dp[j][i][s[i - 1].second], dp[j][i - 1][t] + abs(x[s[i - 1].first] - x[t]));
                }
            }
        }
    }
    int ans = INT64_MAX;
    for (int j = 0; j <= k; j++) {
        for (int t = 0; t < m; t++) {
            ans = min(ans, dp[j][n][t]);
        }
    }
    cout << ans;
    return 0;
}
