#include <iostream>
#include <vector>

using namespace std;
#define int long long
const int INF = 1e15;

inline void solve() {
    int n, q, x;
    cin >> n >> q >> x;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    while (q--) {
        int r;
        cin >> r;
        int cur = 0;
        for (int i = 0; i < r; ++i) cur += a[i];
        vector <int> taken(n);
        cur *= x;
        int cha = 0, sum_left = 0, sum_right = 0;
        while (true) {
            int mn = INF, pos = -1, delta = 0;
            for (int i = 0; i < r; ++i) {
                if (taken[i]) continue;
                int now = -a[i] * x + a[i] * cha + sum_right;
                for (int j = 0; j < r; ++j) {
                    if (i == j) continue;
                    if (j < i) {
                        if (taken[j]) now -= a[i] + a[j];
                    } else {
                        if (!taken[j]) now += a[i] + a[j];
                    }
                }
                if (now < mn) {
                    mn = now;
                    pos = i;
                }
            }
            if (pos == -1) break;
            taken[pos] = 1;
            delta = mn;
            sum_left += a[pos];
            pos = -1;
            mn = INF;
            for (int i = r; i < n; ++i) {
                if (taken[i]) continue;
                int now = a[i] * x + a[i] * (cha + 1) + sum_left;
                for (int j = r; j < n; ++j) {
                    if (i == j) continue;
                    if (j > i) {
                        if (taken[j]) now -= a[i] + a[j];
                    } else {
                        if (!taken[j]) now += a[i] + a[j];
                    }
                }
                if (now < mn) {
                    mn = now;
                    pos = i;
                }
            }
            if (pos == -1) break;
            taken[pos] = 1;
            delta += mn;
            sum_right += a[pos];
            ++cha;
            if (delta < 0) {
                cur += delta;
            } else {
                break;
            }
        }
        cout << cur << "\n";
    }
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
}

/*
 4 1 5
 4 1 2 3
 2

4 1 6
4 1 2 3
2

 */