#include <iostream>
#include <vector>

using namespace std;
#define int long long
const int INF = 1e15;

inline void solve() {
    int n, q, x;
    cin >> n >> q >> x;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector <int> psum(n + 1);
    for (int i = 0; i < n; ++i) psum[i + 1] = psum[i] + a[i];
    while (q--) {
        int r;
        cin >> r;
        int cur = 0;
        for (int i = 0; i < r; ++i) cur += a[i];
        vector <int> taken(n);
        cur *= x;
        int cha = 0, sum_left = 0, sum_right = 0;
        while (true) {
            int mn = INF, pos = -1, delta = 0;
            for (int i = r - 1; i >= 0; --i) {
                int l = r - i - 1;
                if (!taken[i]) {
                    int val = -a[i] * x + a[i] * l - sum_left + sum_right + psum[r] - psum[i + 1];
                    if (val < mn) {
                        mn = val;
                        pos = i;
                    }
                }
            }
            if (pos == -1) break;
            taken[pos] = 1;
            delta = mn;
            sum_left += a[pos];
            pos = -1;
            mn = INF;
            for (int i = r; i < n; ++i) {
                int l = i - r;
                if (!taken[i]) {
                    int val = a[i] * x + a[i] * (l + 1) - sum_right + sum_left + (psum[i] - psum[r]);
                    if (val < mn) {
                        mn = val;
                        pos = i;
                    }
                }
            }
            if (pos == -1) break;
            taken[pos] = 1;
            delta += mn;
            sum_right += a[pos];
            ++cha;
            if (delta < 0) {
                cur += delta;
            } else {
                break;
            }
        }
        cout << cur << "\n";
    }
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
}

/*
 4 1 5
 4 1 2 3
 2

4 1 6
4 1 2 3
2

 */