#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
#define ll long long

inline void solve() {
    int n, q;
    ll x;
    cin >> n >> q >> x;
    vector <ll> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector <ll> psum(n + 1);
    for (int i = 0; i < n; ++i) psum[i + 1] = psum[i] + a[i];
    vector <ll> rem(n + 1);
    vector <ll> imp1, imp2;
    imp1.reserve(n);
    imp2.reserve(n);
    while (q--) {
        int r;
        cin >> r;
        if (rem[r] != 0) {
            cout << rem[r] << "\n";
            continue;
        }
        ll cur = psum[r] * x;
        for (int i = 0; i < r; ++i) {
            imp1.emplace_back(-a[i] * x + a[i] * (r - i) - psum[i + 1]);
        }
        for (int i = r; i < n; ++i) {
            imp2.emplace_back(a[i] * x + a[i] * (i - r + 1) + psum[i]);
        }
        sort(imp1.begin(), imp1.end());
        sort(imp2.begin(), imp2.end());
        int it = 0;
        while (it < (int)imp1.size() && it < (int)imp2.size()) {
            ll delta = imp1[it] + imp2[it];
            if (delta < 0) {
                cur += delta;
                ++it;
            } else {
                break;
            }
        }
        imp1.clear();
        imp2.clear();
        rem[r] = cur;
        cout << cur << "\n";
    }
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
}

/*
 4 1 5
 4 1 2 3
 2

4 1 6
4 1 2 3
2

 */