#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 2505;
const int V = 2 * N + 123;
const ll W = 1e14;
const ll INF = 0x3f3f3f3f3f3f3f3f;
const int M = N * (N - 1) + 3 * N + 1;

int n, k, VV;
ll l[N], r[N];
int ev[M], eu[M], ef[M], ec[M];
ll ew[M];
int m = 0;
vector<int> g[V];
int s, t;
int par[V];
ll d[V], p[V];
bool used[V];

int getv(int i) {
	if (i & 1) {
		return eu[i / 2];
	}
	return ev[i / 2];
}

int getu(int i) {
	if (i & 1) {
		return ev[i / 2];
	}
	return eu[i / 2];
}

int getf(int i) {
	if (i & 1) {
		return -ef[i / 2];
	}
	return ef[i / 2];
}

int getc(int i) {
	if (i & 1) {
		return 0;
	}
	return ec[i / 2];
}

ll getw(int i) {
	if (i & 1) {
		return -ew[i / 2];
	}
	return ew[i / 2];
}

void addedge(int v, int u, int c, ll w) {
	assert(m < M);
	g[v].push_back(2 * m);
	g[u].push_back(2 * m + 1);
	ev[m] = v;
	eu[m] = u;
	ef[m] = 0;
	ec[m] = c;
	ew[m] = w;
	++m;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}
	VV = 2 + 2 * n;
	s = 0;
	t = 1;
	for (int i = 0; i < n; ++i) {
		addedge(2 + 2 * i, 2 + 2 * i + 1, 1, -W);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			addedge(2 + 2 * i + 1, 2 + 2 * j, 1, abs(r[i] - l[j]));
		}
	}
	for (int i = 0; i < n; ++i) {
		addedge(s, 2 + 2 * i, 1, 0);
	}
	for (int i = 0; i < n; ++i) {
		addedge(2 + 2 * i + 1, t, 1, 0);
	}
	{
		d[s] = 0;
		d[2] = 0;
		for (int i = 0; i < n; ++i) {
			d[2 + 2 * i + 1] = d[2 + 2 * i] - W;
			if (i < n - 1) {
				d[2 + 2 * (i + 1)] = d[2 + 2 * i + 1] + abs(r[i] - l[i + 1]);
			}
		}
		d[t] = d[2 + 2 * (n - 1) + 1];
		memcpy(p, d, VV * sizeof p[0]);
	}
	ll ans = 0;
	for (int kek = 0; kek < k; ++kek) {
		memset(d, 0x3f, VV * sizeof d[0]);
		memset(par, 255, VV * sizeof par[0]);
		memset(used, 0, VV * sizeof used[0]);
		d[s] = 0;
		while (true) {
			int v = -1;
			for (int i = 0; i < VV; ++i) {
				if (!used[i] && (v == -1 || d[i] < d[v])) {
					v = i;
				}
			}
			if (v == -1 || d[v] == INF) {
				break;
			}
			used[v] = true;
			for (int i : g[v]) {
				if (getf(i) < getc(i) && d[v] + getw(i) + p[v] - p[getu(i)] < d[getu(i)]) {
					d[getu(i)] = d[v] + getw(i) + p[v] - p[getu(i)];
					par[getu(i)] = i;
				}	
			}
		}
		ans += d[t] + p[t];
		for (int i = 0; i < VV; ++i) {
			p[i] += d[i];
		}
		assert(par[t] != -1);
		for (int v = t; v != s; v = getv(par[v])) {
			if (par[v] & 1) {
				ef[par[v] / 2] -= 1;
			} else {
				ef[par[v] / 2] += 1;
			}
		}
	}
	cout << ans + n * W << endl;
	return 0;	
}
