#pragma GCC otpimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>



using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


int n, q;
vector<ll> v;
ll a;


ll solve_slow(int r){
    vector<ll> xl, xr;
    xl.reserve(r);
    xr.reserve(n - r);
    ll sm = 0;
    for(int i = 0; i < r; i += 1){
        xl.push_back(v[i]);
        sm += v[i] * a;
    }
    for(int i = r; i < n; i += 1){
        xr.push_back(v[i]);
    }
    vector<ll> dxl, dxr;
    ll sufsm = 0;
    ll mnf = 0;
    for(int i = r - 1; i >= 0 && r - i - 1 <= a * 2; i -= 1){
        ll f = sufsm - xl[i] * a + (r - i) * xl[i];
        sufsm += xl[i];
        if(f >= 0){
            continue;
        }
        mnf = min(f, mnf);
        dxl.push_back(f);
    }
    ll prefsm = 0;
    for(int i = 0; i < n - r && i <= a * 2; i += 1){
        ll f = prefsm + xr[i] * a + (i + 1) * xr[i];
        prefsm += xr[i];
        if(f + mnf >= 0){
            continue;
        }
        dxr.push_back(f);
    }
    stable_sort(all(dxl));
    stable_sort(all(dxr));
    ll rs = sm;
    for(int i = 0; i < dxl.size() && i < dxr.size() && i <= a; i += 1){
        if(dxl[i] + dxr[i] >= 0){
            break;
        }
        rs += dxl[i] + dxr[i];
    }
    return rs;
}


int32_t main(){
    if (1) {
        ios::sync_with_stdio(0);
        cin.tie();
        cout.tie(0);
    }
    cin >> n >> q >> a;
    v.resize(n);
    for(int i = 0; i < n; i += 1){
        cin >> v[i];
    }
    while(q--){
        int r;
        cin >> r;
        cout << solve_slow(r) << "\n";
    }
    return 0;
}