#pragma GCC otpimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,fma")

#include <bits/stdc++.h>



using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define prcs cout << fixed << setprecision(20)


flt p;
int n, l, r;


flt solve_slow(){
    const flt inf = n * 100;
    vector<vector<flt>> dp(n + 1, vector<flt>(n + 1, 0));
    dp[n][n] = 0;
    const int iters = 50000;
    const int pws_itrs = 200;
    for(int itr = 0; itr < iters; itr += 1){
        for(int t = 0; t < n; t += 1){
            for(int f = t; f <= n; f += 1){
                for(int cs = 0; cs < 2; cs += 1){
                    if(cs == 2 && t == f){
                        continue;
                    }
                    int i, j;
                    if(cs == 0){
                        i = t;
                        j = f;
                    } else{
                        i = f;
                        j = t;
                    }
                    if(i == j){
                        dp[i][j] = 1 + dp[i + 1][j] * p + dp[i][j + 1] * (1 - p);
                        continue;
                    }
                    flt prob;
                    flt sm1 = inf;
                    flt sm2 = inf;
                    if(i < j){
                        if(j < n){

                        }
                        sm1 = (1 + dp[i + 1][j]) * p;
                        prob = (1 - p);
                        for(int k = 0; k < pws_itrs; k += 1){
                            if(i - k == 0){
                                sm1 += (2 + k + dp[0][j] + p / (1 - p)) * prob;
                                break;
                            }
                            sm1 += (2 + k + dp[max(0, i - k)][j]) * prob * (1 - p);
                            prob *= p;
                        }
                    }
                    if(j < i){
                        sm2 = (1 + dp[i][j + 1]) * (1 - p);
                        prob = p;
                        for(int k = 0; k < pws_itrs; k += 1){
                            if(j - k == 0){
                                sm2 += (2 + k + dp[i][0] + (1 - p) / p) * prob;
                                break;
                            }
                            sm2 += (2 + k + dp[i][max(0, j - k)]) * prob * (p);
                            prob *= (1 - p);
                        }
                    }
                    dp[i][j] = min(sm1, sm2);
                }
            }
        }
    }
    return dp[l][r];
}


void cnt_dpl_slow(vector<flt> &dpl, flt p){
    dpl.resize(n);
    const int pws_itrs = 1000;
    for(int i = 0; i < n; i += 1){
        flt prob = 1;
        flt fcst = 0;
        flt cst_up = 0;
        for(int k = 0; k < pws_itrs; k += 1){
            fcst += (2 + k + cst_up) * prob * (1 - p);
            prob *= p;
            if(i - k - 1 >= 0){
                cst_up += dpl[i - k - 1];
            }
        }
        dpl[i] = 1 + (1 - p) / p * fcst;
    }
}


void cnt_dpl(vector<flt> &dpl, flt p){
    dpl.resize(n);
    const int pws_itrs = 1000;
    flt fcst = 0;
    flt prob = 1;
    for(int k = 0; k < pws_itrs; k += 1){
        fcst += (2 + k) * (1 - p) * prob;
        prob *= p;
    }
    flt p1 = 1 - p;
    flt fuck = (1 - p) / p;
    for(int i = 0; i < n; i += 1){
        flt cst_up = 0;
        dpl[i] = 1 + fuck * fcst;

        fcst = (fcst + 1 + dpl[i]) * p + 2 * p1;
    }
}


flt solve(){
    vector<flt> dpl, dpr;
    cnt_dpl(dpl, p);
    cnt_dpl(dpr, 1 - p);
    int ml = l;
    int mr = r;
    flt rs = 0;
    while(ml < mr){
        rs += dpl[ml];
        ml += 1;
    }
    while(mr < ml){
        rs += dpr[mr];
        mr += 1;
    }
    flt rs1 = 0;
    flt rs2 = 0;
    for(int i = ml; i < n; i += 1){
        rs += 1;
        rs1 += dpr[i];
        rs2 += dpl[i];
    }
    rs += p * rs1 + (1 - p) * rs2;
    return rs;
}


int32_t main(){
    cin >> p >> n >> l >> r;
    prcs << solve() << "\n";
    return 0;
}