#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;
typedef long long ll;
#define int long long

int n, q, A;
int a[1000010];
int psum[1000010];
int ssum[1000010];
int ans = 0;

int val[1000010];

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> q >> A;
    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        psum[i] = a[i] + psum[i - 1];
    }

    for (int i = n; i >= 1; --i)
    {
        ssum[i] = ssum[i + 1] + a[i];
    }

    int r;
    cin >> r;
    ++r;

    for (int i = 1; i <= n; ++i)
    {
        if (i < r)
        {
            val[i] = -a[i] * A + ssum[i + 1] - ssum[r] + a[i] * (r - i - 1) + a[i];
        }
        else
        {
            val[i] = a[i] * A + psum[i - 1] - psum[r - 1] + a[i] * (i - r) + a[i];
        }
    }

    multiset <int> x, y;

    for (int i = 1; i <= n; ++i)
    {
        if (i < r) x.insert(val[i]);
        else y.insert(val[i]);
    }

    while (x.size() && y.size() && *(x.begin()) + *(y.begin()) < 0)
    {
        ans += *(x.begin()) + *(y.begin());
        x.erase(x.begin());
        y.erase(y.begin());
    }

    //for (int musk = 0; musk < (1 << n); ++musk)
    //{
    //    vector <int> le, ri;
    //    for (int j = 0; j < n; ++j)
    //    {
    //        if (!((musk >> j) & 1)) continue;
    //        if (j < r) le.push_back(j);
    //        else ri.push_back(j);
    //    }


    //    if (le.size() != ri.size()) continue;
    //    int nans = 0;
    //    for (auto j : le) nans -= a[j] * A;
    //    for (auto j : ri) nans += a[j] * A;

    //    for (int j = 0; j < le.size(); ++j)
    //    {
    //        for (int k = le[j] + 1; k < r; ++k)
    //        {
    //            nans += a[le[j]] + a[k];
    //        }
    //        for (int k = r; k < ri[j]; ++k)
    //        {
    //            nans += a[ri[j]] + a[k];
    //        }
    //        nans += a[le[j]];
    //        nans += a[ri[j]];
    //    }

    //    ans = min(ans, nans);
    //}

    for (int i = 0; i < r; ++i) ans += a[i] * A;
    cout << ans;
    return 0;
}