#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <iomanip>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;
#define int long long 

int inf = 1e18;

int dp[23][1 << 22];

int n, k;
int bitcnt(int n)
{
	int ans = 0;
	while (n)
	{
		ans += (n & 1);
		n >>= 1;
	}
	return ans;
}

int l[30];
int r[30];


signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> k;
	
	for (int i = 0; i < n; ++i)
	{
		cin >> l[i] >> r[i];
	}

	for (int i = 0; i < n; ++i) for (int j = 0; j < (1 << n); ++j) dp[i][j] = inf;

	dp[0][1] = 0;

	for (int i = 1; i < n; ++i)
	{
		for (int j = 0; j < (1 << i); ++j)
		{
			int musk = j + (1 << i);
			if (bitcnt(musk) > k) continue;
			dp[i][musk] = dp[i - 1][j];
			for (int k = 0; k < i; ++k)
			{
				if ((j >> k) & 1) continue;
				dp[i][musk] = min(dp[i][musk], dp[i - 1][j + (1 << k)] + abs(r[k] - l[i]));
			}
		}
	}

	int ans = inf;
	for (int j = 0; j < (1 << n); ++j)
	{
		ans = min(ans, dp[n - 1][j]);
	}

	cout << ans;

	return 0;
}