#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define int long long

mt19937 rnd(51);

const int INF = 1e18;

int solve(int n, int A, int r, vector<int> a) {
    map<vector<int>, int> d;
    d[a] = 0;
    set<pair<int, vector<int>>> st;
    st.insert({0, a});
    int ans = INF;
    while (st.size() > 0) {
        auto v = st.begin()->second;
        st.erase(st.begin());
        int dist = d[v];
        for (int i = 0; i + 1 < n; i++) {
            int len = v[i] + v[i + 1];
            swap(v[i], v[i + 1]);
            if (!d.count(v) || d[v] > dist + len) {
                st.erase({d[v], v});
                d[v] = dist + len;
                st.insert({d[v], v});
            }
            swap(v[i], v[i + 1]);
        }
        int sum = dist;
        for (int i = 0; i < r; i++) {
            sum += v[i] * A;
        }
        ans = min(ans, sum);
    }
    return ans;
}

int solve2(int n, int A, int r, vector<int> a) {
    vector<int> pr(n);
    for (int i = r - 1; i >= 0; i--) {
        pr[i] = (i + 1 < r ? pr[i + 1] : 0) + a[i];
    }
    for (int i = r; i < n; i++) {
        pr[i] = (i - 1 >= r ? pr[i - 1] : 0) + a[i];
    }
    int res = INF;
    for (int k = 0; k <= min(r, n - r); k++) {
        vector<pair<int,int>> c, d;
        int ans = 0;
        for (int i = 0; i < r; i++) ans += a[i] * A;
        for (int i = r - 1; i >= 0; i--) {
            c.pb({a[i] * k - a[i] * A + pr[i] - a[i] + (r - i - 1) * a[i], i});
        }
        for (int i = r; i < n; i++) {
            d.pb({a[i] * k + a[i] * A + pr[i] - a[i] + (i - r) * a[i], i});
        }
        sort(c.begin(), c.end());
        sort(d.begin(), d.end());
        vector<int> pos1, pos2;
        for (int i = 0; i < k; i++) {
            pos1.pb(c[i].second);
        }
        for (int i = 0; i < k; i++) {
            pos2.pb(d[i].second);
        }
        sort(pos1.rbegin(), pos1.rend());
        int cur = 0, cnt = 0;
        for (auto i : pos1) {
            cur += a[i];
            ans += a[i] * k - a[i] * A + pr[i] - cur + (r - i - 1 - cnt) * a[i];
            cnt++;
        }
        sort(pos2.begin(), pos2.end());
        cur = 0, cnt = 0;
        for (auto i : pos2) {
            cur += a[i];
            ans += a[i] * k + a[i] * A + pr[i] - cur + (i - r - cnt) * a[i];
            cnt++;
        }
        res = min(res, ans);
    }
    return res;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    if (1) {
        int n, q, A;
        cin >> n >> q >> A;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            cin >> a[i];
        }
        assert(q == 1);
        int r;
        cin >> r;
        cout << solve2(n, A, r, a) << endl;
        return 0;
    }
    while (1) {
        int n = rnd() % 8 + 1;
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            a[i] = rnd() % 15 + 1;
        }
        int r = rnd() % n + 1, A = rnd() % 15 + 1;
        auto res = solve(n, A, r, a), res2 = solve2(n, A, r, a);
        if (res != res2) {
            cout << n << ' ' << 1 << ' ' << A << endl;
            for (auto to : a) {
                cout << to << " ";
            }
            cout << endl << r << endl;
            cout << "BAD" << endl;
            return 0;
        }
        cout << solve(n, A, r, a) << endl;
    }
    return 0;
}
