#include<bits/stdc++.h>

using namespace std;

#define ll long long
#define pb push_back
#define int long long

const int N = 20100, INF = 1e14, super_INF = 4e18;
vector<pair<int,int>> g[N];

struct edge {
    int c, f, cost;
};

vector<edge> e;

void add_edge(int a, int b, int c, int cost) {
    g[a].pb({b, e.size()});
    e.pb({c, 0, cost});
    g[b].pb({a, e.size()});
    e.pb({0, 0, -cost});
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    int s = 0, t = k + 1 + 2 * n;
    for (int i = 1; i <= k; i++) {
        add_edge(s, i, 1, 0);
    }
    for (int i = 1; i <= k; i++) {
        for (int j = 0; j < n; j++) {
            add_edge(i, j * 2 + k + 1, 1, 0);
        }
    }
    for (int i = 0; i < n; i++) {
        add_edge(i * 2 + (k + 1), i * 2 + 1 + (k + 1), 1, -INF);
        for (int j = i + 1; j < n; j++) {
            add_edge(i * 2 + 1 + (k + 1), j * 2 + (k + 1), 1, abs(r[i] - l[j]));
        }
        add_edge(i * 2 + 1 + (k + 1), t, 1, 0);
    }
    int m = t + 1;
    vector<int> pt(m, INF);
    pt[s] = 0;
    for (int i = 0; i < m; i++) {
        for (auto to : g[i]) {
            if (e[to.second].f < e[to.second].c) {
                assert(i < to.first);
                pt[to.first] = min(pt[to.first], pt[i] + e[to.second].cost);
            }
        }
    }
    int ans = 0;
    while (1) {
        vector<int> d(m, super_INF);
        vector<pair<int,int>> par(m, {-1, -1});
        d[s] = 0;
        set<pair<int,int>> st{{0, s}};
        while (st.size() > 0) {
            int v = st.begin()->second;
            st.erase(st.begin());
            for (auto to : g[v]) {
                if (e[to.second].f < e[to.second].c) {
                    assert(pt[v] + e[to.second].cost - pt[to.first] >= 0);
                    if (d[to.first] > d[v] + pt[v] + e[to.second].cost - pt[to.first]) {
                        st.erase({d[to.first], to.first});
                        d[to.first] = d[v] + pt[v] + e[to.second].cost - pt[to.first];
                        par[to.first] = {v, to.second};
                        st.insert({d[to.first], to.first});
                    }
                }
            }
        }
        if (par[t].first == -1) break;
        int cur = t;
        while (cur != s) {
            int ind = par[cur].second;
            e[ind].f += 1, e[ind ^ 1].f -= 1;
            ans += e[ind].cost;
            cur = par[cur].first;
        }
        for (int i = 0; i < m; i++) {
            pt[i] += d[i];
        }
    }
    cout << ans + INF * n << endl;
    return 0;
}
