#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;
#define int long long
const int MX = 2e18;

inline void solve() {
    int n;
    cin >> n;
    int q;
    cin >> q;
    int k;
    cin >> k;

    vector<int> a(n);
    for(int i =0;i<n;++i)
        cin >> a[i];
    vector<bool> used(n);
    vector<int> ans(n);
    int mega_sum = 0;
    for(int i =0;i<n;++i){
        int id = -1, mn = MX, cnt = 0, sum = 0, cnt_used = 0, mega_bad_sum = 0;
        for(int j = 0;j<n;++j){
            if(used[j]) {
                cnt_used++;
                mega_bad_sum += a[j];
                continue;
            }
            if (id == -1 || mn > a[j] * k + sum + cnt * a[j] - (i - cnt_used) * a[j] - (mega_sum - mega_bad_sum))
            {
                mn = a[j] * k + sum + cnt * a[j] - (i - cnt_used) * a[j] - (mega_sum - mega_bad_sum);
                id = j;
            }
            cnt++;
            sum += a[j];
        }
        used[id] = 1;
        ans[i] = mn;
        if(i)
            ans[i] += ans[i - 1];
        mega_sum += a[id];
    }
    while(q--){
        int x;
        cin >> x;
        cout << ans[x - 1] << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
