#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
using namespace std;
#define double long double
#define int long long
const int MX = 2e18;

inline bool check(double p) {
    return rand() % 10000 < 10000 * p;
}
inline void solve() {
    double p;
    cin >> p;
    int n, l, r;
    cin >> n >> l >> r;
    int sum = 0;
    int ch;
    int test = 0;
    while (true){
        if((double)clock() / CLOCKS_PER_SEC > 0.1)
            break;
        int x = l, y = r;
        ch = 0;
        int cnt = 0;
        while (ch != 0 || l != n || r != n) {
            cnt++;
            if (ch == 0) {
                if (l == r) {
                    if (check(p))
                        ++l;
                    else
                        r++;
                } else if (l < r) {
                    if (check(p))
                        ++l;
                    else
                        ch = 2;
                } else {
                    if (check(p))
                        ch = 1;
                    else
                        ++r;
                }
            } else if (ch == 1) {
                if (check(p))
                    ch = 0;
                else
                    r = max(r - 1, 0LL);
            } else {
                if (check(p))
                    l = max(l - 1, 0LL);
                else
                    ch = 0;
            }
        }
        l = x;
        r = y;
        sum += cnt;
        ++test;
    }
    cout << setprecision(12) << (double)sum / test;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}