#include <iostream>
using namespace std;
using ll = long long;

const int MAXN = 1e6 + 123;
const ll INF = 1e18;
ll a[MAXN];

ll solve(int n, int r, int u) {
    ll ans = INF;
    for (int m = 0; m < (1 << n); ++m) {
        if (__builtin_popcount(m) != r)
            continue;
        int cnt0 = 0;
        int cnt1 = 0;
        ll ans0 = 0;
        for (int i = 0; i < n; ++i) {
            if (m & (1 << i)) {
                ans0 += a[i] * (u + cnt0);
                ++cnt1;
            } else {
                ans0 += a[i] * (r - cnt1);
                ++cnt0;
            }
        }
        ans = min(ans, ans0);
    }
    return ans;
}

signed main() {
    ll n, q, u;
    cin >> n >> q >> u;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    while (q--) {
        int r;
        cin >> r;
        cout << solve(n, r, u) << '\n';
    }
}
