#include <iostream>
#include <vector>
using namespace std;
using ll = long long;

const int MAXN = 22;
const ll INF = 1e18;
pair<ll, ll> sg[MAXN];

signed main() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; ++i)
        cin >> sg[i].first >> sg[i].second;
    ll ans = INF;
    for (int m = 1; m < (1 << n); m += 2) {
        if (__builtin_popcount(m) != k)
            continue;
        vector<int> lift;
        ll ans0 = 0;
        for (int i = 0; i < n; ++i) {
            if (m & (1 << i)) {
                lift.push_back(sg[i].second);
                continue;
            }
            int& bestx = lift[0];
            for (auto& x : lift) {
                if (abs(bestx - sg[i].first) > abs(x - sg[i].first)) {
                    bestx = x;
                }
            }
            ans0 += abs(bestx - sg[i].first);
            bestx = sg[i].second;
        }
        ans = min(ans, ans0);
    }
    cout << ans << '\n';
}
