#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;
constexpr ll infL = 3e18;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q, A;
    cin >> n >> q >> A;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> R(q);
    for (int i = 0; i < q; ++i) {
        cin >> R[i];
    }

    if (q == 1) {
        ll ans = accumulate(a.begin(), a.begin() + R[0], 0ll) * A;
        auto solve = [&]() {
            int k = min(R[0], n - R[0]);
            vector<ll> dp(k + 1, infL);
            dp[0] = 0;
            for (int i = R[0] - 1; i >= 0; --i) {
                auto dq = dp;
                dp.assign(k + 1, infL);
                { //choose
                    for (int c = 0; c < k; ++c) {
                        dp[c + 1] = dq[c] + ((R[0] - i - 1 - c)) * 1LL * a[i];
                    }
                }
                { //skip
                    for (int c = 0; c <= k; ++c) {
                        dp[c] = min(dp[c], dq[c] + (-c + A) * 1LL * a[i]);
                    }
                }
            }
            vector<ll> L(dp);
            dp.assign(k + 1, infL);
            dp[0] = 0;
            for (int i = R[0]; i < n; ++i) {
                for (int c = k; c >= 0; --c) {
                    dp[c] = (-c) * 1LL * a[i] + min(dp[c],
                                (c > 0 ? dp[c - 1] + ((i - R[0] + 1) + A) * 1LL * a[i] : infL));
                }
            }
            ll sum = accumulate(a.begin(), a.end(), 0ll);
            for (int i = 0; i <= k; ++i) {
                ans = min(ans, L[i] + dp[i] + sum * i);
            }
        };
        solve();
        cout << ans << '\n';
    } else {
        assert(false);
    }

    return 0;
}
