#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int inf = 1e9 + 7;
constexpr ll infL = 3e18;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q, A;
    cin >> n >> q >> A;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<int> R(q);
    for (int i = 0; i < q; ++i) {
        cin >> R[i];
    }

    if (q == 1) {
        ll ans = accumulate(a.begin(), a.begin() + R[0], 0ll) * A;
        auto solve = [&]() {
            int k = min(R[0], n - R[0]);
            vector<ll> dp(k + 1, infL);
            vector<ll> q(k + 1, 1e13);
            q[0] = 0;
            dp[0] = 0;
            for (int i = R[0] - 1; i >= 0; --i) {
                ll kek = ((R[0] - i)) * 1LL * a[i];

                for (int c = k; c >= 1; --c) {
                    q[c] = min(q[c] + 1LL * A * a[i], kek) - a[i];
                }
                q[0] += 1LL * A * a[i];

                vector<bool> won(k + 1);
                for (int c = k; c >= 1; --c) {
                    ll fi = dp[c] + A * 1LL * a[i];
                    ll se = dp[c - 1] + kek;
                    won[c] = fi < se;
                    dp[c] = (-c) * 1LL * a[i] + min(dp[c] + A * 1LL * a[i], dp[c - 1] + kek);
                }
                won[0] = true;
                assert(is_sorted(won.rbegin(), won.rend()));
                dp[0] += A * 1LL * a[i];
            }
            vector<ll> L(dp);
            dp.assign(k + 1, infL);
            dp[0] = 0;
            for (int i = R[0]; i < n; ++i) {
                ll kek = ((i - R[0] + 1) + A) * 1LL * a[i];
                for (int c = k; c >= 1; --c) {
                    dp[c] = (-c) * 1LL * a[i] + min(dp[c], dp[c - 1] + kek);
                }
            }
            ll sum = accumulate(a.begin(), a.end(), 0ll);
            for (int i = 0; i <= k; ++i) {
                ans = min(ans, L[i] + dp[i] + sum * i);
            }
        };
        solve();
        cout << ans << '\n';
    } else {
        assert(false);
    }

    return 0;
}
