#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int K = 3450;

int main() {
    fast;
    int n, q;
    ll A;
    cin >> n >> q >> A;
    vector<ll> a(n), s(n);
    s[0] = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (i < n - 1)
            s[i + 1] = s[i] + a[i];
    }
    if (q == 1) {
        vector<ll> b(n);
        int r;
        cin >> r;
        for (int i = 0; i < n; ++i)
            b[i] = a[i] * (A + i + 1 - r) + s[i];
        sort(all(b));
        ll ans = 0;
        for (int i = 0; i < r; ++i)
            ans += b[i];
        cout << ans << '\n';
    }
    else {
        vector<pair<ll, ll>> b(n);
        for (int i = 0; i < n; ++i)
            b[i] = {a[i] * (A + i + 1) + s[i], a[i]};
        sort(all(b));
        vector<ll> ans(n, 0);
        for (int r = 1; r <= n; ++r) {
            for (int i = 1; i < n; ++i) {
                int j = i;
                while (j > 0 && b[j].first - b[j].second * r < b[j - 1].first - b[j - 1].second * r) {
                    swap(b[j - 1], b[j]);
                    --j;
                }
            }
            for (int i = 0; i < r; ++i)
                ans[r - 1] += b[i].first - b[i].second * r;
        }
        while (q--) {
            int r;
            cin >> r;
            cout << ans[r - 1] << '\n';
        }
    }
}
