﻿#pragma GCC oprimize("O3,fastmath")
#pragma GCC target("avx2,sse4.sse4.2")

#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

vector<ld> count(int n, ld p) {
    vector<ld> d(n + 1), e(n + 1);
    d[0] = 0.0;
    e[0] = 1.0 / (1.0 - p);
    for (int i = 1; i <= n; ++i) {
        d[i] = 1.0 / p + (1.0 - p) / p * e[i - 1];
        e[i] = 1.0 + p * (e[i - 1] + d[i]);
    }
    return d;
}

int main() {
    fast;
    ld p;
    int n, l, r;
    cin >> p >> n >> l >> r;
    if (l > r) {
        swap(l, r);
        p = 1.0 - p;
    }
    vector<ld> d1 = count(n, p), d2 = count(n, 1.0 - p);
    ld ans = 0.0;
    while (l < r) {
        ans += d1[l + 1];
        ++l;
    }
    while (l < n) {
        ans += d1[l + 1] * (1.0 - p) + d2[l + 1] * p + 1.0;
        ++l;
    }
    cout << setprecision(12) << fixed << ans << '\n';
}
