#include <bits/stdc++.h>

using namespace std;

const long long inf = 1e18;

void solve() {
    int n, q, a;
    cin >> n >> q >> a;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    vector<int> r(q);
    for (int i = 0; i < q; ++i) {
        cin >> r[i];
    }
    for (int i = 0; i < q; ++i) {
        vector<vector<long long>> dp(n + 1, vector<long long>(r[i] + 1, inf));
        dp[0][0] = 0;
        for (int j = 0; j < n; ++j) {
            for (int k = 0; k <= r[i] && k <= j; ++k) {
                if (k + 1 <= r[i]) {
                    dp[j + 1][k + 1] = min(dp[j + 1][k + 1], dp[j][k] + v[j] * 1LL * (j - k) + v[j] * 1LL * a);
                }
                dp[j + 1][k] = min(dp[j + 1][k], dp[j][k] + v[j] * 1LL * (r[i] - k));
            }
        }
        cout << dp[n][r[i]] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
}