#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
//#include <unordered_set>
#include <deque>
#include <bitset>
#include <iomanip>
#include <queue>
#include <cmath>
#include <ctime>
#include <numeric>
#include <string>

using namespace std;

typedef long long ll;
//typedef __int128_t ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
//#define break_(x) {x; return;}
const ll MOD = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-9;
//const ll MOD2 = 998244353;
ld pi = asin(0.5) * (ld)6;

vector<ll> v;
int n;
ll A;

ll slv(int R) {
    ll ans = 0;
    for (int i = 0; i < R; ++i) {
        ans += v[i] * A;
    }
    vector<ll> f, s;
    ll smnw = 0;
    for (int i = R - 1; i >= 0; --i) {
        f.push_back(v[i] * ((ll)(R - i) - A) + smnw);
        smnw += v[i];
    }
    smnw = 0;
    for (int i = R; i < n; ++i) {
        s.push_back(v[i] * ((ll)(i - R + 1) + A) + smnw);
        smnw += v[i];
    }
    sort(all(f));
    sort(all(s));
    for (int i = 0; i < min(R, n - R); ++i) {
        if (f[i] + s[i] >= 0LL) {
            break;
        }
        ans += f[i] + s[i];
    }
    return ans;
}

inline void solve(void) {
    int q;
    cin >> n >> q >> A;
    v.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    int R; cin >> R;
    cout << slv(R);
}

int main(void) {
    //freopen("censored.in", "r", stdin);
    //freopen("censored.out", "w", stdout);
    cout << fixed << setprecision(20);
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1; srand(time(0)); //cin >> t;
    while (t--) solve();
    return 0;
}
