#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(a) (int)a.size()
#define all(a)a.begin(),a.end()
const int inf = 1e18;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<vector<pair<int, vector<int>>>> dp(n, vector<pair<int, vector<int>>>(k));
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first >> a[i].second;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < k; ++j) {
            dp[i][j].second.resize(min(j + 1, i + 1), -1);
            dp[i][j].first = inf;
        }

    dp[0][0].first = 0;
    dp[0][0].second = {0};
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j < min(i + 1, k); ++j) {
            dp[i][j].first = dp[i - 1][j - 1].first;
            dp[i][j].second = dp[i - 1][j - 1].second;
            dp[i][j].second.push_back(i);
        }
        for (int j = 0; j < min(k, i + 1); ++j) {
            pair<int, vector<int>> best = dp[i][j];
            if (j + 1 == i + 1)
                break;
            for (int l = 0; l < sz(dp[i - 1][j].second); ++l) {
                pair<int, vector<int>> cur = dp[i - 1][j];
                cur.first += abs(a[cur.second[l]].second - a[i].first);
                cur.second[l] = i;
                best = min(best, cur);
            }
            dp[i][j] = best;
        }
    }

    cout << min_element(all(dp[n - 1]))->first;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
