#include <bits/stdc++.h>

#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=252;

ll l[N],r[N],link[N],sz[N];

ll fset(ll x)
{
    if(x==link[x]) return x;
    return link[x]=fset(link[x]);
}

void unite(ll a, ll b)
{
    a=fset(a);
    b=fset(b);
    if(a==b) return;
    if(sz[a]<sz[b]) swap(a,b);
    link[b]=a;
    sz[a]+=sz[b];
}

void solve()
{
    ll n,k;
    cin>>n>>k;

    for(ll i=0;i<n;i++)
        cin>>l[i]>>r[i];

    ve<tuple<ll,ll,ll>> v;

    for(ll i=0;i<n;i++)
    {
        for(ll j=i+1;j<n;j++)
            v.push_back({abs(r[i]-l[j]),i,j});
    }

    sort(all(v));

    for(ll i=0;i<n;i++)
    {
        link[i]=i;
        sz[i]=1;
    }

    ll cnt=n,ans=0;

    for(tuple<ll,ll,ll> i:v)
    {
        if(cnt==k) break;
        ll a,b,w;
        tie(w,a,b)=i;

        if(fset(a)!=fset(b))
        {
            unite(a,b);
            ans+=w;
            cnt--;
        }
    }

    cout<<ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
