#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define int long long

using namespace std;

int h(const vector<int>& a){
    int res = 0;
    int p = 1;
    for (int i = 0; i < a.size(); i++, p *= 10){
        res += (a[i] * p);
    }
    return res;
}

vector<int> uniq;

ll naive(vector<int> a, int R, int A){
    int n = a.size();
    ll res = 1e18;
    map<int, ll> dist;
    priority_queue<pair<ll, int>> q;
    dist[h(a)] = 0;
    q.push({0, h(a)});
    while (!q.empty()){
        pair<ll, int> t = q.top();
        q.pop();
        if (-t.first > dist[t.second]){
            continue;
        }
        int v = t.second;
        vector<int> b(n);
        for (int i = 0; i < n; i++){
            b[i] = t.second % 10;
            t.second /= 10;
        }
        ll curres = -t.first;
        for (int i = 0; i < R; i++){
            curres += uniq[b[i]] * 1ll * A;
        }
        res = min(res, curres);
        for (int i = 0; i + 1 < n; i++){
            swap(b[i], b[i + 1]);
            int cur = h(b);
            if (dist.find(cur) == dist.end() || dist[cur] > dist[v] + uniq[b[i]] + uniq[b[i + 1]]){
                dist[cur] = dist[v] + uniq[b[i]] + uniq[b[i + 1]];
                q.push({-dist[cur], cur});
            }
            swap(b[i], b[i + 1]);
        }
    }
    return res;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    // freopen("output.txt", "w", stdout);
    int T = 1;
    // cin >> T;
    while (T--){
        int n, m, A;
        cin >> n >> m >> A;
        vector<int> a(n + 1);
        for (int i = 1; i <= n; i++){
            cin >> a[i];
            uniq.push_back(a[i]);
        }
        sort(all(uniq));
        uniq.erase(unique(all(uniq)), uniq.end());
        vector<ll> pref(n + 1);
        for (int i = 1; i <= n; i++){
            pref[i] = pref[i - 1] + a[i];
        }
        for (int id = 0; id < m; id++){
            int R = -1;
            cin >> R;
            vector<ll> t;
            for (int i = 1; i <= n; i++){
                t.push_back(a[i] * (A - R + i) + pref[i - 1]);
            }
            sort(all(t));
            ll res = 0;
            for (int i = 0; i < R; i++){
                res += t[i];
            }
            cout << res << "\n";
        }
        // vector<vector<ll>> dp(n + 1, vector<ll>(R + 1, 1e18));
        // for (int i = 1; i <= n; i++){
        //     dp[i][1] = a[i] * (A - R + i) + pref[i - 1];
        // }
        // for (int j = 2; j <= R; j++){
        //     ll mn = min((ll)1e18, dp[j - 1][j - 1]);
        //     for (int i = j; i <= n; i++){
        //         if (mn != 1e18){
        //             dp[i][j] = min(dp[i][j], mn +
        //                                         a[i] * (A - R + i) + pref[i - 1]);
        //         }
        //         mn = min(mn, dp[i][j - 1]);
        //     }
        // }
        // ll res = 1e18;
        // for (int i = R; i <= n; i++){
        //     res = min(res, dp[i][R]);
        // }
        // cout << res << "\n";
        #ifdef ON_PC
        // if (n <= 8){
        //     cout << "\n";
        //     vector<int> ttt = a;
        //     ttt.erase(ttt.begin());
        //     for (int i = 0; i < n; i++){
        //         ttt[i] = lower_bound(all(uniq), ttt[i]) - uniq.begin();
        //     }
        //     ll res = naive(ttt, R, A);
        //     cout << res << "\n";
        //     map<int, ll> ddist;
        //     priority_queue<pair<ll, int>> qq;
        //     ddist[h(ttt)] = 0;
        //     qq.push({0, h(ttt)});
        //     while (!qq.empty()){
        //         pair<ll, int> t = qq.top();
        //         qq.pop();
        //         if (-t.first > ddist[t.second]){
        //             continue;
        //         }
        //         int v = t.second;
        //         vector<int> b(n);
        //         for (int i = 0; i < n; i++){
        //             b[i] = t.second % 10;
        //             t.second /= 10;
        //         }
        //         ll curres = -t.first;
        //         for (int i = 0; i < R; i++){
        //             curres += uniq[b[i]] * 1ll * A;
        //         }
        //         if (curres == res){
        //             for (int i = 0; i < n; i++){
        //                 cout << uniq[b[i]] << " ";
        //             }
        //             return 0;
        //         }
        //         for (int i = 0; i + 1 < n; i++){
        //             swap(b[i], b[i + 1]);
        //             int cur = h(b);
        //             if (ddist.find(cur) == ddist.end() || ddist[cur] > ddist[v] + uniq[b[i]] + uniq[b[i + 1]]){
        //                 ddist[cur] = ddist[v] + uniq[b[i]] + uniq[b[i + 1]];
        //                 qq.push({-ddist[cur], cur});
        //             }
        //             swap(b[i], b[i + 1]);
        //         }
        //     }
        // }
        #endif
    }
    return 0;
}