#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define int long long

using namespace std;

int h(const vector<int>& a){
    int res = 0;
    int p = 1;
    for (int i = 0; i < a.size(); i++, p *= 10){
        res += (a[i] * p);
    }
    return res;
}

vector<int> uniq;

ll naive(vector<int> a, int R, int A){
    int n = a.size();
    ll res = 1e18;
    map<int, ll> dist;
    priority_queue<pair<ll, int>> q;
    dist[h(a)] = 0;
    q.push({0, h(a)});
    while (!q.empty()){
        pair<ll, int> t = q.top();
        q.pop();
        if (-t.first > dist[t.second]){
            continue;
        }
        int v = t.second;
        vector<int> b(n);
        for (int i = 0; i < n; i++){
            b[i] = t.second % 10;
            t.second /= 10;
        }
        ll curres = -t.first;
        for (int i = 0; i < R; i++){
            curres += uniq[b[i]] * 1ll * A;
        }
        res = min(res, curres);
        for (int i = 0; i + 1 < n; i++){
            swap(b[i], b[i + 1]);
            int cur = h(b);
            if (dist.find(cur) == dist.end() || dist[cur] > dist[v] + uniq[b[i]] + uniq[b[i + 1]]){
                dist[cur] = dist[v] + uniq[b[i]] + uniq[b[i + 1]];
                q.push({-dist[cur], cur});
            }
            swap(b[i], b[i + 1]);
        }
    }
    return res;
}

signed main(){
    srand(time(0));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    // freopen("output.txt", "w", stdout);
    int T = 1;
    // cin >> T;
    while (T--){
        int n, m, A;
        cin >> n >> m >> A;
        vector<int> a(n + 1);
        for (int i = 1; i <= n; i++){
            cin >> a[i];
            uniq.push_back(a[i]);
        }
        sort(all(uniq));
        uniq.erase(unique(all(uniq)), uniq.end());
        vector<ll> pref(n + 1);
        for (int i = 1; i <= n; i++){
            pref[i] = pref[i - 1] + a[i];
        }
        #ifdef ON_PC
        {
            for (int R = 1; R <= n; R++){
                vector<pair<ll, ll>> t;
                for (int i = 1; i <= n; i++){
                    t.push_back({a[i] * (A - R + i) + pref[i - 1], i});
                }
                sort(all(t));
                for (int i = 0; i < n; i++){
                    cout << t[i].first << " ";
                }
                cout << "\n";
                for (int i = 0; i < n; i++){
                    cout << t[i].second << " ";
                }
                cout << "\n\n";
            }
        }
        #endif
        if (m == 1){
            for (int id = 0; id < m; id++){
                ll R = -1;
                cin >> R;
                ll res = 0;
                vector<ll> t;
                for (int i = 1; i <= n; i++){
                    t.push_back(a[i] * (A - R + i) + pref[i - 1]);
                }
                sort(all(t));
                for (int i = 0; i < R; i++){
                    res += t[i];
                }
                cout << res << "\n";
            }
            continue;
        }
        // vector<pair<int, int>> t;
        // for (int i = 1; i <= n; i++){
        //     t.push_back({-a[i], pref[i - 1] + a[i] * (A + i)});
        // }
        // // random_shuffle(all(t));
        // sort(rall(t));
        // t.insert(t.begin(), {-1e18, -1e18});
        // vector<ll> dp0(n + 1, 1e18);
        // vector<ll> dp1(n + 1, 1e18);
        // for (int i = 1; i <= n; i++){
        //     dp0[i] = t[i].first * 1 + t[i].second;
        // }
        // vector<ll> ans(n + 1);
        // ans[1] = *min_element(all(dp0));
        // for (int j = 2; j <= n; j++){
        //     dp1.assign(n + 1, 1e18);
        //     ll mn = min((ll)1e18, dp0[j - 1]);
        //     for (int i = j; i <= n; i++){
        //         if (mn != 1e18){
        //             dp1[i] = min(dp1[i], mn + t[i].first * j + t[i].second);
        //         }
        //         mn = min(mn, dp0[i]);
        //     }
        //     dp1.swap(dp0);
        //     ans[j] = *min_element(all(dp0));
        // }
        vector<int> ans(n + 1, -1);
        vector<bool> used(n + 1);
        for (int id = 0; id < m; id++){
            ll R = -1;
            cin >> R;            
            if (used[R]){
                cout << ans[R] << "\n";
                continue;
            }
            used[R] = 1;
            ll res = 0;
            priority_queue<ll> q;
            for (int i = 1; i <= n; i++){
                res += a[i] * (A - R + i) + pref[i - 1];
                q.push(a[i] * (A - R + i) + pref[i - 1]);
                if (q.size() > R){
                    res -= q.top();
                    q.pop();
                }
            }
            // vector<ll> t;
            // for (int i = 1; i <= n; i++){
                // t.push_back(a[i] * (A - R + i) + pref[i - 1]);
            // }
            // sort(all(t));
            // for (int i = 0; i < R; i++){
            //     res += t[i];
            // }
            // for (int i = 1; i <= R; i++){
            //     res += t[i].first * (R - i) + t[i].second;
            // }
            ans[R] = res;
            cout << res << "\n";
        }
        // vector<vector<ll>> dp(n + 1, vector<ll>(R + 1, 1e18));
        // for (int i = 1; i <= n; i++){
        //     dp[i][1] = a[i] * (A - R + i) + pref[i - 1];
        // }
        // for (int j = 2; j <= R; j++){
        //     ll mn = min((ll)1e18, dp[j - 1][j - 1]);
        //     for (int i = j; i <= n; i++){
        //         if (mn != 1e18){
        //             dp[i][j] = min(dp[i][j], mn +
        //                                         a[i] * (A - R + i) + pref[i - 1]);
        //         }
        //         mn = min(mn, dp[i][j - 1]);
        //     }
        // }
        // ll res = 1e18;
        // for (int i = R; i <= n; i++){
        //     res = min(res, dp[i][R]);
        // }
        // cout << res << "\n";
        #ifdef ON_PC
        // if (n <= 8){
        //     cout << "\n";
        //     vector<int> ttt = a;
        //     ttt.erase(ttt.begin());
        //     for (int i = 0; i < n; i++){
        //         ttt[i] = lower_bound(all(uniq), ttt[i]) - uniq.begin();
        //     }
        //     ll res = naive(ttt, R, A);
        //     cout << res << "\n";
        //     map<int, ll> ddist;
        //     priority_queue<pair<ll, int>> qq;
        //     ddist[h(ttt)] = 0;
        //     qq.push({0, h(ttt)});
        //     while (!qq.empty()){
        //         pair<ll, int> t = qq.top();
        //         qq.pop();
        //         if (-t.first > ddist[t.second]){
        //             continue;
        //         }
        //         int v = t.second;
        //         vector<int> b(n);
        //         for (int i = 0; i < n; i++){
        //             b[i] = t.second % 10;
        //             t.second /= 10;
        //         }
        //         ll curres = -t.first;
        //         for (int i = 0; i < R; i++){
        //             curres += uniq[b[i]] * 1ll * A;
        //         }
        //         if (curres == res){
        //             for (int i = 0; i < n; i++){
        //                 cout << uniq[b[i]] << " ";
        //             }
        //             return 0;
        //         }
        //         for (int i = 0; i + 1 < n; i++){
        //             swap(b[i], b[i + 1]);
        //             int cur = h(b);
        //             if (ddist.find(cur) == ddist.end() || ddist[cur] > ddist[v] + uniq[b[i]] + uniq[b[i + 1]]){
        //                 ddist[cur] = ddist[v] + uniq[b[i]] + uniq[b[i + 1]];
        //                 qq.push({-ddist[cur], cur});
        //             }
        //             swap(b[i], b[i + 1]);
        //         }
        //     }
        // }
        #endif
    }
    return 0;
} 