#include <bits/stdc++.h>

#pragma GCC optimize ("-O3")
#pragma GCC optimize ("unroll-loops")
#pragma GCC target ("avx2")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define mp make_pair
#define int long long

using namespace std;

template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; };
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; };
typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 2e5;
const int lg = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int brute(int n, int X, vector<int> a, int r) {
    int ans = inf;
    auto p = a;
    sort(all(p));
    do {
        int curr = accumulate(p.begin(), p.begin() + r + 1, 0LL) * X;
        auto a0 = a;
        for(int i = 0; i <= r; i++) {
            if(a[i] == p[i]) {
                continue;
            }
            pair<int, int> best = {inf, 0};
            for(int j = i + 1; j < n; j++) {
                if(a[j] == p[i]) {
                    umin(best, mp(abs(j - i), j));
                }
            }
            int j = best.s;
            while(j > i) {
                curr += a[j] + a[j - 1];
                swap(a[j], a[j - 1]);
                j--;
            }
        }
        a = a0;
//        for(auto i : p) {
//            cout << i << " ";
//        }
//        cout << ": " << curr << endl;
        umin(ans, curr);
    }
    while(next_permutation(all(p)));
    return ans;
}

void solve() {
    int n, q, X;
    cin >> n >> q >> X;
    vector<int> a(n);
    for(auto &i : a) {
        cin >> i;
    }
    if(q == 1) {
        int r;
        cin >> r;
        if(r == n) {
            cout << accumulate(all(a), 0LL) * X << '\n';
            return;
        }
        r--;
        cout << brute(n, X, a, r) << endl;
        return;
        int ans = 0;
        while(true) {
            array<int, 3> best = {inf, 0, 0};
            for(int i = r + 1; i < n; i++) {
                for(int idx = 0; idx <= r; idx++) {
                    int sum = 0;
                    for(int j = idx + 1; j < i; j++) {
                        sum += a[j];
                    }
                    int d = sum + (r - idx) * a[idx] + (i - r - 1) * a[i] + a[i] + a[idx] + a[i] * X - a[idx] * X;
                    umin(best, {d, idx, i});
                }
            }
            if(best[0] >= 0) {
                break;
            }
//            for(auto i : a) {
//                cout << i << " ";
//            }
//            cout << ": " << ans << endl;
            int idx = best[1];
            int i = best[2];
            for(int j = idx + 1; j <= r; j++) {
                swap(a[j], a[j - 1]);
                ans += a[j] + a[j - 1];
            }
            for(int j = i - 1; j > r; j--) {
                swap(a[j], a[j + 1]);
                ans += a[j] + a[j + 1];
            }
            swap(a[r], a[r + 1]);
            ans += a[r] + a[r + 1];
        }
//        for(auto i : a) {
//            cout << i << " ";
//        }
//        cout << endl;
        for(int i = 0; i <= r; i++) {
            ans += X * a[i];
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    int ttt0 = ttt;
    while(ttt--) {
        solve();
    }
}
