#include <bits/stdc++.h>

#pragma GCC optimize ("-O3")
#pragma GCC optimize ("unroll-loops")
#pragma GCC target ("avx2")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define mp make_pair
#define int long long

using namespace std;

template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; };
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; };
typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 2e5;
const int lg = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> l(n), r(n);
    for(int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    vector<int> dp(k + 1, inf);
    vector<int> ndp(k + 1, inf);
    dp[0] = 0;
    for(int i = 0; i < n; i++) {
        for(int j = 1; j <= k; j++) {
            ndp[j] = dp[j - 1];
            for(int p = 0; p < i; p++) {
                umin(ndp[j], dp[j] + abs(r[p] - l[i]));
            }
        }
        dp = ndp;
        fill(all(ndp), inf);
    }
    cout << *min_element(all(dp)) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    int ttt0 = ttt;
    while(ttt--) {
        solve();
    }
}
