#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll INF = 1e18;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll n, q, A;
    cin >> n >> q >> A;
    vector<ll> vs(n);
    for (ll &x : vs) {
        cin >> x;
    }
    vector<ll> pre(n + 1);
    for (int i = 1; i <= n; i++) {
        pre[i] = pre[i - 1] + vs[i - 1];
    }
    vector<ll> valL(n);
    for (int qi = 0; qi < q; qi++) {
        ll r;
        cin >> r;
        vector<ll> valL;
        for (ll i = 0; i < r; i++) {
            valL.push_back(vs[i] * (r - i - A) + pre[r] - pre[i + 1]);
        }
        vector<ll> valR;
        for (ll i = r; i < n; i++) {
            valR.push_back(vs[i] * (i - r + 1 + A) + pre[i] - pre[r]);
        }
        sort(valL.begin(), valL.end());
        sort(valR.begin(), valR.end());
        int sz = min(valL.size(), valR.size());
        ll sum = 0;
        ll res = 0;
        for (int i = 0; i < sz; i++) {
            sum += valL[i] + valR[i];
            res = min(res, sum);
        }
        cout << res + (pre[r] * A) << "\n";
    }

    return 0;
}