// string.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
using namespace std;
#include<vector>
#include <cmath>

#include <algorithm>
#define vll vector<ll>
#define ll long long

const int siz = 1e6+1;
vll v(siz);
int n;
const ll inf = 1e18;
vll s(siz);
#define pll pair<ll,ll>
bool comp(int i, int j) {
    return v[i] < v[j];
}
int main()
{
    ll q, a;
    cin >> n >> q >> a;
    for (int i = 0; i < n; i++) {
        int ai;
        cin >> ai;
        v[i+1] = ai;
    }
    for (int i = 1; i <= n; i++) {
        s[i] = s[i - 1] + v[i];
    }
    vector<pll> f(n);
    for (int i = 1; i <= n; i++) {
        f[i - 1] = { s[i - 1] + v[i] * (a + i - 1),i-1 };
    }

    vll ans(n+1);
    for (int i = 1; i <= n; i++) {
        random_shuffle(f.begin(), f.end());
        sort(f.begin(), f.end());
        ll sum = 0;
        for (int j = 0; j < i; j++) {
            sum += f[j].first;
        }
        for (int j = 0; j < n; j++) {
            f[j].first -= v[f[j].second + 1];
        }
        ans[i] = sum;
    }
    for (int i = 0; i < q; i++) {
        int r;
        cin >> r;
        cout << ans[r] << "\n";
    }
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
