#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<pii> vp;

const ll inf = 1e18 + 9;
vp orginal;
map<pii,int> locateg;

inline ll range(int s, int e, vp &arr) {
	ll ans = 0;
	for (int i = s; i <= e; i++) {
		ans += arr[i].first;
	}
	return ans;
}


inline int find(int s,int x, vp &arr) {
	for (int i = s; i < arr.size(); i++) {
		if (arr[i].first == x)return i;
	}
	return -1;
}
inline ll cost(vp &order, int r) {
	ll ans = 0;
	vp arr = orginal;
	map<pii, int> locate = locateg;

	for (int i = 0; i < order.size(); i++) {
		int n = abs(find(i,order[i].first,arr) - i);
		ll curr = range(i, find(i,order[i].first, arr) - 1, arr) + n * order[i].first;
		ans += curr;

		for (int j = locate[order[i]] - 1; j >= 0; j--) {
			locate[{arr[j].first, arr[j].second}]++;
			arr[j + 1] = arr[j];
			
		}
		arr[i] = order[i];
		locate[order[i]] = i;
	}
	return ans;
}

inline ll calc(vp &order, int r, int a) {
	ll ans = 0;
	for (int i = 0; i <= r; i++) {
		ans += order[i].first;
	}
	ans *= a;
	ans += cost(order,r);
	return ans;
}

#include <random>
#include <chrono>
#include <ctime>
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

ll solve(int r, int a) {
	vp order = orginal;
	ll ans = 0;
	for (int i = 0; i <= r; i++) {
		ans += orginal[i].first;
		//order[i] = { orginal[i],i };
	}
	ans *= a;


	sort(order.begin(), order.end());


	
	do
	{
		ll curr = calc(order, r, a);
		ans = min(ans, curr);
	} while (next_permutation(order.begin(), order.end()));
	
	return ans;
}



int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, q, a;
	cin >> n >> q >> a;
	orginal.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> orginal[i].first;
		orginal[i].second = i;
		locateg[{orginal[i].first,i}] = i;
	}
	int r;
	for (int i = 0; i < q; i++) {
		cin >> r;
		r--;
		ll ans = solve(r, a);
		cout << ans << endl;
	}

	return 0;
}