#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<pii> vp;

const ll inf = 1e18 + 9;

vp queries;
multiset<int> keep;
ll cost(int k, int q, ll c) {
	if (q == queries.size())return c;
	ll ans = inf;
	set<int> s;

	auto it = keep.begin();
	vi locate(k);
	for (int i = 0; i < k; i++) {
		locate[i] = *it;
		it++;
	}

	for (int i = 0; i < k; i++) {
		if (s.find(locate[i]) != s.end())continue;
		s.insert(locate[i]);

		ll dist = abs(locate[i] - queries[q].first);
		if (locate[i] == -1)dist = 0;
		ll last = locate[i];
		keep.erase(keep.find(locate[i]));
		keep.insert(queries[q].second);

		ll m = cost(k, q + 1, c + dist);

		keep.erase(keep.find(queries[q].second));
		keep.insert(last);

		ans = min(ans, m);
		
	}

	return ans;
}


int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, k;
	cin >> n >> k;
	queries.resize(n + 1);
	vi locate(k, -1);
	for (int i = 0; i < n; i++) {
		cin >> queries[i + 1].first >> queries[i + 1].second;
	}

	for (int i = 0; i < k; i++) {
		keep.insert(-1);
	}

	ll ans = cost(k,1,0);

	cout << ans;

	return 0;
}