#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<pii> vp;

const ll inf = 1e18 + 9;

vp queries;
//multiset<int> keep;
set<pii> keep;


void update1(int locate, int amount, int q) {
	keep.erase(keep.find({ locate,amount }));
	if (amount - 1 > 0)keep.insert({ locate,amount - 1 });

	auto it = keep.lower_bound({ queries[q].second,-1 });
	if (it!=keep.end() && ((pii)*it).first== queries[q].second){
		int lasta = ((pii)*it).second;
		keep.erase(it);
		keep.insert({ queries[q].second , lasta + 1 });
	}
	else {
		keep.insert({ queries[q].second , 1 });
	}
}


void update2(int locate, int amount, int q) {

	auto it = keep.lower_bound({ queries[q].second,-1 });
	pii curr = *it;
	if (curr.second == 1)keep.erase(it);
	else
	{
		keep.erase(it);
		keep.insert({ curr.first,curr.second - 1 });
	}

	it = keep.lower_bound({ locate,-1 });
	if (it != keep.end() && ((pii)*it).first == locate) {
		int lasta = ((pii)*it).second;
		keep.erase(it);
		keep.insert({ locate , lasta + 1 });
	}
	else {
		keep.insert({ locate , 1 });
	}
}

ll cost(int k, int q, ll c) {
	if (q == queries.size())return c;
	ll ans = inf;

	auto it = keep.begin();
	vi locate(keep.size());
	vi amount(keep.size());
	for (int i = 0; i < keep.size(); i++) {
		pii curr = *it;
		locate[i] = curr.first;
		amount[i] = curr.second;
		it++;
	}

	for (int i = 0; i < locate.size(); i++) {

		ll dist = abs(locate[i] - queries[q].first);
		if (locate[i] == -1)dist = 0;
		
		update1(locate[i], amount[i], q);
		ll m = cost(k, q + 1, c + dist);

		update2(locate[i], amount[i], q);

		ans = min(ans, m);
	
	}

	return ans;
}


int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, k;
	cin >> n >> k;
	queries.resize(n + 1);
	vi locate(k, -1);
	for (int i = 0; i < n; i++) {
		cin >> queries[i + 1].first >> queries[i + 1].second;
	}

	keep.insert({ -1,k });


	ll ans = cost(k,1,0);

	cout << ans;

	return 0;
}