#include <iostream>
#include <vector>
using namespace std;
typedef long long ll;
typedef vector<int> vi;
const ll INF = 1e18;

ll func(vi& v, int N, ll A, int R, int x)
{
	ll ans = 0;
	vector<bool> on(N, false);
	int cnt = 0;
	for (int i = 0; x > 0; i++, x /= 2)
		on[i] = x % 2, cnt += x % 2;
	if (cnt != R)
		return INF;
	for (int i = 0; i < N; i++)
		if (on[i])
		{
			for (int j = 0; j < i; j++)
				if (!on[j])
					ans += v[i] + v[j];
			ans += v[i] * A;
		}
	return ans;
}

int main()
{
	int N, Q, R;
	ll A;
	cin >> N >> Q >> A;
	vi v(N);
	for (int i = 0; i < N; i++)
		cin >> v[i];
	cin >> R;
	ll mn = INF;
	for (int i = 0; i < (1 << N); i++)
		mn = min(mn, func(v, N, A, R, i));
	cout << mn;
}