#include <iostream>
#include <iomanip>

#define double long double

using namespace std;

const int NMAX = 1000;
const double EPS = 1e-8;

double p;
double ans;
int n;

void bkt(int l, int r, double prob){
    if(prob < EPS)
        return;

    if(l == n && r == n)
        ans += prob;

    bkt(l + 1, r, prob * p, prob);
    if(r > 0)
        bkt(l - 1, r, prob * p, prob);

    bkt(l, r + 1, prob * (1 - p), prob);
        if(l > 0)
            bkt(l, r - 1, prob * (1 - p), prob);
}

/*
double dp[NMAX + 1][NMAX + 1];

double Dp(int l, int r, int depth){
    if(depth > 8)
        return 0;

    if(dp[l][r] > 0){
        cout << ">> " << l << ' ' << r << endl;
        return dp[l][r];
    }

    dp[l][r] += Dp(l + 1, r, depth + 1) * p;
    if(l > 0)
        dp[l][r] += Dp(l - 1, r, depth + 1) * p;

    dp[l][r] += Dp(l, r + 1, depth + 1) * (1 - p);
    if(r > 0)
        dp[l][r] += Dp(l, r - 1,depth + 1) * (1 - p);
}*/

int main(){

    int l, r;
    cin >> p >> n >> l >> r;

    //dp[l][r] = 1;

    bkt(l, r, 1);

    cout << fixed << setprecision(12) << Dp(n, n, 1);

    return 0;
}
