#include <bits/stdc++.h>

using namespace std;
const int MN = 1e6 + 71;
using ll = long long;
using ii = pair<ll, ll>;
ll n, q, a, r;
ll V[MN], S[MN];
ll Cost[MN];

struct drepte {
    int len;
    ii Val[MN];
    void add(ii dr) {
        Val[++len] = dr; 
    }
    void remove(ii dr) {
        for(int i = 1; i <= len; ++i) {
            if(Val[i] == dr) {
                swap(Val[i], Val[i + 1]);
            }
        }
        --len;
    }
    inline ll eval(int i, int timp) {
        return Val[i].first * timp + Val[i].second;
    }
    void heaten(int timp) {
        for(int i = 2; i <= len; ++i) {
            int j = i;
            while(j > 1) {
                if(eval(j, timp) < eval(j - 1, timp)) {
                    swap(Val[j], Val[j - 1]);
                    --j;
                }
                else break;
            }
            
        }
        
    }
} st, dr;

ll Rez[MN];

void solve() {
    for(int i = 1; i <= n; ++i) {
        dr.add({-V[i], S[i - 1] + i * V[i] + a * V[i]});
    }
    for(int i = 1; i <= n; ++i) {
        st.add({V[i], -S[i] + (1 - i) * V[i] - a * V[i]});
        dr.remove({-V[i], S[i - 1] + i * V[i] + a * V[i]});
        Rez[i] = S[i] * a;
        st.heaten(i);
        dr.heaten(i);
        for(int j = 1; j <= min((long long)(i), n - i); ++j) {
            ll d1, d2;
            //printf("i=%d j=%d d1=%d d2=%d\n", i, j, d1, d2);
            d1 = st.eval(j, i);
            d2 = dr.eval(j, i); 
            if(d1 + d2 >= 0) break;
            Rez[i] += d1 + d2;
        }
    }
}

int main() {
    cin >> n >> q >> a;
    for(int i = 1; i <= n; ++i) {
        cin >> V[i];
        S[i] = S[i - 1] + V[i];
    }
    solve();
    for(int i = 1; i <= q; ++i) {
        int v;
        cin >> v;
        cout << Rez[v] << "\n";
    }

//    cin >> r;
//    for(int i = 1; i <= r; ++i) {
//        Cost[i] = r * V[i] - S[i] + (- i + 1) * V[i] - a * V[i];
//    }
//    for(int i = r + 1; i <= n; ++i) {
//        Cost[i] = -r * V[i] + S[i - 1] + i * V[i] + a * V[i];
//    }
//    sort(Cost + 1, Cost + r + 1);
//    sort(Cost + r + 1, Cost + n + 1);
//    ll re = S[r] * a;
//    for(int i = 1; i <= r; ++i) {
//        int j = r + i;
//        if(j > n) break;
//        if(Cost[i] + Cost[j] >= 0) break;
//        re += Cost[i] + Cost[j];
//    }
//    cout << re << "\n";
    return 0;
}
