#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi,fma")

using namespace std;
const int MN = 5e4 + 71;
using ll = long long;
using ii = pair<ll, ll>;
using iii = pair<ll, ii>;
int n, q, a, r;
int V[MN];
ll S[MN];

namespace drdr{
    int len;
    iii Val[MN];
    void add(iii dr) {
        Val[++len] = dr; 
    }
    inline ll eval(int i, int timp) {
        return Val[i].second.first * timp + Val[i].second.second;
    }
    void heaten(int timp) {
        for(int i = 2; i <= len; ++i) {
            int j = i;
            while(j > 1 && eval(j, timp) < eval(j - 1, timp)) {
                swap(Val[j], Val[j - 1]);
                --j;
            }
        }
    }
}

ll Rez[MN];
bool Int[MN];

void solve() {
    for(int i = 1; i <= n; ++i)
        drdr::add({i, {-V[i], S[i - 1] + 1ll * i * V[i] + 1ll * a * V[i]}});
    for(int i = 1; i <= n; ++i) {
        if(Int[i]) {
            Rez[i] = S[i] * a;
            drdr::heaten(i);
            int p1 = 1, p2 = n;
            /// cele mai mici sunt pentru dreapta, cele mai mari pt stanga
            while(1) {
                while(drdr::Val[p1].first <= i) ++p1;
                while(drdr::Val[p2].first > i) --p2;
                if(p1 <= n && p2 > 0) {
                    ll de = drdr::eval(p1, i) - drdr::eval(p2, i);
                    if(de >= 0) break;
                    Rez[i] += de;    
                    ++p1;
                    --p2;
                }
                else break;
            }
        }
    }
}
int Q[MN];
int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin >> n >> q >> a;
    for(int i = 1; i <= n; ++i) {
        cin >> V[i];
        S[i] = S[i - 1] + V[i];
    }
    for(int i = 1; i <= q; ++i) {
        cin >> Q[i];
        Int[Q[i]] = 1;
    }
    solve();
    for(int i = 1; i <= q; ++i) {
        cout << Rez[Q[i]] << "\n";
    }
//    cin >> r;
//    for(int i = 1; i <= r; ++i) {
//        Cost[i] = r * V[i] - S[i - 1] + (- i) * V[i] - a * V[i];
//    }
//    for(int i = r + 1; i <= n; ++i) {
//        Cost[i] = -r * V[i] + S[i - 1] + i * V[i] + a * V[i];
//    }
//    sort(Cost + 1, Cost + r + 1);
//    sort(Cost + r + 1, Cost + n + 1);
//    ll re = S[r] * a;
//    for(int i = 1; i <= r; ++i) {
//        int j = r + i;
//        if(j > n) break;
//        if(Cost[i] + Cost[j] >= 0) break;
//        re += Cost[i] + Cost[j];
//    }
//    cout << re << "\n";
    return 0;
}
