#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = (int) 1e6 + 7;
const ll INF = (ll) 1e18 + 7;
int n;
int q;
ll coef;
ll a[N];
ll s[N];
ll sol[N];
int ord[N];

void algosort(int k)
{
    while (1)
    {
        bool change = 0;
        for (int i = 1; i < n; i++)
        {
            ll x = a[ord[i]] * (coef + ord[i] - k) + s[ord[i] - 1];
            ll y = a[ord[i + 1]] * (coef + ord[i + 1] - k) + s[ord[i + 1] - 1];
            if (y < x)
            {
                swap(ord[i], ord[i + 1]);
                change = 1;
            }
        }
        if (!change)
        {
            break;
        }
    }
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    //freopen ("input.txt", "r", stdin);


    cin >> n >> q >> coef;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        s[i] = s[i - 1] + a[i];
        ord[i] = i;
    }
    if (n > 50000)
    {
        assert(q == 1);
        int k;
        cin >> k;
        vector<ll> guys;
        for (int i = 1; i <= n; i++)
        {
            guys.push_back(a[i] * (coef + i - k) + s[i - 1]);
        }
        sort(guys.begin(), guys.end());
        ll sum = 0;
        for (int j = 0; j < k; j++)
        {
            sum += guys[j];
        }
        cout << sum << "\n";
        return 0;
    }
    for (int k = 1; k <= n; k++)
    {
        algosort(k);
        sol[k] = 0;
        for (int i = 1; i <= k; i++)
        {
            sol[k] += a[ord[i]] * (coef + ord[i] - k) + s[ord[i] - 1];
        }

    }
    for (int iq = 1; iq <= q; iq++)
    {
        int k;
        cin >> k;
        cout << sol[k] << "\n";
    }


    return 0;
}
