#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int N = 50000 + 7;
const ll INF = (ll) 1e18 + 7;
int n;
int q;
ll coef;
ll sol[N];

struct T
{
    ll a;
    ll s;
    ll eval(int k)
    {
        return s - a * k;
    }
};

T ord[N];

void algosort(int k)
{
    for (int i = 2; i <= n; i++)
    {
        int j = i;
        while (j >= 2 && ord[j - 1].eval(k) > ord[j].eval(k))
        {
            swap(ord[j], ord[j - 1]);
            j--;
        }
    }
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    //freopen ("input.txt", "r", stdin);


    cin >> n >> q >> coef;
    ll cs = 0;
    ll as = 0;
    for (int i = 1; i <= n; i++)
    {
        cin >> as;
        ord[i] = {as, cs + as * (i + coef)};
        cs += as;
    }
    for (int k = 1; k <= n; k++)
    {
        algosort(k);
        sol[k] = 0;
        for (int i = 1; i <= k; i++)
        {
            sol[k] += ord[i].eval(k);
        }
    }
    for (int iq = 1; iq <= q; iq++)
    {
        int k;
        cin >> k;
        cout << sol[k] << "\n";
    }


    return 0;
}
