#include <bits/stdc++.h>
using namespace std;

mt19937 gen(time(0));

int n, k;
vector<pair<int, int>> l;
vector<int> tata;
long long sol, bestSol;

void improve(int i, int j){
	if(max(tata[i], tata[j])>min(i, j)) return;
	int costi, costj, costi2, costj2;
	if(tata[i]==0){
		costi=0, costj2=0;
	}
	else{
		costi=abs(l[tata[i]].second-l[i].first);
		costj2=abs(l[tata[i]].second-l[j].first);
	}
	if(tata[j]==0){
		costi2=0, costj=0;
	}
	else{
		costi2=abs(l[tata[j]].second-l[i].first);
		costj=abs(l[tata[j]].second-l[j].first);
	}
	int x=gen()%100;
	if(x<0||(costi+costj>costi2+costj2)){
		swap(tata[i], tata[j]);
		sol+=1LL*(costi2+costj2)-1LL*(costi+costj);
		if(sol<bestSol){
			bestSol=sol;
		}
	}
}
int main(){
	int start=clock();
	cin>>n>>k;
	l.resize(n+1);
	tata.resize(n+1);
	for(int i=1;i<=n;++i) cin>>l[i].first>>l[i].second;
	bestSol=1LL<<60;
	while((clock()-start)<2.4*CLOCKS_PER_SEC){
		tata[1]=0;
		vector<bool> used(n+1);
		used[1]=1;
		for(int i=2;i<=k;++i){
			int poz=gen()%n+1;
			if(used[poz]) i--;
			else tata[poz]=0, used[poz]=1;
		}
		sol=0;
		for(int i=1;i<=n;++i){
			if(!used[i]) tata[i]=gen()%(i-1)+1; 
			if(tata[i]!=0) sol+=abs(l[tata[i]].second-l[i].first);
			//cout<<tata[i]<<" ";
		}
		//cout<<"\n"<<sol<<"\n";
		bestSol=min(sol, bestSol);
		while((clock()-start)<0.1*CLOCKS_PER_SEC){
			int a=gen()%n+1, b=gen()%n+1;
			improve(a, b);
		}
		sol=0;
		for(int i=1;i<=n;++i){
			if(!used[i]) tata[i]=gen()%(i-1)+1; 
			if(tata[i]!=0) sol+=abs(l[tata[i]].second-l[i].first);
			//cout<<tata[i]<<" ";
		}
		/*
		cout<<"\n"<<sol<<"\n";
		cout<<"_______________\n";
		bestSol=min(sol, bestSol);
		*/
	}
	cout<<bestSol<<"\n";
	return 0;
}


