#include <bits/stdc++.h>
#define int long long

using namespace std;

const int nmax = 1e4;

int n,k;

int l[nmax + 5], r[nmax + 5];

int get_cost(int st, int dr)
{
    return abs(r[st] - l[dr]);
}

pair<int,int> get_greedy(int cost)
{
    int rez = 0, nr = 0;
    for(int i=1;i<=n;i++)
    {
        int Min = cost;
        ++nr;
        bool ok = false;
        for(int j=1;j<i;j++)
        {
            if(get_cost(j,i) < Min)
            {
                Min = get_cost(j,i);
                ok = true;
            }
        }
        nr -= ok;
        rez += Min;
    }
    return {rez,nr};
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    #ifdef HOME
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
    #endif // HOME
    cin>>n>>k;
    for(int i=1;i<=n;i++)
    {
        cin>>l[i]>>r[i];
    }
    int st = 0;
    int dr = 1e9;
    while(st<=dr)
    {
        int mij = (st + dr) >> 1;
        pair<int,int> val = get_greedy(mij);
        if(val.second == k)
        {
            cout<<val.first - k * mij<<'\n';
            return 0;
        }
        if(val.second<=k)
        {
            dr = mij - 1;
        }
        else
        {
            st = mij + 1;
        }
    }
    pair<int,int> val = get_greedy(st);
    cout<<val.first - st * k<<'\n';
    return 0;
}
