#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N_MAX = 5000;
const ll INF = LONG_MAX / 2;

int N, Q, A;
int V[N_MAX + 2];

ll sL[N_MAX + 2], sR[N_MAX + 2];
ll L[N_MAX + 2][N_MAX + 2];
ll R[N_MAX + 2][N_MAX + 2];

ll solve (int X) {
    int Y = X + 1;
    sL[X] = V[X];
    for (int i = X - 1; i >= 1; i--) {
        sL[i] = sL[i + 1] + V[i];
    }
    sR[Y] = V[Y];
    for (int i = Y + 1; i <= N; i++) {
        sR[i] = sR[i - 1] + V[i];
    }
    L[X + 1][0] = 0; L[X + 1][1] = INF;
    for (int i = X; i >= 1; i--) {
        for (int k = 0; k <= X - i + 1; k++) {
            L[i][k] = L[i + 1][k];
            if (k > 0) {
                L[i][k] = min(L[i][k],
                L[i + 1][k - 1] + (ll) V[i] * (X - i + 1 - A) + sL[i + 1]);
            }
        }
        L[i][(X - i + 1) + 1] = INF;
    }
    R[Y - 1][0] = 0; R[Y - 1][1] = INF;
    for (int i = Y; i <= N; i++) {
        for (int k = 0; k <= i - Y + 1; k++) {
            R[i][k] = R[i - 1][k];
            if (k > 0) {
                R[i][k] = min(R[i][k],
                R[i - 1][k - 1] + (ll) V[i] * (i - Y + 1 + A) + sR[i - 1]);
            }
        }
        R[i][(i - Y + 1) + 1] = INF;
    }
    ll answer = 0;
    for (int k = 1; k <= min(X, N - Y + 1); k++) {
        answer = min(answer, L[1][k] + R[N][k]);
    }
    for (int i = 1; i <= X; i++) {
        answer += (ll) V[i] * A;
    }
    return answer;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> N >> Q >> A;
    for (int i = 1; i <= N; i++) {
        cin >> V[i];
    }
    while (Q--) {
        int X;
        cin >> X;
        cout << solve(X) << "\n";
    }

    return 0;
}
