#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N_MAX = 1000000;
const ll INF = LONG_MAX / 2;

int N, Q, A;
int V[N_MAX + 2];

ll sL[N_MAX + 2], sR[N_MAX + 2];
ll coef[N_MAX + 2];

ll solve (int X) {
    int Y = X + 1;
    coef[X] = 0;
    for (int i = X - 1; i >= 1; i--) {
        coef[i] = coef[i + 1] + V[i + 1];
    }
    coef[Y] = 0;
    for (int i = Y + 1; i <= N; i++) {
        coef[i] = coef[i - 1] + V[i - 1];
    }
    for (int i = X; i >= 1; i--) {
        coef[i] += (ll) V[i] * (X - i + 1 - A);
    }
    for (int i = Y; i <= N; i++) {
        coef[i] += (ll) V[i] * (i - Y + 1 + A);
    }
    sort(coef + 1, coef + X + 1);
    sort(coef + Y, coef + N + 1);
    ll answer = 0;
    ll sum = 0;
    for (int k = 1; k <= min(X, N - Y + 1); k++) {
        sum += coef[k] + coef[X + k];
        answer = min(answer, sum);
    }
    for (int i = 1; i <= X; i++) {
        answer += (ll) V[i] * A;
    }
    return answer;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> N >> Q >> A;
    for (int i = 1; i <= N; i++) {
        cin >> V[i];
    }
    while (Q--) {
        int X;
        cin >> X;
        cout << solve(X) << "\n";
    }

    return 0;
}
