#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N_MAX = 1000000;
const ll INF = LONG_MAX / 2;

int N, Q, A;
int V[N_MAX + 2];

ll sL[N_MAX + 2], sR[N_MAX + 2];
ll coef[N_MAX + 2];

int orderL[N_MAX + 2];
int orderR[N_MAX + 2];

ll solve (int X) {
    int Y = X + 1;
    coef[X] = 0;
    for (int i = X - 1; i >= 1; i--) {
        coef[i] = coef[i + 1] + V[i + 1];
    }
    coef[Y] = 0;
    for (int i = Y + 1; i <= N; i++) {
        coef[i] = coef[i - 1] + V[i - 1];
    }
    for (int i = X; i >= 1; i--) {
        coef[i] += (ll) V[i] * (X - i + 1 - A);
    }
    for (int i = Y; i <= N; i++) {
        coef[i] += (ll) V[i] * (i - Y + 1 + A);
    }
//    iota(order + 1, order + X + 1, 1);
//    sort(order + 1, order + X + 1, [&] (const int &i, const int &j) {
//        return coef[i] < coef[j];
//    });
//    for (int i = 1; i <= X; i++) {
//        cout << order[i] << " ";
//    }
//    cout << "\n";
    ll answer = 0;
    ll sum = 0;
    int l = 0, r = min(X, N - Y + 1);
    while (l < r) {
        int mid = (l + r + 1) / 2;
        nth_element(coef + 1, coef + mid, coef + X + 1);
        nth_element(coef + Y, coef + Y + mid - 1, coef + N);
        ll x = coef[mid], y = coef[Y + mid - 1];
        if (x + y < 0) {
            l = mid;
        } else {
            r = mid - 1;
        }
    }
    if (l > 0) {
        nth_element(coef + 1, coef + l, coef + X + 1);
        nth_element(coef + Y, coef + Y + l - 1, coef + N);
        ll x = coef[l], y = coef[Y + l - 1];
        int k = l;
        for (int i = 1; i <= X && k > 0; i++) {
            if (coef[i] < x) {
                answer += coef[i]; k--;
            }
        }
        answer += x * k;
        k = l;
        for (int i = Y; i <= N && k > 0; i++) {
            if (coef[i] < y) {
                answer += coef[i]; k--;
            }
        }
        answer += y * k;
    }
    for (int i = 1; i <= X; i++) {
        answer += (ll) V[i] * A;
    }
    return answer;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> N >> Q >> A;
    for (int i = 1; i <= N; i++) {
        cin >> V[i];
    }
    while (Q--) {
        int X;
        cin >> X;
        cout << solve(X) << "\n";
    }

    return 0;
}
