#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

#define int long long
int n, i, j, q, a, v[50010], c[50010], s[50010], permc[50100], r, lastr;
int diff, ldiff, initcost, cnt;
vector<int> bucket[37010];

void bucketSort(int a, int b)
{
    int aux = (1 << 10) - 1;
    for (int i = b; i >= a; i--)
        bucket[((c[i]>>4)&aux)].push_back(c[i]);
    int k = a;
    for (int i = 0; i <= aux; i++) {
        while (!bucket[i].empty()) {
            c[k++] = bucket[i].back();
            bucket[i].pop_back();
        }
    }
    for (int i = b; i >= a; i--)
        bucket[((c[i]>>14)&aux)].push_back(c[i]);
    k = a;
    for (int i = 0; i <= aux; i++) {
        while (!bucket[i].empty()) {
            c[k++] = bucket[i].back();
            bucket[i].pop_back();
        }
    }
}

#undef int

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> q >> a;
    for (i = 1; i <= n; i++) {
        cin >> v[i];
        s[i] = s[i-1] + v[i];
        permc[i] = v[i] * a + s[i-1] + i*v[i];
    }
    for (cnt = 1; cnt <= q; cnt++) {
        cin >> r;
        for (i = 1; i <= n; i++)
            c[i] = permc[i] - r * v[i];
        lastr = r;
        if (q > 1) {
            bucketSort(1, r);
            bucketSort(r+1, n);
        }
        else {
            sort(c+1, c+r+1);
            sort(c+r+1, c+n+1);
        }
        initcost = s[r] * a;
        i = r;
        j = r+1;
        diff = 0;
        ldiff = 0;
        while (i >= 1 && j <= n) {
            diff = diff + c[j] - c[i];
            i--;
            j++;
            if (diff > ldiff) {
                i = 0;
                j = n+1;
            }
            else
                ldiff = diff;
        }
        cout << initcost+ldiff << '\n';
    }
    return 0;
}
