#include <iostream>

int n, k;
int l[23];
int r[23];

int get_distance(int a, int b) {
    if(a == -1 || b == -1)
        return 0;
    return std::abs(a - b);
}

int get(int* lifts, int curr) {
    if(curr == n)
        return 0;

    int result = INT32_MAX;
    for(int i = 0; i < k; i++) {
        int save = lifts[i];
        int penalty = get_distance(lifts[i], l[i]);
        lifts[i] = r[i];
        int best = get(lifts, curr + 1) + penalty;
        result = std::min(result, best);
        lifts[i] = save;
    }
    return result;
}

int main() {
    std::cin >> n >> k;
    for(int i = 0; i < n; i++)
        std::cin >> l[i] >> r[i];

    int lifts[23];
    for(int& lift : lifts)
        lift = -1;

    std::cout << get(lifts, 0) << std::endl;

    return 0;
}