#include <stdio.h>
#include <math.h>
#include <vector>
using namespace std;

bool nadstropje[1000000001];
vector<pair<int, int> > v;



int izracunaj(int i, int k) {
	if (i>=v.size()) return 0;
	if (v.size()-i == k) return 0;
	
	int izhod1=1000000000;
	nadstropje[v[i].second] = true;
	if (k>0) izhod1 = izracunaj(i+1, k-1);
	for (int j=1; j+v[i].first<1000000000 && j<izhod1; j++) {
		if (nadstropje[j+v[i].first]) {
			nadstropje[j+v[i].first] = false;
			izhod1 = min(izhod1, izracunaj(i+1, k) + j);
			nadstropje[j+v[i].first] = true;
		}
	}
	for (int j=1; v[i].first-j>=0 && j<izhod1; j++) {
		if (nadstropje[v[i].first-j]) {
			nadstropje[v[i].first-j] = false;
			izhod1 = min(izhod1, izracunaj(i+1, k) + j);
			nadstropje[v[i].first-j] = true;
		}
	}
	return izhod1;
}

int main() {
	int n, k, i, j, a, b;
	
	scanf("%d %d", &n, &k);
	
	for (i=0; i<1000000001; i++) nadstropje[i] = false;
	
	for (i=0; i<n; i++) {
		scanf("%d %d", &a, &b);
		v.push_back(make_pair(a, b));
	}
	
	printf("%d\n", izracunaj(0, k));
	
	return 0;
}
