#include <iostream>
#include <vector>
#include <climits>

using namespace std;

vector<vector<int>> mem;

int calculate(int n, int a, int r, vector<int> &v, int i, int x, int c) {
	// cout << i << " " << x << endl;
	
	/* if (mem[i][x] != -1) return mem[i][x]; */
	
	// If i == n-1 => Calculate costs
	if (i == n-1) {
		// Go again from start
		int cc1 = INT_MAX;
		if (x < 2) cc1 = calculate(n, a, r, v, 0, x+1, c);
		
		// Finish here
		int cc2 = 0;
		// cout << "V: ";
		for (int j=0; j<r; j++) {
			cc2 += v[j];
			// cout << v[j] << " ";
		}
		cc2 *= a;
		cc2 += c;
		// cout << "\tC: " << c + cc << endl;
		return /*mem[i][x] =*/ min(cc1, cc2);
	}
	
	// Don't swap it => i++, c same
	int c1 = calculate(n, a, r, v, i+1, x, c);
	
	// Swap i-th with (i+1)-th => i++, cost += v_i+v_(i+1)
	swap(v[i], v[i+1]);
	int c2 = calculate(n, a, r, v, i+1, x, c + v[i] + v[i+1]);
	swap(v[i], v[i+1]);
	
	return /*mem[i][x] =*/ min(c1, c2);
}

int main() {
	int n, q, a;
	cin >> n >> q >> a;
	
	mem = vector<vector<int>>(n, vector<int>(n, -1));
	
	vector<int> v(n);
	for (int i=0; i<n; i++) cin >> v[i];
	
	for (int i=0; i<q; i++) {
		int r; cin >> r;
		vector<int> v2(v);
		cout << calculate(n, a, r, v2, 0, 0, 0) << "\n";
	}
}

