#include <iostream>
#include <utility>
#include <vector>
#include <cstdlib>
#include <cstring>
#include <algorithm>



std::vector<std::pair<int, int>> connections;


struct w {
    int first;
    int second;
    bool operator<(const w a) {
        return first < a.first;
    }
};
std::vector<w> floorCons;
int n,k;

int main(void) {
    std::cin >> n >> k;
    for(int x = 0; x < n; x++) {
        std::pair<int,int> tmp;
        std::cin >> tmp.first >> tmp.second;
        connections.push_back(tmp);
    }
    
    int con = 0;
    for(int x = 1; x < n; x++) {
        floorCons.push_back({std::abs(connections[x-1].second - connections[x].first), x});
    }
    std::sort(floorCons.begin(), floorCons.end());
    //search for MST until N trees
    int min = 0;
    int trees = n;
    int conn = 0;
    while(trees != k) {
        //use connection in MST
        min += floorCons[conn].first;
        conn++;
        trees--;
    }
    std::cout << min << std::endl;
}