#include <bits/stdc++.h>

using namespace std;

#define int long long
#define mp make_pair
#define pb push_back

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

constexpr int N = (int)1e6+11;
constexpr int INF = (int)1e18+11;

void solve(){
    int n,Q,A;
    cin >> n >> Q >> A;
    int a[n+1];
    int pref[n+1];
    memset(pref,0,sizeof pref);
    for(int i = 1; i <= n; i++){
        cin >> a[i];
        pref[i] = pref[i-1] + a[i];
    }
    vector<pair<int,int>> order;
    for(int i = 1; i <= n; i++){
        order.pb(mp(-a[i],-(pref[i-1]+a[i]*(i+A))));
    }
    sort(order.begin(),order.end());
    for(auto&[x,y] : order)
        y = -y;
    int ans[n+1];
    memset(ans,0,sizeof ans);
    for(int i = 1; i <= n; i++){
        multiset<int> st;
        int sum = 0;
        for(auto&[k,b] : order){
            int cur = k*i + b;
            if(st.size() < i){
                st.insert(cur);
                sum += cur;
            } else if(*(--st.end()) > cur){
                sum -= *(--st.end());
                st.erase(--st.end());
                sum += cur;
                st.insert(cur);
            }
        }
        ans[i] = sum;
    }
    while(Q--){
        int R;
        cin >> R;
        cout << ans[R] << "\n";
    }
}

signed main(){
    ios::sync_with_stdio(false); cin.tie(nullptr);cout.tie(nullptr);
    int tests = 1;
//    cin >> tests;
    for(int test = 1; test <= tests; test++){
        solve();
    }
    return 0;
}
