#include <bits/stdc++.h>

using namespace std;

#define int long long
#define mp make_pair
#define pb push_back

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

constexpr int N = (int)1e6+11;
constexpr int INF = (long long)1e18+11;

int intersection(int k1,int b1,int k2,int b2){
    if(k1 == k2)
        return INF;
    return (b2-b1+k1-k2-1)/(k1-k2);
}

void solve(){
    int n,Q;
    long long A;
    cin >> n >> Q >> A;
    int a[n+1];
    long long pref[n+1];
    memset(pref,0,sizeof pref);
    int k[n+1],b[n+1];
    for(int i = 1; i <= n; i++){
        cin >> a[i];
        k[i] = -a[i], b[i] = pref[i-1] + a[i] * (i+A);
        pref[i] = pref[i-1] + a[i];
    }
    int pos[n+1];
    {
        vector<pair<int,int>> v;
        for(int i = 1; i <= n; i++){
            v.pb(mp(b[i],i));
        }
        sort(v.begin(),v.end());
        for(int i = 0; i < n; i++){
            b[i+1] = v[i].first;
            int id = v[i].second;
            k[i+1] = -a[id];
            pos[i+1] = i+1;
        }
    }
    vector<pair<int,int>> O[n+1];
    {
        for(int i = 1; i <= n; i++){
            for(int j = i+1; j <= n; j++){
                int x = intersection(k[i],b[i],k[j],b[j]);
                if(x > n || x < 0)
                    continue;
                if(k[i] < k[j])
                    O[x].pb(mp(i,j));
                else
                    O[x].pb(mp(j,i));
            }
        }
    }
    int ans[n+1];
    memset(ans,0,sizeof ans);

    for(int it = 1; it <= n; it++){
        for(auto&[i,j] : O[it]){
            swap(k[pos[i]],k[pos[j]]);
            swap(b[pos[i]],b[pos[j]]);
            swap(pos[i],pos[j]);
        }
        for(int i = 1; i <= it; i++){
            ans[it] += k[i] * it + b[i];
        }
    }

    while(Q--){
        int R;
        cin >> R;
        cout << ans[R] << "\n";
    }
}

signed main(){
    ios::sync_with_stdio(false); cin.tie(nullptr);cout.tie(nullptr);
    int tests = 1;
//    cin >> tests;
    for(int test = 1; test <= tests; test++){
        solve();
    }
    return 0;
}
