#include <bits/stdc++.h>

#define ll long long int

using namespace std;

int s(int curv, vector<int> kmindists, int curminsum, int n, int choices, vector< vector< int > >& g) {
    if(curv==n-1) {
        return curminsum;
    }

    int min_sum = 1000000;

    for(int nextv=curv+1; nextv<n; ++nextv) {
        int dist = g[curv][nextv-curv-1];
        // insert into kmindists, cull
        vector<int> nextmindists = kmindists;
        nextmindists.push_back(dist);
        int nextminsum = curminsum + dist;
        sort(nextmindists.begin(), nextmindists.end());
        if(nextmindists.size()>choices) { nextminsum -= nextmindists.back(); nextmindists.pop_back(); }

        int res = s(nextv, nextmindists, nextminsum, n, choices, g);
        if(res<min_sum) min_sum = res;
    }
    return min_sum;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n, k; cin >> n >> k;
    int startf[n];
    int endf[n];
    for(int i=0; i<n; ++i) {
        cin >> startf[i];
        cin >> endf[i];
    }
    if(n-k <= 0) {
        cout << "0\n";
        return 0;
    }

    vector< vector< int > > g(n); // dist (connections from x are to x+1, x+2, ...)
    for(int i=0; i<n-1; ++i) {
        for(int j=i+1; j<n; ++j) {
            int dist = abs(endf[i]-startf[j]);
            g[i].push_back(dist);
        }
    }
    /*for(int i=0; i<n; ++i) {
        for(auto a : g[i]) cout << a << " ";
        cout << "\n";
    }*/

    vector<int> emp;
    cout << s(0, emp, 0, n, n-k, g) << "\n";

    return 0;
}
