#include <bits/stdc++.h>

#define ll long long int

using namespace std;

ll s(int curv, vector<ll> kmindists, ll curminsum, int n, int choices, map< int, vector< pair<int,ll> > > g) {

    if(curv==n-1) return curminsum;

    ll min_sum = 1000000000000000;

    for(int nextv=curv+1; nextv<n; ++nextv) {
        ll dist;
        for(auto p : g[curv]) {
            if(p.first==nextv) {
                dist = p.second;
                break;
            }
        }
        // insert into kmindists, cull
        vector<ll> nextmindists = kmindists;
        nextmindists.push_back(dist);
        ll nextminsum = curminsum + dist;
        sort(nextmindists.begin(), nextmindists.end());
        if(nextmindists.size()>choices) { nextminsum -= nextmindists.back(); nextmindists.pop_back(); }

        map< int, vector< pair<int,ll> > > newg = g;
        newg.erase(curv);
        for(int i=curv+1; i<nextv; ++i) {
            if(newg.find(i) != newg.end()) {
                // try to find connection to nextv
                for(int t=0; t<g[i].size(); ++t) if(g[i][t].first == nextv) newg[i].erase(newg[i].begin()+t);
            }
        }

        ll res = s(curv+1, nextmindists, nextminsum, n, choices, newg);
        if(res<min_sum) min_sum = res;
    }
    return min_sum;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n, k; cin >> n >> k;
    ll startf[n];
    ll endf[n];
    for(int i=0; i<n; ++i) {
        cin >> startf[i];
        cin >> endf[i];
    }
    if(n-k <= 0) {
        cout << "0\n";
        return 0;
    }

    map< int, vector< pair<int,ll> > > g; // name, dist
    for(int i=0; i<n-1; ++i) {
        vector< pair<int,ll> > a;
        for(int j=i+1; j<n; ++j) {
            ll dist = abs(endf[i]-startf[j]);
            a.push_back(make_pair(j, dist));
        }
        g[i] = a;
    }

    vector<ll> emp;
    cout << s(0, emp, 0, n, n-k, g) << "\n";

    return 0;
}
