#include <bits/stdc++.h>

using namespace std;

int main() {
    int n, Q, A; cin >> n >> Q >> A;
    vector<long long> v(n), vPsum(1+n);
    for (int i = 0; i < n; ++i) cin >> v[i], vPsum[i+1] = v[i]+vPsum[i];
    vector<int> R(Q);
    for (int &x : R) cin >> x;

    if (false) {
        for (int q = 0; q < Q; ++q) {
            int r = R[q];
            int mx = min(r, n-r);
            vector<long long> best[2]{};

            // from left
            for (int i = 0; i < r; ++i) {
                int dist = r-1-i;
                long long cost = v[i] * (dist - A + 1) + (vPsum[r] - vPsum[i+1]);
                best[0].push_back(cost);
            }
            sort(best[0].begin(), best[0].end());
            // from right
            for (int i = n-1; i >= r; --i) {
                int dist = i-r;
                long long cost = v[i] * (dist + A + 1) + (vPsum[i] - vPsum[r]);
                best[1].push_back(cost);
            }
            sort(best[1].begin(), best[1].end());

            long long minChange = 0;
            for (int i = 0; i < mx && best[0][i] + best[1][i] < 0; ++i) minChange += best[0][i] + best[1][i];
            long long originalCost = vPsum[r]*A;
            cout << originalCost + minChange << '\n';
        }
    } else {
        // subtask 4 (n^2) with "bubble sort" to avoid extra log n
        vector<pair<long long, int>> cL, cR;
        int r = 0;
        // from left
        for (int i = 0; i < r; ++i) {
            int dist = r-1-i;
            long long cost = v[i] * (dist - A + 1) + (vPsum[r] - vPsum[i+1]);
            cL.emplace_back(cost, i);
        }
        sort(cL.begin(), cL.end());
        // from right
        for (int i = n-1; i >= r; --i) {
            int dist = i-r;
            long long cost = v[i] * (dist + A + 1) + (vPsum[i] - vPsum[r]);
            cR.emplace_back(cost, i);
        }
        sort(cR.begin(), cR.end());

        vector<long long> qAns(1+n);
        for (r = 1; r <= n; ++r) {
            // find r-1 in right and move to left
            int pos = 0;
            while (pos < (int)cR.size() && cR[pos].second != r-1) ++pos;
            if (pos >= (int)cR.size()) cout << "BADDDD" << endl;
            cR.erase(cR.begin() + pos);
            cL.emplace_back(v[r-1] * (-A + 1), r-1);

            // update all costs
            for (pair<long long, int> &pr : cL) {
                if (pr.second != r-1) pr.first += v[pr.second] + v[r-1];
            }
            for (pair<long long, int> &pr : cR) {
                pr.first -= v[pr.second] + v[r-1];
            }

            // bubble sort
            //  n^2, but also n^2 in total over all queries
            //  merge sort would be nlogn, but n^2logn over all queries
            //auto bubbleSort = [](vector<pair<long long, int>> &v) {
            //    int m = v.size();
            //    for (int i = 0; i < m-1; ) {
            //        int j = i;
            //        if (v[])
            //    }
            //};
            //bubbleSort(cL);
            //bubbleSort(cR);
            sort(cL.begin(), cL.end());
            sort(cR.begin(), cR.end());

            long long minChange = 0;
            int mx = min(r, n-r);
            for (int i = 0; i < mx && cL[i].first + cR[i].first < 0; ++i) minChange += cL[i].first + cR[i].first;
            long long originalCost = vPsum[r]*A;
            // cout << originalCost + minChange << '\n';
            qAns[r] = originalCost + minChange;
        }
        for (int r : R) cout << qAns[r] << '\n';
    }
    return 0;
}
