#include <bits/stdc++.h>

using namespace std;

const long long INF = 1e18;

int main() {
    int n, k; cin >> n >> k;
    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) cin >> l[i] >> r[i];
    // bitmasks denote locations of elevators - location = end of passenger path
    int MX = 1 << n;
    vector<long long> minCost(MX, INF); // to get to certain elevator positions
    vector<long long> minCost2(MX, INF);
    minCost[0] = 0;
    long long ans = INF;
    for (int bitmask = 1; bitmask < MX; ++bitmask) {
        if (__builtin_popcount(bitmask) > k) continue;
//        cout << " AT " << bitmask << endl;
        // maximum bit is the last passenger transported
        int i = 0;
        while (1 << (i+1) <= bitmask) ++i;



        minCost2[bitmask] = min(minCost2[bitmask], minCost[bitmask ^ (1 << i)]); // new lift created here
//        cout << "  biggest " << i << endl;
//        cout << "   new elevator: " << minCost[bitmask ^ (1 << i)] << endl;

        for (int j = 0; j < i; ++j) {
            if (bitmask & (1 << j)) continue;
            minCost2[bitmask] = min(minCost2[bitmask], minCost[bitmask ^ (1 << i) ^ (1 << j)] + abs(l[i] - r[j]));
        }
//        cout << "  best " << minCost2[bitmask] << endl;
        if (i == n-1) ans = min(ans, minCost2[bitmask]);

        if (bitmask+1 == (1 << (i+1))) {
            minCost = minCost2;
            minCost2 = vector<long long>(MX, INF);
        }
    }
    cout << ans << endl;
    return 0;
}
